; Umwandlung IBM fat -> QL map                              17.05.91 Jo
; DD / HD

          section   cv

          xdef      cv_friq
          xdef      cv_setmap

          xref      cv_rfat
          xref      cv_d1w
          xref      cv_d1l
          xref      at_stgrp

          include   'keys_iod'
;-          include   'keys_hdr'
          include   'dd_fq_ddlk'
          include   'dd_fq_ql5a'

;+++
; Initialisierung fr Umwandlung IBM fat -> QL map
;
;         a4 c  p   phys def block
;         a5  r     QL map
;
;    status return  always 0
;---
cv_friq
fri.reg   reg       d1-d4/d6/a1/a2
          movem.l   fri.reg,-(sp)
          lea       fdd_map(a4),a5      ; $80(a4)
          lea       flp_gmap(a5),a1     ; $60(a5)
          lea       flp_htop(a5),a2     ; $2480(a5)
          moveq     #-1,d1
fri_nlop
          move.l    d1,(a1)+            ; ..mit $FFFFFFFF vollschreiben
          move.l    d1,(a1)+
          move.l    d1,(a1)+
          move.l    d1,(a1)+
          cmpa.l    a2,a1
            blt.s   fri_nlop

          lea       flp_gmap(a5),a1
          moveq     #0,d1
          moveq     #0,d3
fri_mlop  move.b    #$F8,(a1)+          ; dummy-map $F80000
          move.b    d1,(a1)+
          move.b    d1,(a1)+

          move.w    ibm_clus(a5),d0     ; Erstes Cluster Filebereich
          subq.w    #1,d0               ; 1 gruppe F80000
          bra.s     fri_rdbf
fri_rlop  move.b    d3,(a1)+            ; dummy-dir $00000x
          move.b    d3,(a1)+
          move.b    d1,(a1)+
          addq.w    #1,d1
fri_rdbf  dbf       d0,fri_rlop      ; a1 zeigt jetzt auf 1.Gruppe Filebereich

          move.w    flp_totl(a5),d3     ; alle Sektoren
          sub.w     ibm_file(a5),d3     ; - erster Sektor Filebereich
          divu      flp_allc(a5),d3     ; / gruppengre = Anzahl Eintrge FAT
          moveq     #0,d1               ; Anzahl belegte Eintrge
          moveq     #0,d4               ; Anzahl kaputte Eintrge
          moveq     #2,d2               ; offset 1.Eintrag FAT
          bra.s     fri_ddbf
fri_dlop
          move.w    d2,d0               ; FAT-Eintrag Nr d0
          jsr       cv_rfat(pc)         ; -> d0.w Inhalt
          tst.w     d0                  ; frei ?
            bne.s   fri_fe
          move.b    #$FD,(a1)           ; ..ja
          bra.s     fri_nxt
fri_fe
          cmpi.w    #$0FF7,d0           ; kaputt ?
            bne.s   fri_fc
          move.b    #$FE,(a1)           ; ..ja
          addq.w    #1,d4               ; eine Gruppe weniger frei
          bra.s     fri_nxt
fri_fc
          move.b    #$FC,(a1)           ; ..belegt
          addq.w    #1,d1               ; eine Gruppe weniger frei
fri_nxt
          addq.w    #1,d2               ; nchste FAT-Nr
          addq.l    #3,a1               ; QL-map 3 bytes weiter
fri_ddbf  dbf       d3,fri_dlop

          move.w    flp_allc(a5),d0
          mulu      d0,d1               ; Anzahl Sektoren belegt
          mulu      d0,d4               ; Anzahl Sektoren kaputt
          sub.w     d4,flp_good(a5)     ; Anzahl gute Sektoren
          add.w     d4,d1
          sub.w     d1,flp_free(a5)     ; Anzahl frei verfgbar

          movem.l   (sp)+,fri.reg
          moveq     #0,d0
          rts

;+++
; Setzt dir QL map fr einen File
;
;         d0   r    error / max.Lnge des files
;         d2.w r    new (external) file ID
;         d5  c  p  file position
;         d6  c  p  (sub) dir File-ID
;         a2  c  p  Zeiger auf ibm-direintrag
;         a5  c  p  Zeiger auf QL map
;
;         error return d0.l ERR_FE oder max.Lnge des files
;---
cv_setmap
stm.reg   reg       d1
          movem.l   stm.reg,-(sp)
          moveq     #0,d2               ; alte file ID nicht bekannt
          move.w    $1A(a2),d1          ; erste gruppe ibm
          jsr       cv_d1w(pc)          ; in 68000-syntax
          moveq     #0,d0
          move.w    d1,d0
            beq.s   stm_end             ; keine gruppe da ( ./.. subdir files)
          moveq     #0,d1               ; neue gruppe QL = 0
stm_loop
          jsr       at_stgrp(pc)        ; d0.w fat-nr -> QL-map / d2.w File-ID
            bmi.s   stm_err             ; ..Fehler
          addq.w    #1,d1               ; nchste gruppe QL-file
          bsr.s     cv_rfat             ; d0.w nchste fat-nr ibm -> d0.w
            beq.s   stm_err             ; falls 0, Fehler
          cmpi.w    #$0FF7,d0           ; defekt ?
            beq.s   stm_err
          cmpi.w    #$0FF8,d0           ; letzte gruppe ibm ?
            blt.s   stm_loop            ; ..nein, weiter

          lsl.l     #8,d1               ; * $100
          add.l     d1,d1               ; * $200
          mulu      flp_allc(a5),d1
          move.l    d1,d0               ; max Lnge des files in bytes
stm_end
          movem.l   (sp)+,stm.reg
          rts
stm_err
          moveq     #-$10,d0
          bra.s     stm_end
   end
