; Floppy Disk Allocate Buffer    V2.00    1988   Tony Tebby QJUMP / Jo
; DD / HD

        section at

        xdef    at_albf
        xdef    at_alsec
        xdef    at_alfs

        xref    at_lcbf
        xref    at_lcbf1

        xref    at_figrp
        xref    at_algrp
        xref    at_afgrp

        xref    iou_frsl

        include 'keys_err'
;-        include 'keys_hdr'
        include 'keys_sbt'
        include 'keys_chn'
        include 'keys_qdos_ioa'
        include 'dd_fq_QL5A'

        include 'mac_assert'
;+++
; Floppy Disk ALBF: locates or allocates a slave block for write operations.
; If necessary, it reads the appropriate sector from the disk or extends the
; file allocation.
;
;       d3  r   (word) bytes left in buffer
;       d4  r   block/byte
;       d5 c  p file position
;       d6 c  p drive / file number
;       a0 c  p channel block
;       a2  r   pointer to buffer
;       a3 c  p linkage block
;       a4 c  p definition block
;       a5 c  p pointer to map
;
;       status return standard
;---
at_albf
        cmp.l   chn_feof(a0),d5          ; end of file?
          blt.l at_lcbf                  ; ... no, locate
; make block / byte form
        move.l  d5,d4
          beq.l at_lcbf              ; ..it's new file with iod_hdrl=0, locate
        asl.l   #6,d4
          bvs.s fda_eof                  ; ... oops sign change      short !
        add.l   d4,d4
        lsr.w   #7,d4
          bne.l at_lcbf1                 ; not the start of a new block
;+++
; Floppy Disk ALSEC: allocates a slave block and sector by starting or extending
; the file allocation.
;
;       d3  r   (word) bytes left in buffer
;       d4 c  p block/byte
;       d6 c  p drive / file number
;       a0 c  p channel block
;       a2  r   pointer to buffer
;       a3 c  p linkage block
;       a4 c  p definition block
;       a5 c  p pointer to map
;
;       status return standard
;---
at_alsec
fda.reg reg     a1
;***        movem.l fda.reg,-(sp)
        move.l  a1,-(sp)
        move.w  flp_allc(a5),d3
        cmpi.b  #ioa.kdir,chn_accs(a0)  ; accsess byte = dir ?
          beq.s fda_sfil                ; ..ja
        cmp.w   chn_sdid(a0),d6         ; dir - ID dieses files
          beq.s fda_sfil                ; ..implizit geffnet
        cmpi.w  #1,d6                   ; rootdir ?
          bgt.s fda_rfil                ; ..nein
fda_sfil
        lsl.w   #1,d3                   ; dir: 4 sectoren pro gruppe
fda_rfil
        move.l  d4,d0
        clr.w   d0                       ; sector number
        swap    d0
        divu    d3,d0                    ; sector / group form
        swap    d0
        tst.w   d0
          beq.s fda_alg                  ; first sector of group
        swap    d0
        jsr     at_figrp(pc)             ; find group
        bra.s   fda_sfsb
fda_alg
        swap    d0
        jsr     at_algrp(pc)             ; allocate new group of file
fda_sfsb
          blt.s fda_exit

        jsr     iou_frsl(pc)             ; find new slave block

        assert  0,sbt_phys-1,sbt_phyg-2
        or.l    d0,(a1)+                 ; set physical sector / group
        assert  0,sbt_file-4,sbt_blok-6

        cmp.w   chn_sdid(a0),d6         ; dir - ID dieses files
          beq.s fda_dset                ; ..implizit geffnet
        cmpi.b  #ioa.kdir,chn_accs(a0)  ;
          beq.s fda_dset                ;
        cmpi.w  #1,d6                   ;
          bgt.s fda_nset                ;
fda_dset
        bset    #7,-3(a1)               ; dir Kennung in sbt_phys(a1)
fda_nset
        move.w  d6,(a1)+                 ; set file
        swap    d4
        move.w  d4,(a1)+                 ; and block
        swap    d4

        move.l  #512,d3                  ; bytes left in buffer

fda_ok
        moveq   #0,d0
fda_exit
;***        movem.l (sp)+,fda.reg
        movea.l (sp)+,a1
        rts

fda_eof
        moveq   #err.eof,d0
        bra.s   fda_exit

;+++
; Allocate / re-allocate first sector of new file
;
;       d1 cr   old / new file ID
;       d5 c  p sub-directory position 
;       d6 c  p drive / sub-directory ID
;       a0 c  p channel block
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       status return 0 or err.drfl
;---
at_alfs
;***        movem.l fda.reg,-(sp)
        move.l  a1,-(sp)
        jsr     at_afgrp(pc)             ; allocate first group
          ble.s fda_exit
        jsr     iou_frsl(pc)             ; find new slave block

        assert  0,sbt_phys-1,sbt_phyg-2
        or.l    d0,(a1)+                 ; set physical sector / group
        assert  0,sbt_file-4,sbt_blok-6

        cmp.w   chn_sdid(a0),d6         ; dir - ID dieses files
          beq.s fda_dfil                ; ..implizit geffnet
        cmpi.b  #ioa.kdir,chn_accs(a0)  ; access byte = dir
          beq.s fda_dfil                ;
        cmpi.w  #1,d1                   ; root dir
          bgt.s fda_nfil                ;
fda_dfil
        bset    #7,-3(a1)               ; dir Kennung in sbt_phys(a1)
fda_nfil
        move.w  d1,(a1)+                 ; set file
        clr.w   (a1)+                    ; and block
        bra.s   fda_ok

    end
