; Check ATR-floppy for Open      V2.00    1990   QJUMP   14.12.91 Jo
; DD / HD

        section at

        xdef    at_ckop

        xref    at_ckrw       ; check read write
        xref    at_flsha      ; flush all
        xref    at_ldfat      ; load fat
        xref    at_ldrdr      ; load root dir
        xref    at_alfs       ; allocate first sector
        xref    cv_friq       ; convert fat + root dir Ibm->Ql
        xref    iou_clsl      ; clear slave blocks

        include 'keys_err'
        include 'keys_iod'
;-        include 'keys_hdr'
        include 'keys_chn'
        include 'dd_fq_ddlk'
        include 'dd_fq_QL5A'

;+++
; Check ATR-floppy for open ( _*D not implemented )
;
;       d1      scratch
;       d6 c  p msw drive number
;       a0 c  p channel block
;       a3 c  p pointer to linkage block
;       a4 c  p pointer to physical definition
;       a5      pointer to QL map
;
;       error return 0 ok, or err.mchk
;---
at_ckop
fdc.reg  reg    d3/d4/d5/d6/a1/a2
        cmp.l   fdd_maxd(a3),d6          ; drive in range? fdd_maxd/fdd_maxt
          bgt.s fdc_fdnf                 ; ... no

        moveq   #$ffffffdf,d1            ; check for *D or *d
        and.l   chn_name(a0),d1
        cmp.l   #$00042a44,d1            ; is it?
          bne.s fdc_ckok
fdc_bn
        moveq   #err.inam,d0
fdc_rts
        rts

fdc_fdnf
        moveq   #err.fdnf,d0             ; drive out of range
        bra.s   fdc_rts

fdc_ckok
        move.w  #$0200,iod_sctl(a4)     ;+ 512 bytes/sector
        movea.l fdd_base(a3),a2
        tst.b   iod_drst(a4)             ; OK?
          bge.s fdc_check                ; ... no
        moveq   #0,d0                    ; ... yes, assume OK then
        tst.w   iod_rdid(a4)             ; root directory set?
          beq.s fdc_check                ; ... no, get map
        jsr     at_ckrw(pc)              ; check ok to read or write
;-          ble.s fdc_rts                  ; ... ok, all done
          beq.s fdc_rts                 ; ... ok, all done
          bpl.s fdc_ck1                 ; ..changed, check
        tst.b   fdd_mpty(a3)            ; drive ?
          bne.s fdc_fdnf                 ; .. empty, return
        move.l  d6,d0
        swap    d0                      ; drive nr 1..4
        subq.w  #1,d0                   ; drive bit nr 0..3
        btst    d0,fdd_maxr(a3)         ; do not change mode !
          beq.s fdc_ck1
        bchg    #0,fdd_mode(a4)         ; try other mode
fdc_ck1
        clr.b   iod_drst(a4)             ; status not OK yet
fdc_check
        movem.l fdc.reg,-(sp)
        move.b  chn_drid(a0),d0          ; drive id
        jsr     iou_clsl(pc)             ; clear slave blocks

        jsr     at_ldfat(pc)             ; load fat
          bne.s fdc_mch_                 ; ... oops
        jsr     at_ldrdr(pc)             ; load root dir
fdc_mch_  bne   fdc_mchk                 ; ... pech
        jsr     cv_friq(pc)              ; ConVert Fat + Rootdir Ibm -> Ql
        move.b  #iod.ql5a,iod_ftyp(a4)
; VOL-ID suchen
        lea     fdd_hdir(a4),a2         ; root dir DD/HD..
        lea     fdd.haln(a4),a1         ; ..bis Ende absuchen
        moveq   #$20,d0
fdc_mlop
        tst.b   (a2)                    ; Ende root_dir
          beq.s fdc_nonm
        btst    #3,$0B(a2)              ; file-typ VOL-ID ?
          bne.s fdc_medn                ; ..ja, gefunden
        adda.l  d0,a2                   ; nchster Eintrag
        cmpa.l  a2,a1                   ; root-dir Ende ?
          bgt.s fdc_mlop                ; ..weitersuchen
fdc_nonm
        lea     iod_mnam(a4),a1
        move.l  #'    ',d0
        move.l  d0,(a1)+
        move.l  d0,(a1)+
        move.l  d0,(a1)+
        bra.s   fdc_nam9
fdc_medn
        lea     iod_mnam(a4),a1
        move.l  (a2)+,(a1)+
        move.l  (a2)+,(a1)+
        cmpi.b  #' ',-1(a1)
          bne.s fdc_nspc
        subq.l  #1,a1                    ; ' ' weg
        move.b  (a2)+,(a1)+              ; ..durch 1. Buchstaben EXT ersetzen
fdc_nspc
        move.b  (a2)+,(a1)+              ; Achtung, a2 knnte ungerade sein
        move.b  (a2)+,(a1)+
fdc_nam9
;-        moveq   #9,d0                    ; name is max 10 bytes long
;-fdc_mnam
;-        cmp.b   #' ',-(a1)               ; space at end ?
;-        dbne    d0,fdc_mnam
;-        addq.w  #1,d0
;-        move.w  d0,iod_mnam(a4)          ; length of medium name
; phys.def.block ausfllen

        move.w  #iod.rdid,iod_rdid(a4)     ; root directory ID = 1

        move.l  flp_eodr(a5),d0
        lsl.w   #7,d0
        lsr.l   #7,d0
        move.l  d0,iod_rdln(a4)          ; and length

        moveq   #0,d1
        move.w  flp_allc(a5),d1          ; d1.l = allocation unit
        move.w  d1,d0
        lsl.w   #8,d0
        add.w   d0,d0
        move.w  d0,iod_allc(a4)          ; *512

        moveq   #0,d0
        move.w  flp_good(a5),d0          ; total good
        divu    d1,d0
        move.w  d0,iod_totl+2(a4)

        moveq   #0,d0
        move.w  flp_free(a5),d0          ; total free
        divu    d1,d0
        move.w  d0,iod_free+2(a4)

        moveq   #0,d0
        move.w  flp_totl(a5),d0
        divu    d1,d0                   ; Anzahl Eintrge in QL-map
        mulu    #3,d0                   ; bytes map
        addq.w  #1,d0
        bclr    #0,d0                   ; auf gerade Zahl aufrunden
        add.w   #flp_gmap,d0
;        move.w  #flp_ftop,d1            ; $A00 = 5 Sektoren
        move.w  #flp_htop,d1            ; $2400 = 18 Sektoren
        cmp.w   d1,d0
          ble.s fdc_seto
        move.w  d1,d0                   ; auf flp_htop begrenzen
fdc_seto
        move.w  d0,fdd_mtop+2(a4)       ; eintragen fr at_group

        clr.l   iod_hdrl(a4)             ;+ inbuilt header length = 0
        clr.l   fdd_mupd(a4)             ;+ reset fat update
        clr.l   fdd_mupd+4(a4)
        clr.b   fdd_mupd+8(a4)          ; 9 Sektoren FAT !

        st      iod_drst(a4)             ; map ok now
        moveq   #0,d0
        bra.s   fdc_exmp

fdc_mchk
        moveq   #err.mchk,d0
fdc_exmp
        movem.l (sp)+,fdc.reg
;-fdc_rtd0
;-        tst.l   d0
        rts
        end
