; ATR Floppy disk initialisation  V2.01    1990  Tony Tebby  QJUMP/Jo 26.10.94
; DD / HD, ATR_SEC immer = 2

        section at

        xdef    at_init
        xdef    init_new

        xref    id_flag

        xref    iou_ddst
        xref    iou_ddlk
        xref    iou_flnk

        xref    at_poll
        xref    at_flsha

        xref    at_chek         ; check all slave blocks read
        xref    at_flsh         ; flush all buffers
        xref    fq_info         ; get occupancy information
        xref    fq_load         ; load
        xref    iou_save        ; save
        xref    fq_trnc         ; truncate
        xref    at_lcbf         ; locate buffer
        xref    at_albf         ; locate / allocate buffer
        xref    fq_upbf         ; mark buffer updated
        xref    at_alfs         ; allocate first sector
        xref    at_ckop         ; check medium for open operation
        xref    at_fdrv         ; format drive
        xref    at_rsecp        ; read sector (physical)
        xref    at_wsecp        ; write sector (physical)
; end of standard directory driver entry points
        xref    at_wsecl        ; $A4 write sector (logical)
        xref    ioi_mkdr        ; $AA atr make directory
; iod_jend $B0

        include 'keys_iod'
        include 'keys_karte'       ; aktuelle Karten-Version: 'keys_sandy'
        include 'dd_fq_ddlk'       ; ATR Floppy linkage block
        include 'keys_cv'
        include 'mac_assert'

;+++
; Initialise DD linkage and get device going.
;
;       status return standard
;---
at_init
        assert  fdd_cadr,iod_jend+8      ; = $B8 oder etwa nicht ?

        lea     fq_vect,a3               ; set up dd linkage
        jsr     iou_ddst(pc)

        st      fdd_schk(a3)             ; force check
        st      fdd_drvs(a3)             ; and already stopped

        tas     fdd_slvl(a3)             ; very high bottom of range
        jsr     iou_ddlk(pc)

; FLP0 finden
        move.l  #'FLP0',d7
        jsr     iou_flnk(pc)            ; ddd+$18 -> d1.l, a0
          beq.s ini_found
        moveq   #-$13,d0      ; ERR_NI
        rts
ini_found
        moveq   #$18,d0
        sub.l   d0,d1
        movea.l d1,a0                   ; a0 ist FLP0 ddd
        move.l  a0,fdd_flpl(a3)
        lea     init_new(pc),a1
        move.l  a1,fdd_init(a3)         ; fr Basic-Befehle merken
        movea.l fdd_cadr(a3),a1         ; Liste ATRconv da?
        cmpi.l  #'qiiq',(a1)
          beq.s init_new                ; ..ja

; Zeiger auf id_flag ber ATR_DEV aus Basic-nametable holen
ini.reg reg     a0-a2/a4-a6
        movem.l ini.reg,-(sp)
        moveq   #0,d0   ; MT_INF
        trap    #1
        moveq   #0,d2
        movea.l $0010(a0),a6    ; SV_BASIC
        adda.w  #$0068,a6       ; BV_START a6 wie in Basic blich
        movea.l $0018(a6),a1    ; BV_NTBAS
        movea.l $001C(a6),a2    ; BV_NTP
        movea.l $0020(a6),a5    ; BV_NLBAS
        lea     0(a6,a5.l),a5   ; absolut
ini_name
        cmpi.w  #$0800,0(a6,a1.l)
          beq.s ini_mcproc
ini_nnam
        addq.l  #8,a1           ; nchster Eintrag
        cmpa.l  a2,a1           ; letzter ?
          blt.s ini_name        ; ..nein, weiter
        bra.s   init_exi        ; ..nix gefunden (???)
ini_mcproc
        lea     bas_name(pc),a0 ; gesuchter name 7,'ATR_DEV'
        move.w  2(a6,a1.l),d0   ; Offset-Zeiger in Namelist
        lea     0(a5,d0.w),a4   ; Zeiger auf MC-Name
        move.b  (a0),d2         ; Lnge
cmploop
        cmpm.b  (a0)+,(a4)+
          dbne  d2,cmploop
          bne.s ini_nnam
        move.l  4(a6,a1.l),d0   ; absolutadresse von ATR_DEV-Procedure
          bmi.s ini_nnam        ; ..kopie, weiter
        movea.l d0,a0
        move.w  -2(a0),d0       ; hier steht zeiger auf id_flag
        adda.w  d0,a0           ; ..absolut
        move.l  a0,fdd_cadr(a3)
        adda.w  cv_is0(a0),a0
        move.l  a0,fdd_ibm0(a3)
init_exi
        movem.l (sp)+,ini.reg
;+++
; Aufruf von ATR_DEV (a0) FLP0 -> (a3) ATR0
;---
init_new
;        move.b  fdd_plug(a0),fdd_plug(a3)
        move.b  fdd_prec(a0),fdd_prec(a3)
        assert  fdd_maxd+2,fdd_maxt
        move.l  fdd_maxd(a0),fdd_maxd(a3)
        assert  fdd_defd+1,fdd_sec
        move.b  fdd_defd(a0),fdd_defd(a3)
        st      fdd_sec(a3)             ; immer ATR_SEC = 2
        move.b  fdd_rnup(a0),fdd_rnup(a3)
        move.w  fdd_maxr(a0),fdd_maxr(a3)
        move.l  fdd_step(a0),fdd_step(a3)
        move.l  fdd_base(a0),fdd_base(a3)
        move.l  fdd_time(a0),fdd_time(a3)
        moveq   #0,d0
        rts

bas_name
        dc.b    7,'ATR_DEV'

fq_vect
        dc.l    fdd_aend    ; length of linkage                 $0700
        dc.l    fdd.haln    ; ATR length of physical definition $5080
        dc.w    3,'ATR0'    ; device name (usage)
        dc.w    3,'ATR0'    ; device name (real)

null    dc.w    0           ; external interrupt server
        dc.w    at_poll-*   ; polling server
        dc.w    0           ; scheduler server

        dc.w    0           ; io
        dc.w    0           ; open
        dc.w    0           ; close
        dc.w    at_flsha-*  ; atr forced slaving
        dc.w    0           ; dummy
        dc.w    0           ; dummy
        dc.w    0           ; format

        dc.w    at_chek-*   ; atr check all slave blocks read
        dc.w    at_flsh-*   ; atr flush all buffers
        dc.w    fq_info-*   ; get occupancy information
        dc.w    fq_load-*   ; flp/atr load
        dc.w    iou_save-*  ; save
        dc.w    fq_trnc-*   ; truncate
        dc.w    at_lcbf-*   ; atr locate buffer
        dc.w    at_albf-*   ; atr locate / allocate buffer
        dc.w    fq_upbf-*   ; mark buffer updated
        dc.w    at_alfs-*   ; allocate first sector
        dc.w    at_ckop-*   ; atr check medium for open operation
        dc.w    at_fdrv-*   ; atr format drive
        dc.w    at_rsecp-*  ; read sector
        dc.w    at_wsecp-*  ; write sector
        dc.w    at_wsecl-*  ; write sector (logical position)
        dc.w    ioi_mkdr-*  ; atr make dir                (new)
        dc.w    -1          ; end flag
     end
