; ATR Floppy Disk Locate Buffer    V2.00  1988 Tony Tebby QJUMP / 27.05.91 Jo
; DD / HD

        section at

        xdef    at_lcbf
        xdef    at_lcbf1

        xref    at_figrp
        xref    at_rsecl
        xref    at_rootd
        xref    at_subd

        xref    iou_fisl
        xref    iou_frsl

        include 'keys_err'
        include 'keys_sys'
;-        include 'keys_hdr'
        include 'keys_sbt'
        include 'keys_chn'
        include 'keys_qdos_ioa'
        include 'dd_fq_QL5A'
        include 'dd_fq_ddlk'

        include 'mac_assert'
;+++
; ATR Floppy Disk. Locates a slave block for read or write operations.
; If necessary, it reads the appropriate sector from the disk (at_rsecl) or
; from IBM directory in buffer (at_rootd)
;
;       d3  r   (word) bytes left in buffer
;       d4  r   block/byte
;       d5 c  p file position
;       d6 c  p drive / file number
;       a0 c  p channel block
;       a2  r   pointer to buffer
;       a3 c  p pointer to linkage block
;       a4 c  p pointer to physical definition block
;       a5 c  p pointer to map
;
;       status return standard
;---
at_lcbf
        move.l  d5,d4                    ; make block / byte form
        asl.l   #7,d4
        lsr.w   #7,d4

at_lcbf1
fdl.reg reg     d1/d7/a1
        movem.l fdl.reg,-(sp)

        jsr     iou_fisl                 ; find slave block ->(a2)
          beq   fdl_done

        jsr     iou_frsl                 ; find a free slave block ->(a2)

        move.l  a2,d7                   ; Zeiger auf slave block
        move.w  flp_allc(a5),d1         ; normal 2 Sektoren pro Gruppe
        lea     at_rsecl(pc),a2         ; Sektor lesen

        cmpi.w  #1,d6                   ; root dir ?
          ble.s fdl_rtdr                ; ..ja
        cmp.w   chn_sdid(a0),d6         ; dir - ID dieses files
          beq.s fdl_sdir                ; ..implizit geffnet
        cmpi.b  #ioa.kdir,chn_accs(a0)  ; access byte = 4, dir file?
          bne.s fdl_fndg                ; ..nein, normaler file
fdl_sdir
        lsl.w   #1,d1                   ; 2*2 = 4 Sektoren pro Gruppe bei DIR

        btst    #$10,d4                 ; untere oder obere Hlfte des Sektors ?
          bne.s fdl_schg                ; ..obere, subdir schon im Puffer

        movem.l d1/a1,-(sp)             ; Zeiger auf Slaveblock retten
        move.l  d4,d0
        clr.w   d0                      ; sector number
        swap    d0
        divu    d1,d0                   ; sector / file group form
        jsr     at_figrp(pc)            ; find group: sector / disk group
          blt.s fdl_bad1
        swap    d0                      ; disk group / sector
        lsr.w   #1,d0         ;test  sector/2
        lea     fdd_abuf(a3),a1         ; IBM-Puffer
        jsr     at_rsecl(pc)            ; IBM subdir erst einlesen
fdl_bad1
        movem.l (sp)+,d1/a1
          bne.s fdl_bad
fdl_schg
        lea     at_subd(pc),a2
        bra.s   fdl_fndg
fdl_rtdr
        lea     at_rootd(pc),a2         ; rootdir
        lsl.w   #1,d1                   ; 4 sectoren pro gruppe
fdl_fndg
        move.l  d4,d0
        clr.w   d0                       ; sector number
        swap    d0
        divu    d1,d0                    ; sector / group form
        jsr     at_figrp(pc)             ; find group
          blt.s fdl_bad

        assert  0,sbt_phys-1,sbt_phyg-2
        or.l    d0,(a1)+                 ; set physical sector / group
        assert  0,sbt_file-4,sbt_blok-6

        cmp.w   chn_sdid(a0),d6          ; dir - ID dieses files
          beq.s fdl_dir                  ; ..implizit geffnet
        cmpi.b  #ioa.kdir,chn_accs(a0)   ; dir file ?
          beq.s fdl_dir                  ; ..ja
        cmpi.w  #1,d6                    ; root dir ?
          bgt.s fdl_nodr                 ; ..nein
fdl_dir                                  ;
        bset    #7,-3(a1)                ; ..ja, kennzeichnen in sbt_phys
fdl_nodr
        move.w  d6,(a1)+                 ; set file
        swap    d4
        move.w  d4,(a1)+                 ; and block
        swap    d4

        swap    d0
        pea     -8(a1)                   ; backspace a1 and keep it
        movea.l d7,a1                    ; Zeiger auf slaveblock
        jsr     (a2)                     ; read sector or rootdir or subdir
        movea.l d7,a2
        movea.l (sp)+,a1
          bne.s fdl_bad
fdl_done
        move.l  #$200,d3                 ; bytes left in buffer
        sub.w   d4,d3
        add.w   d4,a2                    ; pointer position
        bra.s   fdl_exit
fdl_bad
        move.b  #sbt.mpty,sbt_stat(a1)   ; say empty
fdl_exit
        movem.l (sp)+,fdl.reg
        tst.l   d0
        rts
    end
