; ATR Floppy Disk load fat, 8/9/10/18 Sektoren pro Spur       02.12.91  Jo
; setzt fdd_iatp(a4) = 0 (IBM) oder $0002 (Atari)
; setzt fdd_chks(a4) Checksumme FAT 1 fr fq_ckrw1
; DD / HD
; Bugfix  move.b $0000007f,$00D7(a3)   03.11.94
        section at

        xdef    at_ldfat
        xdef    fdl_lp9
        xdef    fdl_offs

        xref    at_rsecp
        xref    at_chks

        include 'keys_err'
;-        include 'keys_hdr'
        include 'dd_fq_ddlk'
        include 'dd_fq_QL5A'
;+++
; This loads the boot sector and fat from a IBM/Atari Floppy Disk DD (HD)
; Testet auf 'QL5A'/'QL5B', $F0FF, 8-10 (18) Sektoren/Spur, $200 bytes/Sektor,
; und max. 112 (224) Eintrge rootdir = max 7 (14) Sektoren
;
;       a3 c  p pointer to linkage block
;       a4 c  p pointer to drive definition
;       a5 c  p pointer to map
;
;       status return 0 or err.mchk
;---
at_ldfat
fdl.reg reg     d1/d3/a1/a5
        movem.l fdl.reg,-(sp)
        st      fdd_actm(a3)            ;+
        lea     fdd_abuf(a3),a5

        move.b  fdd_mode(a4),$14(a2)    ; $3FD4
        movea.l a5,a1
        moveq   #1,d0
        jsr     at_rsecp                 ; direct sector 1 (rootsector)
          beq.s fdl_mset

        move.l  d6,d0
        swap    d0                      ; drive nr 1..4
        subq.w  #1,d0                   ; drive bit nr 0..3
        btst    d0,fdd_maxr(a3)         ; do not change mode
          beq.s fdl_mchk
        bchg    #0,fdd_mode(a4)         ; change mode
        move.b  fdd_mode(a4),$14(a2)    ; $3FD4
        movea.l a5,a1
        moveq   #1,d0
        jsr     at_rsecp                 ; read root sector again
          bne.s fdl_mchk
fdl_mset
        move.l  (a5),d0                 ; QL5A oder QL5B
        subq.b  #1,d0
        bset    #0,d0
        cmpi.l  #'QL5A',d0              ; ist QL-Floppy
          beq.s fdl_mchk                ; ..so nicht !
        move.b  $0C(a5),d0
        lsl.w   #8,d0
        move.b  $0B(a5),d0
        cmpi.w  #$0200,d0               ; $200 bytes pro Sektor ?
          bne.s fdl_mchk                ; ..nein, schlecht !

        lea     fdd_hfat(a4),a5
        movea.l a5,a1
        moveq   #2,d0                   ; track 0, side 0, sector 2
        jsr     at_rsecp(pc)            ; direct sector 2 read fat 1
          bne.s fdl_mchk

        move.w  #$F0FF,d0               ; $F9FF, $FEFF $F0FF IBM, $F7FF Atari
        move.w  d0,d1
        and.w   (a5),d1                 ; first entry IBM-fat
        cmp.w   d0,d1                   ; IBM typ floppy ?
          bne.s fdl_mchk                ; ..no

        moveq   #3,d1                   ; direct sector 3 read fat 1
        moveq   #4,d3                   ; last sector fat 1 DD (3 sectors)
        tst.b   fdd_mode(a4)
          ble.s fdl_rfat
        moveq   #10,d3                  ; last sector fat 1 HD (9 sectors)
fdl_rfat
        move.l  d1,d0                   ; this sector
        jsr     at_rsecp(pc)            ; read it
          bne.s fdl_mchk
        addq.b  #1,d1                   ; next sector
        cmp.b   d3,d1                   ; last ?
          bgt.s fdl_conv                ; ..yes
        bra.s   fdl_rfat

fdl_mchk
        bra     fdl_bad

fdl_conv
        movea.l a5,a1                   ; FAT 1 neu eingelesen
        jsr     at_chks(pc)             ; Checksumme $200 bytes (a1)+ -> d0.l
        move.l  d0,fdd_chks(a4)         ; ..eintragen fr fq_ckrw1
        moveq   #0,d0

        lea     fdd_map(a4),a5          ; QL-map
        lea     fdd_abuf(a3),a1         ; IBM boot sector
        move.b  $0D(a1),flp_allc+1(a5)  ; Anzahl Sektoren/Cluster
        clr.b   flp_allc(a5)
        move.b  $13(a1),flp_totl+1(a5)  ; Gesamtzahl aller Sektoren
        move.b  $14(a1),flp_totl(a5)
        move.w  flp_totl(a5),d0
        move.w  d0,flp_good(a5)         ; alle gut annehmen
        move.w  d0,flp_free(a5)         ; alle frei annehmen
        move.b  $18(a1),flp_strk+1(a5)  ; Anzahl Sektoren pro Spur
        move.b  $19(a1),flp_strk(a5)
        move.b  $1A(a1),flp_scyl+1(a5)  ; Anzahl Kpfe..
        move.b  $1B(a1),flp_scyl(a5)
        move.w  flp_scyl(a5),d1
        mulu    flp_strk(a5),d1         ; ..mal Anzahl Sektoren pro Spur
        move.w  d1,flp_scyl(a5)         ; = Anzahl Sektoren pro Zylinder
        divu    d1,d0                   ; good/scyl = trak
        move.w  d0,flp_trak(a5)         ; Anzahl Spuren
        cmpi.w  #$50,d0                 ; ..mehr als 80 ?
          bgt.s fdl_mchk
        move.b  $0E(a1),ibm_res+1(a5)   ; Anzahl reservierter Sektoren
        move.b  $0F(a1),ibm_res(a5)
        move.b  $10(a1),ibm_fat+1(a5)   ; Anzahl FAT's
        clr.b   ibm_fat(a5)
        move.b  $16(a1),ibm_nfat+1(a5)  ; Anzahl Sektoren pro FAT
        move.b  $17(a1),ibm_nfat(a5)
        move.b  $11(a1),ibm_dir+1(a5)   ; Anzahl Eintrge max. im root dir
        move.b  $12(a1),ibm_dir(a5)
        move.b  $1C(a1),ibm_hid+1(a5)   ; Anzahl verborgener Sektoren
        move.b  $1D(a1),ibm_hid(a5)
        move.w  ibm_nfat(a5),d1
        mulu    ibm_fat(a5),d1
        add.w   ibm_res(a5),d1
        move.w  d1,ibm_fdir(a5)         ; erster sektor root dir
        move.w  ibm_dir(a5),d0
        lsr.w   #4,d0                   ; /16 = Anzahl Sektoren fr root dir
        add.w   d0,d1
        add.w   ibm_hid(a5),d1
        move.w  d1,ibm_file(a5)         ; erster Sektor des Filebereiches
        sub.w   d1,flp_free(a5)         ; wenn leer, soviel Sektoren frei
        divu    flp_allc(a5),d1
        move.w  d1,ibm_clus(a5)         ; erstes Cluster des Filebereiches

        cmpi.w  #$E0,ibm_dir(a5)        ; max 224 Eintrge = 14 Sektoren HD
          bgt.s fdl_bad

        clr.w   fdd_iatp(a4)            ; ibm typ annehmen
        cmpi.w  #$0005,ibm_nfat(a5)     ; sektoren/FAT = 5 ?
          bne.s fdl_nibm                ; ..n
        move.w  #$0002,fdd_iatp(a4)     ; ..ja, ist Atari
fdl_nibm
        move.w  flp_strk(a5),d1
        move.w  $26(a1),flp_rand(a5)    ; extra ID + 1 byte Serien-Nummer
        move.l  $28(a1),flp_mupd(a5)    ; dto fr at_chrw1

;        moveq   #4,d0
;        bsr.s   fdl_clop                ; 20 bytes (a1)->(a5) fr at_chrw

        lea     fdd_map+flp_soff(a4),a5
        clr.w   (a5)+                   ; flp_soff = 0
        lea     fdl_lp9(pc),a1          ; 9 Sektoren pro Spur ?  -> DD
        cmpi.w  #$09,d1
          beq.s fdl_doco
        lea     fdl_lp18(pc),a1         ; 18 Sektoren pro Spur ? -> HD
        cmpi.w  #$12,d1
          beq.s fdl_doco
        lea     fdl_lp8(pc),a1
        cmpi.w  #$08,d1                 ; 8 Sektoren pro Spur ?
          beq.s fdl_doco
        lea     fdl_lp10(pc),a1
        cmpi.w  #$0A,d1                 ; 10 Sektoren pro Spur ?
          bne.s fdl_bad
fdl_doco
        bsr.s   fdl_copy                ; 36 bytes = 9 long (a1)+,(a5)+
        moveq   #0,d0
fdl_exit
        move.b  #fdd.at17,fdd_actm(a3)  ;+
        movem.l (sp)+,fdl.reg
        tst.l   d0
        rts
fdl_bad
        moveq   #err.mchk,d0
        bra.s   fdl_exit

; 36 bytes = 9 long kopieren
fdl_copy
        moveq   #9-1,d0
fdl_clop
        move.l  (a1)+,(a5)+
        dbf     d0,fdl_clop
        rts
fdl_lp8
        dc.w    $0001,$0203,$0405,$0607,$8081,$8283,$8485,$8687,$0000
        dc.w    $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
fdl_lp9
        dc.w    $0001,$0203,$0405,$0607,$0880,$8182,$8384,$8586,$8788
        dc.w    $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
fdl_lp10
        dc.w    $0001,$0203,$0405,$0607,$0809,$8081,$8283,$8485,$8687
        dc.w    $8889,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
fdl_lp18
        dc.w    $0001,$0203,$0405,$0607,$0809,$0A0B,$0C0D,$0E0F,$1011
        dc.w    $8081,$8283,$8485,$8687,$8889,$8A8B,$8C8D,$8E8F,$9091
fdl_offs equ    fdl_lp18-fdl_lp9
    end
