; Einen Sektor IBM-dir als QL-dir lesen                 04.12.91 Jo
; DD / HD

          section   at

          xdef      at_rootd            ; rootdir lesen
          xdef      at_subd             ; subdir lesen

          xref      cv_d1w
          xref      cv_d1l
          xref      cv_iquhr
          xref      cv_setmap

          include   'keys_hdr'
          include   'keys_chn'
          include   'keys_iod'
          include   'dd_fq_ddlk'
;-          include   'dd_at_ql5a'
          include   'mac_assert'
;+++
;  Liest einen Sektor des IBM rootdir von fdd_rdir(a4) als QL rootdir -> a1
;
;       d0      error code
;       d1..d2  preserved
;     ( d4 c  p block/byte )
;       d5 c  p file position
;       d6 c  p drive / file number
;       a0 c  p channel block
;       a1 c  p pointer to buffer
;       a3 c  p pointer to linkage block
;       a4 c  p pointer to physical definition block
;       a5 c  p pointer to map
;
;       status return standard
;---
at_rootd
rtd.reg   reg       d1-d3/d5/a1
          movem.l   rtd.reg,-(sp)
          bsr.s     rtd_null            ; Sektor (a1) auf NULL setzen / delay

          moveq     #7,d3               ; 8 Eintrge pro Sektor QL dir
          lea       fdd_hdir(a4),a2
          move.l    d4,d0               ; block / byte
          clr.w     d0
          swap      d0                  ; block
          lsl.l     #9-1,d0             ; * $200  /2
          adda.l    d0,a2               ; Zeiger auf rootdir-Eintrag IBM
          move.l    d0,d5
          lsl.l     #1,d5               ; Zeiger auf QL-dir Anfang block
rtd_hlop
          tst.b     (a2)                ; letzter Eintrag ibm ?
            beq.s   rtd_ok              ; ..ja, fertig
          cmpi.b    #$E5,(a2)           ; gelscht ?
            beq.s   rtd_next            ; ..ja, berspringen
          btst      #3,$0B(a2)          ; VOL-ID gesetzt ?
            beq.s   rtd_nvol            ; ..nein
          tas       (a1)                ; ..fr QDOS tabu kennzeichnen
          bra.s     rtd_next
rtd_nvol
          jsr       cv_setmap(pc)       ; QL map fr einen File setzen/d2.w = ID
            bmi.s   rtd_next            ; ..Fehler ?
          bsr.s     at_iqhdr            ; 1 Header Umwandeln
rtd_next
          adda.w    #$20,a2             ; nchster IBM header
          moveq     #hdr.len,d0
          adda.l    d0,a1               ; neuer QL header
          add.l     d0,d5               ; position fr at_stgrp/stg_flid
          dbf       d3,rtd_hlop
rtd_ok
          moveq     #0,d0
          movem.l   (sp)+,rtd.reg
          rts

; Utility: einen Sektor (a1) auf 0 setzen / $7F flag eintragen
rtd_null
          moveq     #0,d1
          moveq     #$7F,d0
          movea.l   a1,a2
rtd_nlop  move.l    d1,(a2)+
          dbf       d0,rtd_nlop
          moveq     #7,d0
          movea.l   a1,a2
rtd_7f    move.b    #$7F,(a2)
          adda.w    #hdr.len,a2
          dbf       d0,rtd_7f
          rts
;+++
;  Liest einen Sektor des IBM subdir aus fdd_abuf(a3) als QL subdir -> a1
;
;       d0      error code
;       d1..d2  preserved
;       d4 c  p block/byte
;     ( d5 c  p file position )
;       d6 c  p drive / file number
;       a0 c  p pointer to channel block
;       a1 c  p pointer to buffer
;       a3 c  p pointer to linkage block
;       a4 c  p pointer to physical definition block
;       a5 c  p pointer to map
;
;       status return standard
;---
at_subd
sbd.reg   reg       d1-d3/d5/a1
          movem.l   sbd.reg,-(sp)
          bsr.s     rtd_null            ; einen Sektor (a1) auf 0 / $7F setzen

          moveq     #7,d3               ; 8 Eintrge pro Sektor QL dir
          lea       fdd_abuf(a3),a2

;          move.w    d4,d0               ; byte position QL
;          lsr.w     #1,d0               ; byte position IBM
;          adda.w    d0,a2               ; Zeiger auf subdir-Eintrag IBM

          move.w    #$FE00,d0
          and.w     d0,d5               ; Zeiger auf QL-dir Anfang block
          and.w     d4,d0               ; 0 oder n * $200
          lsr.w     #1,d0               ; /2
          adda.w    d0,a2               ; Zeiger auf subdir-Eintrag IBM
          btst      #$10,d4
            beq.s   sbd_hlop            ; untere Hlfte des Sektors
          adda.w    #$100,a2            ; obere Hlfte des Sektors
sbd_hlop
          tst.b     (a2)                ; letzter Eintrag ibm ?
            beq.s   sbd_ok              ; ..ja, fertig
          cmpi.b    #$E5,(a2)           ; gelscht ?
            beq.s   sbd_next            ; ..ja, berspringen
sbd_nvol
          jsr       cv_setmap(pc)       ; QL map fr ganzen File setzen/d2.w =ID
            bmi.s   sbd_next            ; d0.l >0 max.Lnge des subdir
          bsr.s     at_iqhdr            ; 1 Header Umwandeln
sbd_next
          adda.w    #$20,a2
          moveq     #hdr.len,d0
          adda.w    d0,a1
          add.l     d0,d5
          dbf       d3,sbd_hlop
sbd_ok
          moveq     #0,d0
          movem.l   (sp)+,sbd.reg
          rts
;+++
; Umwandlung IBM-Header -> QL-Header
;       d0..d2  scratch !
;       d0 c s  max Lnge subdir oder 0
;       d2 c s  File ID
;       d6 c  p dir file ID
;       a0 c  p Zeiger auf channel def block
;       a1 c  p Zeiger auf QL-Header zum setzen
;       a2 c  p Zeiger auf IBM-Header zum Lesen
;---
at_iqhdr
ihd.reg   reg       d4/a0-a2/a5
          movem.l   ihd.reg,-(sp)

          move.b    $0B(a2),d1             ; IBM Attribut
          move.b    d1,hdr_attr(a1)        ; = QL TK2 FDAT
          move.b    d1,hdr_vers+1(a1)      ; ..und zum Anzeigen
          bset      #hdr..att,hdr_dset(a1) ; Flag IBM Attribut gesetzt
          btst      #0,d1                  ; read only ?
            beq.s   ihd_nro
          bset      #hdr..rol,hdr_accs(a1)
ihd_nro   btst      #1,d1                  ; hidden ?
            bne.s   ihd_hset
          btst      #2,d1                  ; system ?
            beq.s   ihd_fiid
ihd_hset  bset      #hdr..hid,hdr_accs(a1)

ihd_fiid  move.w    d2,hdr_flid(a1)     ; File-ID setzen

          move.w    $1A(a2),d1          ; 1.Cluster des Files
          jsr       cv_d1w(pc)
          move.w    d1,hdr_clus(a1)     ; ..in QL Header retten

          moveq     #hdr.len,d2         ; byte Zhler auf $40
          btst      #4,$0B(a2)          ; ibm Attribut subdir ?
            beq.s   ihd_sdr             ; ..nein, File-Typ QL = 0, data
          tst.l     $1C(a2)             ; Filelnge subdir..
            bne.s   ihd_null            ; ..nicht 0, kann nicht sein
          assert    hdrt.dir,$FF
          st        hdr_type(a1)        ; File-typ QL = -1, subdir
          cmpi.l    #'..  ',(a2)        ; IBM . oder .. -File
            beq.s   ihd_snul
          cmpi.w    #'. ',(a2)
            beq.s   ihd_snul
          add.l     d0,d0               ; QL dir = 2 x IBM dir
          add.l     d0,d2               ; d0 + #hdr.len
ihd_snul
          move.l    d2,hdr_flen(a1)     ; max.Lnge subdir eintragen
          bra.s     ihd_hdr
ihd_null
          moveq     #0,d2
          move.l    d2,hdr_flen(a1)
          bra       ihd_err
ihd_sdr
          jsr       cv_iquhr(pc)        ; Xbm-Uhr $16(a2) -> QL-Uhr d1.l
          move.l    d1,hdr_date(a1)     ; QL update date

          move.l    $1C(a2),d1          ; File Lnge IBM
          jsr       cv_d1l(pc)
          add.l     d2,d1               ; + #hdr.len
            bmi.s   ihd_null            ; ..schrott
          cmpi.l    #$000B2440,d1       ; 713*1024 + 64 = 730176
            bgt.s   ihd_null            ; ..zu lang, kann nicht sein
          move.l    d1,hdr_flen(a1)     ; File Lnge QL
ihd_hdr
          lea       hdr_name+2(a1),a5   ; hier hin schreiben
          moveq     #0,d2               ; byte Zhler QL-Name auf 0
          cmpi.w    #1,d6
            ble.s   ihd_ndat            ; ..rootdir
; subdir prefix kopieren
          lea       chn_name+2(a0),a0   ; ..subdir, hier steht Pfadname
          moveq     #$1F,d0
          and.w     fdd_path(a4),d0     ; Pfadnamen-Lnge von iou_fnam
          move.w    d0,hdr_path(a1)     ; ..eintragen
            beq.s   ihd_ndat
          addq.w    #1,d2               ; '_' dazu, falls nicht rootdir
          bra.s     ihd_pdbf
ihd_pfix
          move.b    (a0)+,(a5)+
          addq.w    #1,d2
ihd_pdbf  dbf       d0,ihd_pfix
          cmpi.b    #'_',-1(a5)
            beq.s   ihd_ndat
          move.b    #'_',(a5)+
ihd_ndat
          moveq     #8,d0               ; max 8 bytes Name
          bra.s     ihd_tlen
ihd_loop
          move.b    (a2)+,d1
            beq.s   ihd_err
          cmpi.b    #' ',d1
            beq.s   ihd_spce
          move.b    d1,(a5)+
          addq.w    #1,d2
          addq.w    #1,d4
ihd_tlen  cmpi.w    #hdr.nmln,d2        ; name zu lang ?
            bge.s   ihd_trun            ; ..ja, abbrechen und begrenzen
ihd_spce
          dbf       d0,ihd_loop
ihd_ext
          tst.l     d2
            bmi.s   ihd_end
          moveq     #3,d0               ; max 3 bytes extension
          moveq     #0,d4               ; extention Zhler auf 0
          bset      #hdr..ext,hdr_dset(a1) ; flag ext. set
          cmpi.b    #' ',(a2)           ; extension vorhanden ?
            beq.s   ihd_end             ; ..nein, fertig
          move.b    #'_',(a5)+
          addq.w    #1,d2
          bset      #31,d2              ; d2.l jetzt negativ
          bra.s     ihd_tlen
ihd_trun
          moveq     #hdr.nmln,d2        ; ..begrenzen
ihd_err
          moveq     #0,d4
ihd_end
          move.w    d2,hdr_name(a1)     ; Lnge Name (word)
          move.b    d4,hdr_extn(a1)     ; Lnge extention (byte)
          movem.l   (sp)+,ihd.reg
          rts
     end
