; ATR Floppy Disk Group Handling                            04.05.1991 Jo
; DD / HD

        section at

        xdef    at_stgrp      ; ATR set group

        include 'keys_err'
        include 'keys_iod'
        include 'dd_fq_ddlk'
        include 'dd_fq_QL5A'
;+++
; ATR set group
;
;       d0 c  p word ibm-file fat-nr
;       d1 c  p word group of QL file
;       d2 cr   old / new File-ID
;       d3-d4   preserved
;       d5 c  p sub-directory position / neg if unknown
;       d6 c  p drive / sub-directory ID
;       a0-a3   preserved
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       error return ERR_FE oder ok
;---
at_stgrp
stg.reg reg     d0-d1/d3/a1/a2
        movem.l stg.reg,-(sp)
        subq.w  #2,d0           ; fat-offset abziehen
          blt.s stg_err         ; ..wie das ?
        move.w  d2,d3           ; alte file ID retten
          bmi.s stg_err         ; ..=0 nicht bekannt, -1 Fehler
        subq.w  #1,d3           ; ..intern -1
        moveq   #0,d2
        move.w  ibm_clus(a5),d2 ; erstes Cluster Filebereich
        add.w   d0,d2           ; gruppen-nr QL
        lea     flp_gmap(a5),a2 ; base of map
        add.w   d2,a2           ; + group offset
        add.w   d2,a2
        add.w   d2,a2           ; das ist Zeiger auf aktuellen map Eintrag
        tst.w   d1              ; gruppe 0 ?
          bne.s stg_maps        ; ..nein, alte file ID nehmen
; File ID finden -> d2.w
        bset    #11,d2          ; file id = group with msb set
        cmp.w   #1,d6           ; unless it is main directory?
          bgt.s stg_mts         ; ..no, is subdirectory
        move.l  d5,d2           ; ... yes, rootdir file id = position
          bpl.s stg_srt         ; 0, $40, $80, ...
        move.l  iod_rdln(a4),d2 ; ... but this is at end of directory
stg_srt
        lsr.l   #6,d2           ; 0, 1, 2, ...
        addq.w  #1,d2           ; 1, 2, 3, ...
stg_mts
        move.w  d2,d3           ; neue File-ID retten
; QL map Eintrag testen
stg_maps
        move.w  d3,d2           ; neue oder alte interne File ID in d2.w
        cmpi.b  #$FD,(a2)       ; noch frei ?
          bne.s stg_tsfc        ; ..nein, auf $FC testen
        move.w  flp_allc(a5),d0
        sub.w   d0,flp_free(a5) ; one fewer free allocation blocks
        subq.w  #1,iod_free+2(a4)
        bra.s   stg_stfg
stg_tsfc
        cmpi.b  #$FC,(a2)       ; als belegt markiert ?
          bne.s stg_done        ; ..nein, fertig

; file / block in QL map setzen
stg_stfg
        swap    d2
        move.w  d1,d2           ; file ID / gruppe
        lsl.w   #4,d2           ; auf 12 bit zusammenrutschen
        lsl.l   #4,d2           ; links zentrieren
        rol.l   #8,d2           ; msb file-ID holen
        move.b  d2,(a2)+
        rol.l   #8,d2           ; lsb/msb file ID / gruppe
        move.b  d2,(a2)+
        rol.l   #8,d2           ; lsb gruppe
        move.b  d2,(a2)+
stg_done
        move.w  d3,d2
        addq.w  #1,d2           ; externe File-ID ist 1 hher
        moveq   #0,d0           ; ERR_ok
stg_exit
        movem.l (sp)+,stg.reg
        rts
stg_err
        moveq   #-1,d2          ; file ID = $FFFF
        moveq   #-$10,d0        ; ERR_FE
        bra.s   stg_exit
    end
