; Einen Block QL-dir lesen und 1/2 Block IBM-dir schreiben         30.12.91 Jo
; QL Header -> IBM Header DD / HD

          section   at

          xdef      at_wrtdir

          xref      at_rsecl
          xref      at_lcbf

          xref      cv_d1w
          xref      cv_d1l
          xref      cv_qiuhr

          include   'keys_hdr'
          include   'keys_iod'
          include   'keys_sbt'
          include   'keys_chn'
          include   'keys_qdos_ioa'
          include   'dd_fq_ddlk'
          include   'dd_fq_ql5a'
;+++
;  Liest einen Block QL dir und schreibt 1/2 Block IBM rootdir oder subdir
;
;       d0 cr   physical group / sector
;       a1 c s  pointer to slave block table
;       a2 cr   pointer to slaveblock-buffer QL dir / pointer to updated IBM dir
;       a3 c  p pointer to linkage block
;       a4 c  p pointer to physical definition block
;     ( a5 c  p pointer to map )
;
;       status return cond.code  N error, Z ok,write
;---
at_wrtdir
wrt.reg   reg       d1-d4/d7
          movem.l   wrt.reg,-(sp)
          move.l    sbt_file(a1),d1     ; msw file ID / lsw blok nr rootdir
          cmpi.w    #1,sbt_file(a1)     ; File ID
            bgt.s   at_subdir           ; ..ist nicht rootdir
; rootdir QL -> IBM
          move.w    d1,d7               ; ..blok nr merken
          lea       fdd_hdir(a4),a1
          lsl.w     #8,d1               ; * $100 = Offset auf IBM Eintrag
          adda.w    d1,a1               ; Zeiger auf IBM Dir Eintrag
          add.w     d1,d1               ; bytes von Anfang QL dir bis hier
          move.l    iod_rdln(a4),d3     ; Lnge QL rootdir
          sub.l     iod_hdrl(a4),d3     ; ..in echt
          sub.w     d1,d3               ; d3.w bytes Rest bis Ende rootdir
          lsr.w     #6,d3               ; / $40
          cmpi.w    #8,d3
            ble.s   wrt_wdbf
          moveq     #7,d3               ; max 8 Files pro Block
wrt_rlop
          cmpi.b    #$7F,(a2)           ; flag $7F QL dir Ende
            beq.s   wrt_end
          bsr.l     at_qihdr            ; ein QL-Header -> IBM-Header
          adda.w    #$20,a1
          adda.w    #hdr.len,a2
wrt_wdbf
          dbf       d3,wrt_rlop
wrt_end
          moveq     #0,d0
          lea       fdd_hdir(a4),a2
          lsr.w     #1,d7               ; QL block 0, 1, 2, 3, -> 0, 0, 1, 1,
          move.w    d7,d0               ; sector-nr im rootdir
          lsl.w     #8,d7
          add.w     d7,d7               ; * $200
          adda.w    d7,a2               ; Zeiger auf IBM root dir block
          add.w     ibm_fdir(a5),d0     ; + erster Sektor rootdir
          divu      flp_allc(a5),d0     ; sector/group
          swap      d0                  ; group / sector
          moveq     #0,d1               ; cond.code = Z
          movem.l   (sp)+,wrt.reg
          rts

; Subdirectory umwandeln zum Wegschreiben
at_subdir
          lsr.w     #1,d0               ; 2 sectoren / gruppe
          move.l    d0,d7               ; group / sector retten
          move.l    a1,d4               ; Zeiger auf aktuellen Slaveblock
          moveq     #0,d3               ; untere Hlfte
          btst      #0,d1               ; blok-nr QL subdir gerade ?
            beq.s   wrt_grde
          move.w    #$100,d3            ; obere Hlfte
wrt_grde  lea       fdd_abuf(a3),a1     ; ibm puffer
          jsr       at_rsecl(pc)        ; ..erst einlesen
            bmi.s   wrt_exit            ; hoppla
          adda.w    d3,a1               ; Zeiger auf ibm subdir Hlfte

; 1/2 Block lschen; Pfadlnge rausfinden
pth.reg   reg       d5-d6/a0-a2
          movem.l   pth.reg,-(sp)

          moveq     #$3F,d3             ; $3F+1 * 4 = $100
wrt_clrl  clr.l     (a1)+               ; ..lschen
          dbf       d3,wrt_clrl

          moveq     #7,d3               ; max 8 QL dir Eintrge
wrt_pthl
          tst.w     hdr_path(a2)        ; Pfadlnge gesetzt?
            bne.s   wrt_path            ; ..ja
          adda.w    #hdr.len,a2         ; nchster QL dir Eintrag
          dbf       d3,wrt_pthl         ; nichts gefunden

          lea       fdd_abuf+$200(a3),a0 ; dummy channel blok
          move.b    #ioa.kdir,chn_accs(a0)
          movea.l   d4,a1               ; aktueller Slaveblock
          move.b    (a1),d0
          lsr.b     #4,d0               ; drive-ID
          move.b    d0,chn_drid(a0)
          subq.l    #8,a1
          move.l    a1,chn_csb(a0)
          moveq     #0,d5               ; Block 0 mit . - dir lesen
          swap      d1                  ; subd file ID
          move.w    d1,d6
          jsr       at_lcbf(pc)         ; ..mit d6 drive / file ID
            beq.s   wrt_path            ; ..ok, gefunden
          movem.l   (sp)+,pth.reg
          moveq     #-$10,d1
          bra.s     wrt_exit            ; Fehler
wrt_path
          move.w    hdr_path(a2),d4     ; Pfadlnge d4.w
          movem.l   (sp)+,pth.reg

; jetzt 1/2 IBM Subdir bersetzen
          moveq     #7,d3               ; max 8 Files pro Block
wrt_slop
          tst.w     hdr_path(a2)        ; Pfadlnge schon gesetzt ?
            bne.s   wrt_dohr            ; ..ja, fertig
          move.w    d4,hdr_path(a2)     ; ..setzen
wrt_dohr
          cmpi.b    #$7F,(a2)           ; flag $7F QL (sub)dir ende
            beq.s   wrt_efok
          bsr.s     at_qihdr            ; ein QL-Header -> IBM-Header
          adda.w    #$20,a1
          adda.w    #hdr.len,a2
          dbf       d3,wrt_slop
wrt_efok
          move.l    d7,d0               ; physical group / sector zurck
          moveq     #0,d1               ; cond.code = Z
wrt_exit
          lea       fdd_abuf(a3),a2
          movem.l   (sp)+,wrt.reg
          rts
;+++
; Umwandlung QL-Header (a2) -> IBM-Header (a1)
;       d0..d2  scratch !
;       a1 c  p Zeiger auf IBM-Header zum Setzen
;       a2 c  p Zeiger auf QL-Header zum Lesen
;---
at_qihdr
qhd.reg   reg       a0-a2/a5
          movem.l   qhd.reg,-(sp)
          movea.l   a1,a5               ; Zeiger auf IBM-Header retten
          moveq     #hdr.len,d2
          move.l    hdr_flen(a2),d1     ; File-Lnge QL
            bmi     qhd_end             ; ..Flag fr QL tabu
          sub.l     d2,d1               ; - hdr.len
            blt.s   qhd_negl
          jsr       cv_d1l(pc)
          move.l    d1,$1C(a1)          ; File-Lnge IBM
qhd_negl
          move.w    hdr_clus(a2),d1     ; erstes Cluster IBM gerettet
          jsr       cv_d1w(pc)
          move.w    d1,$1A(a1)          ; ..setzen
qhd_nset
          move.l    hdr_date(a2),d1
          jsr       cv_qiuhr(pc)        ; QL-Uhr d1.l -> IBM-Uhr d1.l
          move.l    d1,$16(a1)

          move.b    hdr_attr(a2),d1     ; IBM Attribut
          btst      #hdr..att,hdr_dset(a2) ; ..gesetzt?
            bne.s   qhd_aset            ; ..ja
          moveq     #$20,d1             ; ..nein, ersatzweise Archive-bit setzen
qhd_aset
          cmpi.b    #hdrt.dir,hdr_type(a2) ; QL subdir -1 ?
            bne.s   qhd_nsub            ; ..nein
          moveq     #$10,d1             ; IBM subdir
          clr.l     $1C(a1)             ; ..hat keine Filelnge
qhd_nsub  move.b    d1,$0B(a1)          ; IBM Attribut setzen

          move.w    hdr_name(a2),d0     ; Namenlnge QL
            beq.s   qhd_clrd            ; ..file gelscht
          move.w    hdr_path(a2),d2     ; Pfadnamenlnge ohne '_'
            beq.s   qhd_csps            ; ..rootdir = 0
          addq.w    #1,d2               ; '_' dazu
          sub.w     d2,d0               ; - Pfadnamenlnge = Filenamenlnge IBM
            ble.s   qhd_clrd            ; ..drfte garnicht sein !
qhd_csps
          moveq     #$0A,d1
qhd_spce  move.b    #' ',(a1)+          ; IBM-Namen mit ' ' vorbelegen
          dbf       d1,qhd_spce
          movea.l   a5,a1

          lea       hdr_name+2(a2,d2.w),a0 ; Zeiger auf Filename ohne Pfad
          btst      #hdr..ext,hdr_dset(a2)
            bne.s   qhd_eset
          bsr.s     qh_lext             ; Lnge Extention ermitteln
qhd_eset
          sub.b     hdr_extn(a2),d0     ; Filenamenlnge ohne Extention
          cmpi.w    #8,d0               ; ..lnger als 8 bytes ?
            ble.s   qhd_8byt            ; ..nein, aber auf '_' testen
          moveq     #8,d0               ; ..ja, auf 8 bytes begrenzen
          bra.s     qhd_fdbf
qhd_8byt  cmpi.b    #'_',-1(a0,d0.w)    ; letzes Zeichen ein '_' ?
            bne.s   qhd_fdbf
          subq.w    #1,d0               ; ..ohne '_'
          bra.s     qhd_fdbf
qhd_fnam
          move.b    (a0)+,d1
          bsr.s     cv_gross
          move.b    d1,(a1)+            ; Filenamen kopieren
qhd_fdbf  dbf       d0,qhd_fnam

          moveq     #3,d0
          and.b     hdr_extn(a2),d0     ; Lnge Extention, auf 3 begrenzt
          move.w    hdr_name(a2),d1     ; Gesamtnamenlnge QL
          sub.w     d0,d1               ; - Lnge Extention
          lea       hdr_name+2(a2,d1.w),a0 ; = Zeiger auf Anfang Extention
          lea       8(a5),a1            ; IBM Platz fr EXT
          bra.s     qhd_cdbf
qhd_cext
          move.b    (a0)+,d1
          bsr.s     cv_gross
          move.b    d1,(a1)+            ; EXT kopieren
qhd_cdbf  dbf       d0,qhd_cext
          bra.s     qhd_end
qhd_clrd
          move.b    #$E5,(a1)           ; IBM-Eintrag gelscht
qhd_end
          movem.l   (sp)+,qhd.reg
          rts

; Utility: Buchstaben a..z -> A..Z
cv_gross
          cmpi.b    #'a',d1
            blt.s   gss_rts
          cmpi.b    #'z',d1
            bgt.s   gss_rts
          subi.b    #$20,d1
gss_rts   rts

; Lnge extention ermitteln
qh_lext
          lea       0(a0,d0.w),a1       ; Zeiger auf Ende Filename
          moveq     #0,d1               ; Zhler ext.Lnge
qhd_elop  cmpi.b    #'_',-(a1)
            beq.s   qhd_etst
          addq.w    #1,d1
          cmpi.b    #3,d1               ; max 3 bytes ext.
            ble.s   qhd_elop
          bra.s     qhd_nfnd            ; ext = 0
qhd_etst
          move.b    d1,hdr_extn(a2)     ; d1.b = Lnge Extention ok annehmen
          cmp.w     d0,d1               ; Extention < Name ohne Pfad ?
            blt.s   qhd_done            ; ..ja, ist wirklich Extention
qhd_nfnd
          clr.b     hdr_extn(a2)        ; Lnge Extention = 0
qhd_done
          movea.l   a5,a1               ; a1 zurck
          rts
     end
