; Floppy Disk Allocate Buffer    V2.00    1988   Tony Tebby QJUMP   Jo

        section fq

        xdef    fq_albf
        xdef    fq_alsec
        xdef    fq_alfs

        xref    fq_lcbf
        xref    fq_lcbf1

        xref    fq_figrp
        xref    fq_algrp
        xref    fq_afgrp

        xref    iou_frsl

        include 'flp1_keys_err'
        include 'flp1_keys_hdr'
        include 'flp1_keys_sbt'
        include 'flp1_keys_chn'
        include 'flp1_dd_fq_QL5A'
;+++
; Floppy Disk ALBF: locates or allocates a slave block for write operations.
; If necessary, it reads the appropriate sector from the disk or extends the
; file allocation.
;
;       d3  r   (word) bytes left in buffer
;       d4  r   block/byte
;       d5 c  p file position
;       d6 c  p drive / file number
;       a0 c  p channel block
;       a2  r   pointer to buffer
;       a3 c  p linkage block
;       a4 c  p definition block
;       a5 c  p pointer to map
;
;       status return standard
;---
fq_albf
        cmp.l   chn_feof(a0),d5          ; end of file?
        blt.l   fq_lcbf                  ; ... no, locate

        move.l  d5,d4                    ; make block / byte form
        asl.l   #6,d4
        bvs.s   fda_eof                  ; ... oops sign change
        add.l   d4,d4
        lsr.w   #7,d4
        bne.l   fq_lcbf1                 ; not the start of a new block

;+++
; Floppy Disk ALSEC: allocates a slave block and sector by starting or extending
; the file allocation.
;
;       d3  r   (word) bytes left in buffer
;       d4 c  p block/byte
;       d6 c  p drive / file number
;       a0 c  p channel block
;       a2  r   pointer to buffer
;       a3 c  p linkage block
;       a4 c  p definition block
;       a5 c  p pointer to map
;
;       status return standard
;---
fq_alsec
fda.reg reg     a1
;****        movem.l fda.reg,-(sp)
        move.l  a1,-(sp)
        move.l  d4,d0
        clr.w   d0                       ; sector number
        swap    d0                       
        divu    flp_allc(a5),d0          ; sector / group form
        swap    d0
        tst.w   d0
        beq.s   fda_alg                  ; first sector of group
        swap    d0
        jsr     fq_figrp                 ; find group
        bra.s   fda_sfsb
fda_alg
        swap    d0
        jsr     fq_algrp                 ; allocate new group of file
fda_sfsb
        blt.s   fda_exit

        jsr     iou_frsl                 ; find new slave block

;-        assert  0,sbt_phys-1,sbt_phyg-2
        or.l    d0,(a1)+                 ; set physical sector / group
;-        assert  0,sbt_file-4,sbt_blok-6
        move.w  d6,(a1)+                 ; set file
        swap    d4
        move.w  d4,(a1)+                 ; and block
        swap    d4

        move.l  #512,d3                  ; bytes left in buffer

fda_ok
        moveq   #0,d0
fda_exit
;***        movem.l (sp)+,fda.reg
        move.l  (sp)+,a1
        rts

fda_eof
        moveq   #err.eof,d0
        bra.s   fda_exit

;+++
; Allocate / re-allocate first sector of new file
;
;       d1 cr   old / new file ID
;       d5 c  p sub-directory position 
;       d6 c  p drive / sub-directory ID
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       status return 0 or err.drfl
;---
fq_alfs
;***        movem.l fda.reg,-(sp)
        move.l  a1,-(sp)
        jsr     fq_afgrp                 ; allocate first group
        ble.s   fda_exit
        jsr     iou_frsl                 ; find new slave block

;-        assert  0,sbt_phys-1,sbt_phyg-2
        or.l    d0,(a1)+                 ; set physical sector / group
;-        assert  0,sbt_file-4,sbt_blok-6
        move.w  d1,(a1)+                 ; set file
        clr.w   (a1)+                    ; and block
        bra.s   fda_ok

        end
