; Check floppy for Open      V2.00    1990   QJUMP  /  02.03.92 Jo

        section fq

        xdef    fq_ckop

        xref    fq_ckrw
        xref    fq_flsha
        xref    fq_ldmap
        xref    fq_alfs
        xref    iou_clsl

        include 'keys_err'
        include 'keys_iod'
        include 'keys_hdr'
        include 'keys_chn'
        include 'dd_fq_ddlk'
        include 'dd_fq_QL5A'

;+++
; Check floppy for open. with _*DnD, _*DnH, n=0..3
;
;       d1      scratch
;       d6 c  p msw drive number
;       a0 c  p channel block
;       a3 c  p pointer to linkage block
;       a4 c  p pointer to physical definition
;
;       error return 0 ok, 1 direct sector, or err.mchk
;---
fq_ckop
fdc.reg  reg    d3/d4/d5/d6/a1/a2
        tas     fdd_nset(a3)            ;+ name set ?
          bne.s fdc_ckop                ;+ ..yes
        move.l  iod_dnam+2(a3),iod_dnus+2(a3) ;+ device name->device name usage
fdc_ckop
        cmp.l   fdd_maxd(a3),d6          ; drive in range? fdd_maxd/fdd_maxt
        bgt.s   fdc_fdnf                 ; ... no

        moveq   #$ffffffdf,d1            ; check for *D or *d
        and.l   chn_name(a0),d1
        cmp.l   #$00042a44,d1            ; is it?
        bne.s   fdc_ckok
        moveq   #$ffffffdf,d1
        and.w   chn_name+4(a0),d1
        moveq   #fdd.dd,d2              ;+ DD=0
        cmpi.b  #'D',d1                 ;+ _*D0D.. _*D3D 128..1024 DD bytes/sect
          beq.s fdc_dop                 ;+
        cmpi.b  #'H',d1                 ;+ _*D0H.. _*D3H 128..1024 HD bytes/sect
          bne.s fdc_bn                  ;+
        moveq   #fdd.hd,d2              ;+ HD=1
fdc_dop
        lsr.w   #8,d1                   ;+
        subi.b  #'0',d1                 ;+
          blt.s fdc_bn                  ;+
        cmpi.b  #3,d1                   ;+ max 3=1024 bytes, fdd_buff=$400 !!
          ble.s fdc_ds                  ;+ < 4=2048 ... ausschlieen
fdc_bn
        moveq   #err.inam,d0
        bra.s   fdc_rts                  ; bad name
fdc_ds
        jsr     fq_flsha(pc)             ; flush everything
        move.b  d2,fdd_mode(a4)         ;+ set fdc_mode
        move.b  d1,d6                   ;+ 0..3 x $80 = $80..$400 bytes/sector
        moveq   #1,d0                    ; flag direct sector io
fdc_rts
        rts

fdc_fdnf
        moveq   #err.fdnf,d0             ; drive out of range
        bra.s   fdc_rts

fdc_ckok
        move.w  #$0200,iod_sctl(a4)     ;+ QL5A-Files: 512 bytes/sector
        movea.l fdd_base(a3),a2
        tst.b   iod_drst(a4)             ; OK?
          bge.s fdc_check                ; ... no
        moveq   #0,d0                    ; ... yes, assume OK then
        tst.w   iod_rdid(a4)             ; root directory set?
          beq.s fdc_check                ; ... no, get map
        jsr     fq_ckrw(pc)              ; check ok to read or write
;-          ble.s fdc_rts                  ; ... ok, all done
          beq.s fdc_rts                  ; ... ok, all done
          bpl.s fdc_ck1                 ; ..changed, check
        tst.b   fdd_mpty(a3)            ; drive ?
          bne.s fdc_fdnf                ; .. empty, return
        move.l  d6,d0
        swap    d0                      ; drive nr 1..4
        subq.w  #1,d0                   ; drive bit nr 0..3
        btst    d0,fdd_maxr(a3)         ; do not change mode !
          beq.s fdc_ck1
        bchg    #0,fdd_mode(a4)         ; try other mode
fdc_ck1
        clr.b   iod_drst(a4)             ; status not OK yet
fdc_check
        movem.l fdc.reg,-(sp)
        move.b  chn_drid(a0),d0          ; drive id
        jsr     iou_clsl(pc)             ; clear slave blocks

        jsr     fq_ldmap(pc)             ; load map
          bne   fdc_mchk                 ; ... oops
        move.b  #iod.ql5a,iod_ftyp(a4)  ; =0

        lea     flp_mnam(a5),a2
        lea     iod_mnam(a4),a1
        move.l  (a2)+,(a1)+
        move.l  (a2)+,(a1)+
        move.l  (a2)+,(a1)+              ;+ max name is 10 long + random

;-        moveq   #9,d0
;-fdc_mnam
;-        cmp.b   #' ',-(a1)               ; space at end
;-        dbne    d0,fdc_mnam
;-        addq.w  #1,d0
;-        move.w  d0,iod_mnam(a4)          ; length of medium name

        move.w  #iod.rdid,iod_rdid(a4)     ; root directory ID = 1

        move.l  flp_eodr(a5),d0
        lsl.w   #7,d0
        lsr.l   #7,d0
        move.l  d0,iod_rdln(a4)          ; and length

        move.w  flp_allc(a5),d1          ; d1.l allocation unit
        move.w  d1,d0
        lsl.w   #8,d0
        add.w   d0,d0
        move.w  d0,iod_allc(a4)          ; *512

        moveq   #0,d0
        move.w  flp_good(a5),d0          ; total good
        divu    d1,d0
        move.w  d0,iod_totl+2(a4)

        moveq   #0,d0
        move.w  flp_free(a5),d0          ; total free
        divu    d1,d0
        move.w  d0,iod_free+2(a4)

        moveq   #0,d0
        move.w  flp_totl(a5),d0
        divu    d1,d0                   ; Anzahl Eintrge in QL-map
        mulu    #3,d0                   ; bytes map
        addq.w  #1,d0
        bclr    #0,d0                   ; auf gerade Zahl aufrunden
        add.w   #flp_gmap,d0
;--        move.w  #flp_mtop,d1            ; $600 = 3 Sektoren
        move.w  #$0C00,d1               ;++ 6 sectoren
        cmp.w   d1,d0
          ble.s fdc_seto
        move.w  d1,d0                   ; auf flp_ftop begrenzen
fdc_seto
        move.w  d0,fdd_mtop+2(a4)       ; eintragen fr at_group

        move.l  #hdr.len,iod_hdrl(a4)

        clr.l   fdd_mupd(a4)            ; reset map update
        clr.l   fdd_mupd+4(a4)

        st      iod_drst(a4)             ; map ok now
        moveq   #0,d0
        bra.s   fdc_exmp

fdc_mchk
        moveq   #err.mchk,d0
fdc_exmp
        movem.l (sp)+,fdc.reg
;-fdc_rtd0
;-        tst.l   d0
        rts
        end
