; Check floppy for Read/Write      V2.00    1990   QJUMP   Jo 02.12.1991
; checks FLP and ATR, with fdd_new and Checksum of FAT 1
; QL5A oder QL5B    10.03.92

          section   fq

          xdef      fq_ckrw
          xdef      at_chks

          xref      fq_ckwp
          xref      fq_rsec

          include   'keys_err'
          include   'keys_iod'
          include   'dd_fq_ddlk'
          include   'dd_fq_QL5A'

;+++ 
; Check floppy for read / write. FLP / ATR version.  DD / HD
;
;       d0      preserved if no error, else err.mchk
;       d6 c  p msw drive number
;       a2 c  p WD1772
;       a3 c  p pointer to linkage block
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       error return <0 bad, 0 ok, +ve changed
;---
fq_ckrw
fcrw.reg  reg       d0/d1/d7/a1/a5
          movem.l   fcrw.reg,-(sp)
          move.l    d6,d7                    ; drive number
          swap      d7
          subq.w    #1,d7
          bclr      d7,fdd_schk(a3)          ; stopped since check?
            beq.s   fdc_exit                 ; ... no
fcrw_tst
          jsr       fq_ckwp                  ; write protected?
            sne     iod_wprt(a4)             ; ... set flag

          moveq     #1,d0
          lea       fdd_buff(a3),a1
          jsr       fq_rsec(pc)              ; read root sector
            bne.s   fdc_mchk

          move.l    (a1),d1                  ; 'QL5A' oder 'QL5B' oder ?
          subq.b    #1,d1
          bset      #0,d1                    ; flp.id = 'QL5A'

          tst.l     fdd_flpl(a3)             ;+ ATR ?
            bne.s   atr_ckrw                 ;+ ..ja

          moveq     #4,d0                    ; check first 20 bytes
fdc_loop
          cmpm.l    (a5)+,(a1)+
          dbne      d0,fdc_loop
            bne.s   fdc_mtst                 ; ... changed
fdc_old
          moveq     #0,d0
fdc_exit
          movem.l   (sp)+,fcrw.reg
          rts

fdc_mtst
          cmpi.l    #flp.id,d1               ; correct type? #'QL5A'
            bne.s   fdc_mchk                 ; ... no, bad
          tst.b     iod_nrfl(a4)             ; files open?
            bne.s   fdc_mchk                 ; ... yes, bad
          moveq     #1,d0                    ; ... yes, change
          bra.s     fdc_exit

fdc_mchk
          bset      d7,fdd_schk(a3)          ; check again
          moveq     #err.mchk,d0             ; ERR_FE
          move.l    d0,(sp)                  ; return error
          bra.s     fdc_exit
; ------------------------------------------ ; ende original fq_ckrw
atr_ckrw
          cmpi.l    #flp.id,d1          ; QL5A type?
            beq.s   fdc_mchk            ; ... yes, bad

          tst.b     fdd_new(a3)         ; ATR_DEV flag new
            bne.s   atr_mtst            ; ..set

;          lea       fdd_map(a4),a5
;          moveq     #4,d0               ; compare first 20 bytes
;atr_lop0  cmpm.l    (a1)+,(a5)+
;          dbne      d0,atr_lop0
;            bne.s   atr_mtst            ; ..changed

        lea     fdd_map+flp_rand(a4),a5 ; QL map  flp_rand..flp_mupd
        adda.w  #$26,a1                 ; extra ID + Serien-Nummer IBM Start
        moveq   #2,d0                   ; compare 3 word
atr_lop0
        cmpm.w  (a1)+,(a5)+
        dbne    d0,atr_lop0
          bne.s atr_mtst

          lea       fdd_buff(a3),a1     ; Puffer fr 3 Sektoren
          moveq     #2,d0               ; Spur 0, Seite 0, Sektor 2: FAT 0
          jsr       fq_rsec(pc)         ; in fdd_buff(a3) = a1 lesen
            bne.s   fdc_mchk            ; ..bad

         bsr.s      at_chks             ; Checksumme (a1)+ -> d0.l
         cmp.l      fdd_chks(a4),d0     ; = alte Prfsumme ?
            beq.s   fdc_old
atr_mtst
          tst.b     iod_nrfl(a4)        ; files open?
            bne.s   fdc_mchk            ; ... yes, bad
          sf        fdd_new(a3)         ; clear ATR_DEV flag new
          moveq     #1,d0               ; ... no, but changed
          bra.s     fdc_exit
;+++
;         Checksum of $200 bytes (a1)+
;         d0   r    checksum
;         a1 c   p  pointer to $200 bytes
;
;         Error return none
;---
at_chks
          movem.l   d1/a1,-(sp)
          moveq     #0,d0               ; Prfsumme auf 0
          moveq     #$1F,d1             ; $20*4*4=$200 bytes
atr_lop1  add.l     (a1)+,d0            ; Prfsumme von Diskette neu bilden
          add.l     (a1)+,d0
          add.l     (a1)+,d0
          add.l     (a1)+,d0
          dbf       d1,atr_lop1
          movem.l   (sp)+,d1/a1
          rts
      end
