; QL Floppy Disk Format   V2.00    1990   Tony Tebby QJUMP   Jo
; DD / HD - Version  06.03.92
; at_ftrack wird auch von at_fdrv verwendet

        section fq

        xdef    fq_fdrv
;        xdef    fq_fdata                 ;+
        xdef    at_ftrack                ;+

        xref    fq_ckwp
        xref    fq_flsha
        xref    fq_flshm
        xref    fq_fint
        xref    fq_wtrack
        xref    fq_rsec
        xref    gu_achp0
        xref    gu_rchp
        xref.l  fdf_offs                ;+

        include 'keys_err'
        include 'keys_iod'
        include 'keys_hdr'
        include 'keys_karte'       ;+
        include 'keys_sys'
        include 'dd_fq_ddlk'
        include 'dd_fq_QL5A'
        include 'mac_assert'

fdf.group equ   3
;- fdf.sctt  equ   9
fdf.trkl  equ   13*512  ; DD track length = 6656 $1A00
fdf.htrk  equ   26*512  ; HD track length =13312 $3400

;+++
; This formats a Floppy Disk on a QL
;
;       d1  r   good groups
;       d2  r   total groups
;       d6 c  p msw drive number
;       a1 c  p medium name
;       a3 c  p dd linkage block
;       status return standard
;---
fq_fdrv
fdf.reg reg     d3-d5/d7/a0-a2/a4-a5
        movem.l fdf.reg,-(sp)
        moveq   #0,d4
        move.w  fdd_maxt(a3),d4         ; tracks
          bne.s fdf_tset                ; ..gesetzt
        moveq   #80,d4                  ; auf 80 begrenzen
fdf_tset
        move.w  (a1)+,d5                ; Lnge Name
        subq.w  #$05,d5                 ; 'flpx_' weg
        addq.l  #$05,a1
        moveq   #-$01,d1                ; S
        cmpi.b  #'*',-$01(a1,d5.w)      ; 'name*' ?
          beq.s fdf_min1                ; ..ja, DD einseitig
        cmpi.b  #'*',-$02(a1,d5.w)      ; 'name*H', 'name*D', name*S' ?
          bne.s fdf_defd                ; ..nein, 'name', default density
        move.b  -$01(a1,d5.w),d2        ; ..ja, letztes Zeichen ein 'HDS' ?
        bsr     den_hds                 ; d1.l = -1 .. 1
          beq.s fdf_min2                ; wenn nicht ok, default nehmen
fdf_defd
        addq.w  #$02,d5                 ; s.fdf_min2/fdf_min1
        move.b  fdd_defd(a3),d1
        ext.w   d1
        bset    #$1F,d4                 ; flag fast format and default density
fdf_min2
        subq.w  #$01,d5                 ; '*H' weg
fdf_min1
        subq.w  #$01,d5                 ; '*' weg
fdf_flsh
        jsr     fq_flsha                 ; do all pending ops and stop int task
;-        assert  fdd.hold,-1
;-        st      fdd_actm(a3)             ; stop interrupt task

        move    SR,-(a7)                 ; nur mit Formatieren beschftigt..
        ori.w   #$0700,SR

        moveq   #0,d0                    ; flag Laufwerk nicht testen
        jsr     fq_ckwp                  ; write protected (selects and seeks)?
          bne.l fdf_rdon

        move.l  #fdd.hlen+fdf.htrk+$200,d0 ; $80 + 3*$200 bytes + HD-tracklength
        jsr     gu_achp0                 ; = $4080 bytes
          bne.l fdf_exit                 ; ... oops
;        movea.l $F4(a3),a0      ;+test
;        nop                     ;+test
;        nop                     ;+test

        move.l  a0,a4                    ; set base of pseudo definition block
        swap    d6
        move.b  d6,iod_dnum(a4)          ; set drive number
        swap    d6

        movea.l  fdd_base(a3),a2
        bsr      fq_fint

        moveq   #fdf_dtab-fdf_stab,d0   ; Lnge einer Datentabelle
        muls    d1,d0                   ; * -1, 0 oder 1 (S, D, H)
        lea     fdf_dtab(pc),a2         ; Zeiger auf D-Tabelle
        adda.l  d0,a2                   ; Zeiger auf aktuelle Tabelle
        assert  fdd_sctl,fdd_mode-1
        move.w  (a2)+,fdd_sctl(a4)      ; z.B. 0201 02 fdd_sctl, 01 fdd_mode
        move.w  (a2)+,iod_sctl(a4)      ; $0200 = 512 bytes/sector

; fast format testen
        tst.l   d4                      ; fast format ?
          bpl.s fdf_fullf               ; ..no
        moveq   #-1,d0
        add.w   d4,d0
        move.b  d0,fdd_trak(a3)         ; letzte Spur
        move.b  2+1(a2),fdd_sect(a3)    ; flp_strk, letzter Sektor
        move.b  #1,fdd_side(a3)         ; Seite 1
        tst.b   d1
          bpl.s fdf_dside
        clr.b   fdd_side(a3)            ; ausser fr 'S', d1=-1, Seite 0
fdf_dside
        move.w  fdd_maxr(a3),d0         ; change mode kopieren
        lsr.w   #8,d0                   ; um 1 byte verschieben und lschen
        move.w  d0,fdd_maxr(a3)
        move.l  a1,-(sp)
        move.l  fdd_sadd(a3),d0
;---        lea     $C0000,a1       ; EPROM absolut !!!
        lea     fdd.hlen+fdf.htrk(a4),a1 ; $200 bytes read buffer
        jsr     fq_rsec(pc)             ; read sector, aber ohne change mode !
        movea.l (sp)+,a1
        move.b  fdd_maxr+1(a3),fdd_maxr(a3) ; change mode zurck
        clr.l   fdd_sadd(a3)            ; bitte jetzt von Anfang an
        tst.l   d0
          beq.s fdf_fullf               ; ok, fast format
        bclr    #$1F,d4                 ; nicht ok, full format
fdf_fullf

        move.w  #fdd.hlen-fdd_map-1,d0   ; fill medium header buffer with $ff
        lea     fdd.hlen(a4),a0          ; Top of pseudo physdef
fdf_bloop
        st      -(a0)
        dbra    d0,fdf_bloop
        move.l  a0,a5                    ; our map

        move.w  #'QL',(a0)+             ; flp_id 'QL'
        move.w  (a2)+,(a0)+             ; '5A' oder '5B'

        moveq   #10,d1                   ; max 10 bytes mnam
        sub.w   d5,d1                    ; d5.w lnge >10?
          bge.s fdf_snend
        moveq   #9,d5                    ; yes, take first 10
fdf_snloop
        move.b  (a1)+,(a0)+              ; copy it into map
fdf_snend
        dbra    d5,fdf_snloop

        bra.s   fdf_spend
fdf_sploop
        move.b  #' ',(a0)+               ; now pad with spaces
fdf_spend
        subq.w  #1,d1
          bge.s fdf_sploop

        move.w  sys_rand(a6),(a0)+      ; random number
        clr.l   (a0)+                   ; update count
        move.w  (a2)+,d7                ; get flp_strk
        move.w  (a2)+,d5                ; get flp_scyl
        move.w  d5,d1
        mulu    d4,d1                   ; calculate flp_trak*flp_scyl=flp_totl
        move.w  d1,d0
        sub.w   (a2)+,d0                ; flp_totl-reserved = flp_free
        move.w  d0,(a0)+                ; flp_free
        move.w  d1,(a0)+                ; flp_good
        move.w  d1,(a0)+                ; flp_totl
        move.w  d7,(a0)+                ; flp_strk
        move.w  d5,(a0)+                ; flp_scyl
        move.w  d4,(a0)+                ; flp_trak
        move.w  (a2)+,(a0)+             ; flp_allc
        move.l  #hdr.len,(a0)+          ; flp_eodr
        movea.l a2,a1
        adda.w  (a2)+,a1                ; pointer to fdf_xxtrans
        move.w  (a1)+,d0                ; length of fdf_xxtrans
        subq.w  #$01,d0
fdf_strans
        move.b  (a1)+,(a0)+             ; copy flp_soff, flp_lgph, flp_phlg
        dbf     d0,fdf_strans

; now format and check all the tracks

        lea     flp_gmap(a5),a0          ; set address of map

fdf_tr_loop
        lea     fdd.hlen(a4),a1          ; buffer for 26 sectors
        cmp.w   #9,d5                    ; single sided?
          beq.s fdf_tr_s0                ; ... yes

        move.b  #1,fdd_side(a3)          ; side 1
        bsr     fq_ftrack                ; format and check
          bne.s fdf_tr_bad
fdf_tr_s0
        clr.b   fdd_side(a3)             ; side 0
        bsr     fq_ftrack                ; format and check
          bne.s fdf_tr_bad
        moveq   #$fffffffd,d0            ; ... good cylinder, mark vacant
        bra.s   fdf_tr_mset

fdf_tr_bad
        moveq   #$fffffffe,d0            ; bad track
        sub.w   d5,flp_free(a5)          ; decrement sector counts
        sub.w   d5,flp_good(a5)

fdf_tr_mset
        moveq   #0,d1                    ; set number of map entries/cylinder
        move.w  d5,d1
        divu    #fdf.group,d1

fdf_tr_gloop
        move.b  d0,(a0)                  ; and set all groups good or bad
        addq.l  #3,a0
        subq.w  #1,d1
          bgt.s fdf_tr_gloop

        addq.b  #1,fdd_trak(a3)          ; move on one track
        cmp.b   fdd_trak(a3),d4          ; end of map?
          bgt.s fdf_tr_loop              ; ... no

        move.l  a0,d0
        sub.l   a5,d0
        move.l  d0,fdd_mtop(a4)         ; length of gmap <<<<<<<<<<<-
        lea     flp_gmap(a5),a0
        cmpi.l  #$fdfffffd,(a0)         ; are the first two groups free?
          bne.s fdf_fmtf                ; ... no

        addq.l  #2,a2                   ; fdf.trkl weg
        move.l  (a2)+,(a0)+             ; set it to medium header / directory
        move.l  (a2)+,(a0)+             ; ..first 4 groups
        move.l  (a2)+,(a0)+

        sf      fdd_schk(a3)            ; do not fail please
        clr.l   fdd_mup0(a4)
        clr.l   fdd_mup0+4(a4)
        st      fdd_mup0(a4)
        st      fdd_mup1(a4)
        st      fdd_mup2(a4)

        tst.b   fdd_mode(a4)
          ble.s fdf_3map

        st      fdd_mup3(a4)            ; nur fr HD
        st      fdd_mup4(a4)
        st      fdd_mup5(a4)
fdf_3map
        jsr     fq_flshm(pc)            ; write map sectors (a5 pointer to map)
          bne.s fdf_fmtf                ; ... oops

fdf_done
        st      fdd_schk(a3)            ; change the drive so next open rereads
        assert  flp_good,flp_totl-2
        movem.w flp_good(a5),d1/d2      ; set sector counts flp_good/flp_totl
        move.l  a4,a0
        jsr     gu_rchp
fdf_exit
        move    (a7)+,SR                ; interrupts frei
        movem.l (sp)+,fdf.reg
        tst.l   d0
        rts

fdf_rdon
;-        move.b  #fdd.actm,fdd_actm(a3)   ; ready to stop
        moveq   #err.rdo,d0              ; read only
        bra.s   fdf_exit

fdf_fail
        addq.l  #8,sp                   ; remove a2/a5
        addq.l  #8,sp                   ; remove return and a1
fdf_fmtf
        moveq   #err.fmtf,d0             ; format failed
        bra.s   fdf_done

;+++
; subroutine to format a ATR-track and check it
;       d0..d3  scratch !
;       a1 c    pointer to $3400 buffer / error code
;       a1-a5   preserved
;---
at_ftrack
        movem.l a1/a2/a5,-(sp)
        lea     fdf_offs(a2),a5         ; pointer to fdf.strk
        bra.s   fdf_ft_chk

;+++
; subroutine to format a track and check it
;       d0..d3  scratch !
;       a1 c    pointer to $3400 buffer / error code
;       a1-a5   preserved
;---
fq_ftrack
        movem.l a1/a2/a5,-(sp)
        lea     fdf_strk-fdf_trkl(a2),a5 ; pointer to fdf.strk

fdf_ft_chk
        tst.l   d4                      ; flag fast format ?
          bpl.s fdf_form                ; ..no
        tst.b   fdd_trak(a3)            ; track 1..79 ?
          bgt.s fdf_ffor                ; ..evtl. fast format
fdf_form
        bsr.s   fdf_wtrack               ; set up and write track
          bne.s fdf_fail                 ; ... oops, back to BASIC
fdf_ffor
        clr.b   fdd_sect(a3)
fdf_ft_read
        addq.b  #1,fdd_sect(a3)          ; next sector
        move.l  fdd_sadd(a3),d0
        moveq   #1,d1
        add.b   d0,d1                    ; sector + 1
        cmp.w   (a5),d1                  ; all done?
          beq.s fdf_ft_exit              ; ... yes
;--        movea.l (sp),a1                  ;+
;--        lea     $C0000,a1     ; EPROM (!)
        lea     fdd.hlen+fdf.htrk(a4),a1 ; $200 bytes read buffer
        jsr     fq_rsec                  ; to read
          beq.s fdf_ft_read              ; ... ok
fdf_ft_exit
        movem.l (sp)+,a1/a2/a5
        rts                              ; all ok

; set up and write a track
; (subroutine !)
fdf_wtrack
        lea     fdf_data(pc),a2

        move.w  fdf_trkl-fdf_strk(a5),d3 ; fdf.trkl total length DD / HD

        moveq   #1,d0                    ; first sector
fwt_sloop
        moveq   #0,d1
fwt_rdata
        move.b  (a2)+,d2                 ; get byte to write
        move.b  (a2)+,d1                 ; get number of bytes to write
          blt.s fwt_nsect                ; ... next sector
          bgt.s fwt_wbytes               ; ... genuine
        move.b  fdd_trak(a3),(a1)+       ; track
        move.b  fdd_side(a3),(a1)+       ; side
        move.b  d0,(a1)+                 ; sector
        subq.w  #3,d3
        bra.s   fwt_rdata

fwt_wbytes
        sub.w   d1,d3                    ; a bit off the total
fwt_wbloop
        move.b  d2,(a1)+                 ; byte in buffer
        subq.b  #1,d1
          bgt.s fwt_wbloop
        bra.s   fwt_rdata

fwt_nsect
        addq.b  #1,d0                    ; next sector
        cmp.b   1(a5),d0                 ; all done ?
          bgt.s fwt_fend                 ; ..yes
        ext.w   d1                       ; offset to loop
        add.w   d1,a2
        bra.s   fwt_sloop                ; and next sector

fwt_fend
        move.b  (a2)+,d2                 ; end fill byte
fwt_floop
        move.b  d2,(a1)+
        subq.w  #1,d3
          bgt.s fwt_floop

        move.w  fdf_trkl-fdf_strk(a5),d2 ; fdf.trkl total length DD / HD
        movea.l 4(sp),a1
        jsr     fq_wtrack(pc)            ; write track
        rts
;
fq_fdata
fdf_data
;-        dc.w    fdf.trkl ; track length DD, jetzt in fdf_tab
        dc.b    $4e,60  ; initial gap
fdf_prea
        dc.b    $00,12  preamble
        dc.b    $f5,3   sync
        dc.b    $fe,1   index address mark
        dc.b    $00,0   track, side, sector
        dc.b    $02,1   sector length flag
        dc.b    $f7,1   crc
        dc.b    $4e,22  gap
        dc.b    $00,12  preamble
        dc.b    $f5,3   sync
        dc.b    $fb,1   data address mark
        dc.b    $30,100 data
        dc.b    $30,100 more data
        dc.b    $30,100 more data
        dc.b    $30,100 more data
        dc.b    $30,112 ... 512 bytes altogether
        dc.b    $f7,1   crc
        dc.b    $4e,84  gap
        dc.b    $00,fdf_prea-(*+2)       ; go back to the preamble

        dc.b    $4e,00                   ; fill at end

; +++++++++++++++++ FORMAT DATA +++++++++
; Double Density, 9 sectors, single side
fdf_stab  dc.w      $0200,$0200         ; 02, typ 0, 512 bytes pro sector
          dc.w      '5A'                ; flp_id
          dc.w      $0009,$0009         ; flp_strk, flp_scyl
          dc.w      $0006               ; reserved sectors
          dc.w      $0003               ; flp_allc
          dc.w      fdf_9trans-*        ; $00A2
          dc.w      fdf.trkl
          dc.w      $F800,$0000,$0000,$FDFF,$FFFD,$FFFF ; first 4 groups
; Double Density, 9 sectors, double side
fdf_dtab  dc.w      $0200,$0200         ; 02, typ 0, 512 bytes pro sector
          dc.w      '5A'                ; flp_id
fdf_strk  dc.w      $0009,$0012         ; flp_strk, flp_scyl
          dc.w      $0006               ; flp_totl-flp_free = reserved sectors
          dc.w      $0003               ; flp_allc
          dc.w      fdf_18trans-*       ; $0058
fdf_trkl  dc.w      fdf.trkl
          dc.w      $F800,$0000,$0000,$FDFF,$FFFD,$FFFF
; High Density, 18 sectors, double side
          dc.w      $0201,$0200         ; 02, typ 1, 512 bytes pro sector
          dc.w      '5B'                ; flp_id
          dc.w      $0012,$0024         ; flp_strk, flp_scyl
          dc.w      $0009               ; reserved sectors
          dc.w      $0003               ; flp_allc
          dc.w      fdf_htrans-*        ; $0086
          dc.w      fdf.htrk
          dc.w      $F800,$00F8,$0001,$0000,$00FD,$FFFF
; Extended Density, 10 sectors, double side
;          dc.w      $0402,$0800         ; 04, typ 2, 2048 bytes pro sector
;          dc.w      '5B'                ; flp_id
;          dc.w      $000A,$0014         ; flp_strk, flp_scyl
;          dc.w      $0004               ; reseved sectors
;          dc.w      $0001               ; flp_allc
;          dc.w      fdf_etrans-*        ; $008C
;-          dc.l      $FA0A044D           ; d7
;          dc.w      $F800,$00F8,$0001,$F800,$0200,$0000
;-          dc.w      $0004              ; mulu
fdf_18trans
          dc.w      $0026               ; number of bytes
          dc.w      $0005               ; flp_soff
          dc.w      $0003,$0680,$8386,$0104,$0781,$8487,$0205,$0882,$8588
          dc.w      $0006,$0C01,$070D,$0208,$0E03,$090F,$040A,$1005,$0B11
fdf_9trans
          dc.w      $0026               ; number of bytes
          dc.w      $0005               ; flp_soff
          dc.w      $0003,$0601,$0407,$0205,$0880,$8386,$8184,$8782,$8588
          dc.w      $0003,$0601,$0407,$0205,$0809,$0C0F,$0A0D,$100B,$0E11
fdf_htrans
          dc.w      $0026               ; number of bytes
;gc         dc.w      $0002               ; flp_soff
;gc         dc.w      $0002,$0406,$080A,$0C0E,$1080,$8284,$8688,$8A8C,$8E90
;gc         dc.w      $0103,$0507,$090B,$0D0F,$1181,$8385,$8789,$8B8D,$8F91
          dc.w      $0006               ; flp_soff
          dc.w      $0006,$0C80,$868C,$0107,$0D81,$878D,$0208,$0E82,$888E
          dc.w      $0309,$0F83,$898F,$040A,$1084,$8A90,$050B,$1185,$8B91
;fdf_etrans
;          dc.w      $0016               ; number of bytes
;          dc.w      $0002               ; flp_soff
;          dc.w      $0002,$0406,$0880,$8284,$8688
;          dc.w      $0103,$0507,$0981,$8385,$8789
; +++++++++++++++++++++++++++++++++++++++
; kommt spter in Basic 'FLP_DENSITY':
den_hds
;        move.l  #'EHDS',d0
        move.l  #0+'HDS',d0
        andi.b  #$DF,d2
        moveq   #-$01,d1
den_slop
        cmp.b   d2,d0
          beq.s den_ok
        addq.l  #$01,d1
        lsr.l   #$08,d0
          bne.s den_slop
        moveq   #-$0F,d0        ; ERR_BP
        rts
den_ok
        moveq   #0,d0           ; ERR_ok
        rts
   end

