; Floppy Flush Slave Blocks and Map  V1.00   1988  Tony Tebby QJUMP/Jo 16.12.91
; mit FLP_SEC
; FLP / ATR compatible DD / HD   05.04.92

        section fq

        xdef    fq_chek
        xdef    fq_flsha
        xdef    fq_flsh
        xdef    fq_flshm
        xdef    at_flshm

        xref    fq_figrp
        xref    at_wrtdir
        xref    at_chks
        xref    fq_wsecl

        xref    iou_fdef
        xref    iou_scsr

;-        include 'keys_sys'
        include 'keys_iod'
        include 'keys_sbt'
        include 'keys_qlv'
        include 'keys_err'
        include 'keys_qdos_sms'
        include 'dd_fq_ddlk'
        include 'dd_fq_QL5A'
        include 'mac_assert'
;+++
; Floppy Disk flush slave blocks and map (channel not required)
;
;       d6 c  p drive number msw
;       a3 c  p pointer to linkage block
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map or 0
;
;       status return standard
;---
fq_chek
;+++
; Floppy Disk flush slave blocks and map (channel not required)
;
;       d6 c  p drive number msw
;       a3 c  p pointer to linkage block
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map or 0
;
;       status return standard
;---
fq_flsh
        tst.b   fdd_mup0(a4)             ; map zero changed?
          bne.s fdf_do
        tst.b   fdd_slvl(a3)             ; anything to slave?
          bmi.s fdf_ok                   ; ... no, range zapped
fdf_do
;        tst.w   d3                       ; type of flush?
        or.b    fdd_sec(a3),d3           ; type of flush or sec level
          beq.s fdf_wait                 ; ... unimportant
        move.b  #fdd.flsh,fdd_actm(a3)   ; flush right soon
        tst.b   fdd_sec(a3)              ; sec level high ?
          bne.s fq_flsh                  ; ..yes, flush immediate
        bra.s   fdf_nc                   ; ..no, was retry
fdf_wait
        move.b  #fdd.at17,fdd_actm(a3)   ; count is normal
fdf_nc
        st      fdd_freq(a3)             ; flush required !
        moveq   #err.nc,d0
        rts
fdf_ok
        moveq   #0,d0
        rts

;+++
; Floppy Disk Flush all slave blocks for all drives (incl. ATR)
;
;       d0  s
;       a3 c  p pointer to linkage block
;
;---
fq_flsha
fdfa.reg reg    d6/a4/a5
        movem.l fdfa.reg,-(sp)
        move.w  fdd_maxd(a3),d6  ; start at highest drive
fdf_fdef
        swap    d6
        jsr     iou_fdef         ; find definition
          blt.s fdf_ndef         ; ... none
        move.l  iod_map(a4),d0   ; map
          beq.s fdf_ndef         ; ... none
        tst.b   iod_drst(a4)     ; ok?
          bge.s fdf_ndef         ; ... not this drive
        move.l  d0,a5
        bsr.s   fq_flshd         ; flush FLP / ATR
fdf_ndef
        swap    d6
        subq.w  #1,d6            ; next drive
          bgt.s fdf_fdef
        tas     fdd_slvl(a3)             ; enormous number at bottom of range
        clr.l   fdd_slvh(a3)             ; no top end of range
        movem.l (sp)+,fdfa.reg
        rts

fq_flshd
fdf.reg reg     d1/d2/d3/d6/a0/a1/a2
        movem.l fdf.reg,-(sp)

        assert  fdd.hold,-1
        st      fdd_actm(a3)             ; hold polling task

        move.l  a5,d0                    ; any map?
          beq.s fdf_exit
        move.l  iod_rdln(a4),d0          ; new directory length
        lsl.l   #7,d0
        lsr.w   #7,d0                    ; block byte
        cmp.l   flp_eodr(a5),d0          ; same as old?
          beq.s fdf_drid                 ; ... yes
        move.l  d0,flp_eodr(a5)          ; set directory length
        st      fdd_mup0(a4)             ; and flush first sector of map
fdf_drid
        move.b  iod_drid(a4),d0          ; drive ID
        movem.l fdd_slvl(a3),a0/a1       ; slave block range
        move.l  a1,d3                    ; any top set?
          beq.s fdf_map                  ; ... no
        lea     fdf_fssb(pc),a2          ; action routine
        jsr     iou_scsr(pc)             ; scan slave bloks
        bra.s   fdf_map

;+++
; Floppy Disk flush map (used by fq_fdrv)
;
;       d6 c  p drive number msw
;       a3 c  p pointer to linkage block
;       a5 c  p pointer to map
;
;       status return standard
;---
fq_flshm
        movem.l fdf.reg,-(sp)

fdf_map
        tst.l   fdd_flpl(a3)            ;+ ATRdev ?
          bne   adf_fat                 ;+ ..yes

        moveq   #0,d0
        tst.b   fdd_mup0(a4)             ; map sector zero updated?
          beq.s fdf_exit                 ; ... no

        assert  fdd.hold,-1
        st      fdd_actm(a3)             ; hold poling task
        addq.w  #1,flp_mupd(a5)          ; map updated again
        movea.l a5,a1                   ; map adress, sector 0
        moveq   #$00,d1                 ; start with map sector 0
fdf_mplp
        tst.b   fdd_mupd(a4,d1.w)       ; update map sector d1.w ?
          beq.s fdf_noup                ; ..no
        move.l  d1,d0                   ; log. sector nr
        bsr.s   fdf_wsec
        clr.b   fdd_mupd(a4,d1.w)       ; mark sector d1.w is updated
fdf_noup
        adda.w  iod_sctl(a4),a1         ; + $200
        addq.w  #$01,d1                 ; next map sector
        cmpi.w  #$0008,d1               ; ..last ?
          blt.s fdf_mplp                ; ..no, loop
fdf_exit
        move.b  #fdd.at17,fdd_actm(a3)   ; ..let it go
        sf      fdd_freq(a3)             ; no flush
        movem.l (sp)+,fdf.reg
        tst.l   d0
        rts

; Action routine von iou_scsr (scan slaveblok) FLP/ATR
fdf_fssb
        bclr    #sbt..wrq,sbt_stat(a1)   ; not needing write any more
          beq.s fdff_ok                  ; not that it ever did

        assert  fdd.hold,-1
        st      fdd_actm(a3)             ; hold poling task

        move.w  sbt_phyg(a1),d0
        swap    d0   
        move.b  sbt_phys(a1),d0          ; physical group / sector

        bclr    #7,d0          ;+ dir Kennung weg
          beq.s fdf_nfil       ;+ ..war keine da, normaler file
        jsr     at_wrtdir(pc)  ;+ write dir (a2)->fdd_abuf(a3) od. fdd_rdir(a4)
fdf_nfil

        move.l  a2,a1
fdf_wsec
        jsr     fq_wsecl(pc)             ; write sector, reset fdd_actm(a3)
          beq.s fdff_rts                 ; ..ohne Fehler, sonst
        movem.l d1/d5/d7/a3,-(sp)
        lea     fdf_beep,a3
        moveq   #sms.hdop,d0             ; Jodeln...
        trap    #do.sms2
        movem.l (sp)+,d1/d5/d7/a3
        st      fdd_schk(a3)             ; check again Sam
fdff_ok
        moveq   #0,d0                    ; throw away error sectors
fdff_rts
        rts

fdf_beep dc.b   $0a,8,0,0,$aa,$aa,$01,$14,$c8,$00,$28,$23,$3f,0,1,0

;+++
; ATR Floppy Disk flush FAT
;
;       d6 c  p drive number msw
;       a3 c  p pointer to linkage block
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       status return standard
;---
at_flshm
        movem.l fdf.reg,-(sp)
adf_fat
        moveq   #0,d0
        tst.b   fdd_mup0(a4)             ; map sector zero updated?
          beq.s adf_exit                 ; ... no

        assert  fdd.hold,-1
        st      fdd_actm(a3)             ; hold polling task

        lea     fdd_hfat(a4),a1
        jsr     at_chks(pc)              ; checksum (a1) -> d0.l
        move.l  d0,fdd_chks(a4)

        moveq   #1,d3                    ; group 0, sector 1, DD-FAT 0/3
adf_mplp
        tst.b   fdd_mupd-1(a4,d3.w)     ; update fat sector d3.w-1 ?
          beq.s adf_noup                ; ..no
        clr.b   fdd_mupd-1(a4,d3.w)     ; mark sector d3.w-1 is updated
        move.l  d3,d0                   ; group 0, sector nr 1..9
        bsr.s   adf_wfat                ; 1.+2. FAT schreiben
adf_noup
        adda.w  iod_sctl(a4),a1         ; + $200
        addq.w  #$01,d3                 ; next map sector
        cmpi.w  #$0009,d3               ; ..last ?
          ble.s adf_mplp                ; ..no, 1..9 loop
adf_exit
        bra     fdf_exit

adf_wfat
        move.l  d0,d1                   ; FAT1 sector 1..9
        add.w   ibm_nfat(a5),d1         ; + Anzahl sectoren pro FAT= FAT2
        move.l  d1,-(sp)
        bsr.s   adf_wfd0                ; 1.FAT schreiben
        move.l  (sp)+,d0
        bsr.s   adf_wfd0                ; 2.FAT schreiben
adf_wfrt
        rts
adf_wfd0
        divu    flp_allc(a5),d0
        swap    d0
        bra     fdf_wsec
    end
