; FLP / ATR Floppy Disk Group Handling                       30.12.91  Jo
; ATR combatible, DD / HD

        section fq

        xdef    fq_afgrp
        xdef    fq_algrp
        xdef    fq_figrp
        xdef    fq_trgrp

        xref    iou_cisl
        xref    cv_wfat

        include 'keys_err'
        include 'keys_iod'
        include 'keys_chn'
        include 'keys_hdr'
        include 'dd_fq_ddlk'
        include 'dd_fq_QL5A'
;+++
; Allocate new group     FLP / ATR
;
;       d0 cr   call: sector / file group - return: sector / disk group
;       d6 c  p drive / file ID
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       status returns positive ok, negative standard
;---
fq_algrp
fdag.reg reg    d1-d3/a1/a2
        movem.l fdag.reg,-(sp)
        bsr.l   fdg_comp                 ; make compressed form
        subq.w  #1,d1                    ; first find previous group
        bsr.l   fdfg_find                ; group d0.w=d2.w, map adress a2
          blt.s fdag_exit

        move.w  d0,d3                    ;+ vorige gruppe merken fr ATRdev

        addq.w  #1,d1                    ; now allocate this group
        bsr.l   fdag_vg2                 ; looking from where we got to
          bgt.s fdag_ok                  ; ... found
        bsr.l   fdag_vg0                 ; try again from start of disk
          bgt.s fdag_ok                  ; ... found
        moveq   #err.drfl,d0
        bra.s   fdag_exit                ; drive full
fdag_ok
        bsr.l   fdag_set                 ; (smash d1)
        tst.l   iod_hdrl(a4)             ; ATRdev ?
          bne.s fdag_flp

; nur fr ATRdev
        addq.w  #2,d3                    ;+ FAT offset 2
        sub.w   ibm_clus(a5),d3          ;+ ..als FAT nr
        swap    d3                       ;+ ..in d3.msw
        move.w  d0,d3                    ;+ neue gruppe
        addq.w  #2,d3                    ;+ FAT offset
        sub.w   ibm_clus(a5),d3          ;+ als FAT nr
        move.l  d3,d2                    ;+ FAT adresse / nchste gruppe
        jsr     cv_wfat(pc)              ;+ ..eintragen
        swap    d2                       ;+
        move.w  #$0FFF,d2                ;+ Endflag
        jsr     cv_wfat(pc)              ;+ ..eintragen

fdag_flp
        tst.l   d0
fdag_exit
        movem.l (sp)+,fdag.reg
        rts

;+++
; Allocate or re-allocate first group of new or renamed file
; FLP / ATR compatible
;
;       d0  r   msw 0 / lsw first group
;       d1 cr   old file ID -reallocate(or zero -allocate) / new file ID
;       d5 c  p sub-directory position 
;       d6 c  p drive / sub-directory ID
;       a0 c  p pointer to channel block
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       status return 0 (re-allocate), >0 or err.drfl
;---
fq_afgrp
fdaf.reg reg    d2/d3/a1/a2
        movem.l fdaf.reg,-(sp)
        moveq   #0,d0
        tst.w   d1                       ; allocate or re-allocate?
          beq   fdaf_do                  ; d1=0 allocate
        btst    #11,d1                   ; was it sub-directory?
          beq.s fdaf_rea                 ; ... no, reallocate
        cmpi.w  #1,d6                    ; is it still in a sub-directory?
          bgt.l fdaf_exit                ; ... yes

; re-allocate
fdaf_rea
        move.w  d1,d3                    ; old file id
        subq.w  #1,d1
        swap    d1
        clr.w   d1
        lsr.l   #4,d1                    ; first group in compressed form
        bsr.l   fdfg_find                ; find it
          blt   fdaf_exit
        move.w  d3,d2                    ; old file ID
        move.l  d1,d3                    ; keep old group zero
        bsr     fdaf_flid                ; set new file ID
        move.l  d1,-(sp)
        addq.w  #1,d1                    ; external group
        move.b  chn_drid(a0),d0
        jsr     iou_cisl                 ; change file ids in slave blocks
        subq.w  #1,d1
        swap    d1
        lsr.l   #4,d1                    ; new group zero
        eor.l   d3,d1                    ; d1 is difference

        swap    d1
        swap    d3

        lea     flp_gmap(a5),a2          ; get start of map
;        lea     flp_mtop(a5),a1          ; and top of range
        bsr     fdl_tset                 ; set top of range -> a1
fdrf_loop
        cmp.b   (a2),d3                  ; msb file matches?
          bne.s fdrf_lend                ; ... no
        rol.l   #8,d3
        moveq   #$fffffff0,d2
        and.b   1(a2),d2                 ; and lsn file?
        cmp.b   d3,d2
          bne.s fdrf_l1                  ; ... no
        eor.b   d1,(a2)                  ; ... yes, change the file ID
        rol.l   #8,d1
        eor.b   d1,1(a2)
        ror.l   #8,d1
fdrf_l1
        ror.l   #8,d3
fdrf_lend
        addq.l  #3,a2                    ; next group
        cmp.l   a1,a2
          blt.s fdrf_loop

        moveq   #2,d0
        tst.b   fdd_mode(a4)            ; bei DD FLP0, ATR0
          ble.s fdrf_l2                 ; ..nur 2..0
        moveq   #5,d0                   ; bei HD 5..0
        tst.l   iod_hdrl(a4)
          bne.s fdrf_l2                 ; FLP0
        moveq   #7,d0                   ; ATR0 HD 7..0
fdrf_l2
        st      fdd_mupd(a4,d0.w)       ; alles updaten, je nach fdd_mode
        dbf     d0,fdrf_l2
        moveq   #0,d0
        bra.s   fdaf_ext

fdaf_do
        tst.l   iod_hdrl(a4)
          beq.s fdaa_do

; allocate nur FLP !
        moveq   #0,d2
        move.w  flp_scyl(a5),d2          ; keep clear of track 0
        divu    flp_allc(a5),d2
        bsr.s   fdag_vg1                 ; look for free
          bgt.s fdaf_ok                  ; ... found
        bsr.s   fdag_vg0                 ; try again from start of disk
          ble.s fdaf_err                 ; ..not found, drive full
fdaf_ok
        bsr.s   fdaf_flid
        move.l  d1,-(sp)
        swap    d1
        lsr.l   #4,d1
        bsr     fdag_set                 ; set group
        bra.s   fdaf_ext

; allocate nur ATR !
fdaa_do
        bsr.s   fdag_vg0                 ; look for free
          bgt.s fdaa_ok                  ; ... found, d0.w=d2.w / a2 group nr
fdaf_err
        moveq   #err.drfl,d0
        bra.s   fdaf_exit                ; drive full
fdaa_ok
        bsr.s   fdaf_flid               ; ->d1.w file ID
        move.l  d1,-(sp)
        swap    d1
        lsr.l   #4,d1
        bsr.s   fdag_set                ; set group -> map a2

; erste FAT-nr in Header und FAT eintragen
;s.fdag_set        bsr     cv_mafa                 ; d2 map -> fat
        move.w  d2,chn_opwk+hdr_clus(a0) ; erste FAT nr des files in QL header
        move.w  d2,fdd_clus(a4)         ; ..in fdd_clus(a4) retten

        swap    d2
        move.w  #$0FFF,d2               ; FAT adresse / endflag
        jsr     cv_wfat(pc)             ; ..eintragen

fdaf_ext
        move.l  (sp)+,d1
        addq.w  #1,d1                    ; external group is plus 1!!

fdaf_exit
        tst.l   d0
        movem.l (sp)+,fdaf.reg
        rts

; Set file ID                   FLP / ATR
fdaf_flid
        move.l  d0,d1                    ; group is file id ...
        bset    #11,d1                   ; with msb set
        cmpi.w  #1,d6                    ; unless it is main directory?
          bgt.s fdafi_rts                ; ... no

        tst.l   iod_hdrl(a4)             ; ATRdev ?
          beq.s fdaa_flid                ; ..yes, d5 can be 0

        move.l  d5,d1                    ; ... yes, file id is position
          bgt.s fdafi_srt                ; $40, $80, $C0, ...
        move.l  iod_rdln(a4),d1          ; ... but this is at end of directory
fdafi_srt
        lsr.l   #6,d1
fdafi_rts                               ;  external ID = 2, 3, ...
        rts

fdaa_flid
        move.l  d5,d1                    ; .. yes, file id is position
          bpl.s fdaai_srt                ; $00, $40, $80, $C0, ...
        move.l  iod_rdln(a4),d1          ; .. but this is at end of directory
fdaai_srt
        lsr.l   #6,d1                   ; internal ID = 1, 2, ...
        addq.w  #1,d1                   ; external ID = 2, 3, ...
        rts

; look for vacant group         FLP / ATR
fdag_vg0
        moveq   #0,d2                    ; try from start..
fdag_vg1
        lea     flp_gmap(a5),a2          ; base of map
        adda.w  d2,a2                    ; + group offset
        adda.w  d2,a2
        adda.w  d2,a2
fdag_vg2
;        lea     flp_mtop(a5),a1          ; top of map
        bsr.s   fdl_tset                 ; set top of range -> a1
        move.b  #$FD,d0

fdagv_loop
        cmp.b   (a2),d0                  ; free?
          beq   fdagv_set                ; ..yes, group nr d0.w=d2.w (a2)
        addq.l  #3,a2
        cmpa.l  a1,a2
          blt.s fdagv_loop
        clr.w   d0                       ; no empty groups
        rts

; set a group in the map        FLP / ATR
fdag_set
        swap    d1
        move.b  d1,(a2)+                 ; set file/block in group map
        rol.l   #8,d1
        move.b  d1,(a2)+
        rol.l   #8,d1
        move.b  d1,(a2)+

        move.w  flp_allc(a5),d1
        sub.w   d1,flp_free(a5)          ; one fewer free allocation blocks
        subq.w  #1,iod_free+2(a4)

; Set map / FAT updated         FLP / ATR
fdg_mupdt
        st      fdd_mup0(a4)            ; sector 0 updated,sonst passiert garnix

        tst.l   iod_hdrl(a4)            ; ATRdev ?
          beq.s adg_fatd                ; ..ja

; nur FLP0
        move.l  a2,d1                   ; running pointer+3 to map
        sub.l   a5,d1                   ; - base of map
        subq.w  #1,d1
        divu    iod_sctl(a4),d1         ; d1.w / $200 = 0..5
        st      fdd_mupd(a4,d1.w)
        swap    d1                      ; rest
        subq.w  #2,d1                   ; evtl. voriger sector ?
          bge.s fdag_rts                ; ..nein
        swap    d1
        st      fdd_mupd-1(a4,d1.w)
fdag_rts
        rts

; nur ATR0 / d0, d2 nicht verndern !
adg_fatd
        bsr     cv_mafa         ; d2.w FLP0 group -> d2.w fat-nr
        moveq   #0,d1
        move.w  d2,d1           ; fat-nr
        asr.w   #1,d1           ; /2
        add.w   d2,d1           ; + fat-nr = 1.5 * fat-nr
        addq.w  #1,d1           ; oberes byte
        divu    iod_sctl(a4),d1 ; msw Rest, lsw sector-nr
        cmpi.w  #7,d1           ; ok, im Bereich 0..7
          ble.s adg_lt7
        moveq   #7,d1           ; auf 7 begrenzen
adg_lt7
        st      fdd_mupd(a4,d1.w)
        swap    d1              ; Rest..
        tst.w   d1              ; .. =0 ?
          bne.s adg_rts         ; ..nein, fat-Eintrag liegt in diesem Sektor
        swap    d1              ; ..ja, unteres byte im vorigen Sektor
        st      fdd_mupd-1(a4,d1.w)
adg_rts
        rts

; set flp_mtop(a5)->a1 or flp_ftop(a5),a1
fdl_tset
        movea.l a5,a1                   ; pointer to map
        adda.l  fdd_mtop(a4),a1         ; pointer to top of map/fat + $600/$A00
        rts

;+++
; Find Group  FLP / ATR
;
;       d0 cr   call: sector / file group - return: sector / disk group
;       a5 c  p base address of map
;
;       status return +ve or err.mchk
;---
fq_figrp
fdfg.reg reg    d1/d2/a1/a2
        movem.l fdfg.reg,-(sp)
        bsr.s   fdg_comp                 ; compressed form of file/group
        bsr.s   fdfg_find
        movem.l (sp)+,fdfg.reg
        rts

; routine to find a group in the map
fdfg_find
        lea     flp_gmap+2(a5),a2        ; get start of map+2
;        lea     flp_mtop(a5),a1          ; and top of range
        bsr.s   fdl_tset                 ; set top of range -> a1
fdagf_loop
        cmp.b   (a2),d1                  ; lsb group matches?
          bne.s fdagf_lend
        swap    d1
        cmp.b   -2(a2),d1                ; and msb file?
          bne.s fdagf_l1
        rol.l   #8,d1
        cmp.b   -1(a2),d1                ; and top of group / bottom of file?
          beq.s fdagf_done
        ror.l   #8,d1                    ; restore comparison register
fdagf_l1
        swap    d1
fdagf_lend
        addq.l  #3,a2
        cmp.l   a1,a2
          blt.s fdagf_loop

        moveq   #err.mchk,d0             ; oops, not found
        rts

fdagf_done
        rol.l   #8,d1
        subq.l  #2,a2                    ; set a2 to point to start
fdagv_set
        lea     flp_gmap(a5),a1
        move.l  a2,d2
        sub.l   a1,d2
        divu    #3,d2
        move.w  d2,d0                    ; group number
        rts

; routine to set compressed form of file/group in d1
fdg_comp
        move.w  d6,d1                    ; file ID
        subq.w  #1,d1                    ; -1
        swap    d1
        move.w  d0,d1                    ; get file / group in d1
        lsl.w   #4,d1                    ; and stick them together
        lsr.l   #4,d1
        rts

; map-nr -> fat-nr
cv_mafa
        sub.w   ibm_clus(a5),d2         ; - erste gruppe filebereich
        addq.w  #2,d2                   ; + FAT offset 2 = FAT nr
        rts

;+++
; Truncate groups of file  FLP / ATR compatible
;
;       d1 c    last useful group of file (logical number) -1 for none
;       d6 c  p drive / file
;       a0 c  p channel block
;       a4 c  p pointer to drive definition
;       a5 c  p pointer to map
;
;       status return ok
;---
fq_trgrp
fdtg.reg reg    d1-d3/d6/a1/a2
        movem.l fdtg.reg,-(sp)
        subq.w  #1,d6                    ; file ID in map

        lea     flp_gmap(a5),a2          ; bottom of sector map
;        lea     flp_mtop(a5),a1
        bsr     fdl_tset                 ; set top of range -> a1

        move.l  a1,d3                    ;+ d3.l top of map
        tst.l   iod_hdrl(a4)             ;+ ATRdev ?
          bne.s fdtg_loop                ;+ ..nein, FLP normal
        move.w  ibm_clus(a5),d0          ;+
        adda.w  d0,a2                    ;+
        adda.w  d0,a2                    ;+
        adda.w  d0,a2                    ;+ Zeiger auf 1. gruppe Filebereich
fdtg_loop
        moveq   #0,d0
        move.b  (a2),d0                  ; file msb
        lsl.w   #8,d0
        move.b  1(a2),d0                 ; file lsn / block msn
        ror.l   #4,d0
        cmp.w   d0,d6                    ; is this the right file number?
          bne.s fdtg_next                ; ... no
        swap    d0
        lsr.w   #4,d0
        move.b  2(a2),d0
        cmp.w   d1,d0                    ; is the block off the end of file?
          blt.s fdtg_next                ; ... no
          bgt.s fat_000                  ;+ ..ja, frei machen

        tst.l   iod_hdrl(a4)             ;+ ATRdev ?
          bne.s fdtg_next                ;+ ..nein, nix machen
                                         ;+ ..d1=d0, endflag eintragen
        bsr.s   fdagv_set                ;+ group d0.w=d2.w
        bsr.s   cv_mafa                  ;+ d2 map -> fat
        tst.w   d1                       ;+ erste FAT-nr des files ?
          bne.s fat_001                  ;+ ..nein
        move.w  d2,chn_opwk+hdr_clus(a0) ;+ erste FAT nr des files in QL header
fat_001
        swap    d2                       ;+
        move.w  #$0FFF,d2                ;+ FAT adresse / endflag
        jsr     cv_wfat(pc)              ;+ ..eintragen
        bra.s   fdtg_next                ;+
fat_000                                  ;+
        tst.l   iod_hdrl(a4)             ;+ ATRdev ?
          bne.s fdtg_com                 ;+ ..nein, weiter
        bsr     fdagv_set                ;+
        bsr.s   cv_mafa                  ;+
        swap    d2                       ;+
        clr.w   d2                       ;+ frei
        jsr     cv_wfat(pc)              ;+
fdtg_com
        move.b  #$FD,(a2)                ; ... yes, free the sector
        move.w  flp_allc(a5),d0
        add.w   d0,flp_free(a5)          ; ... one more free
        addq.w  #1,iod_free+2(a4)
        move.l  d1,d0                    ; d1 retten
        bsr     fdg_mupdt                ; map updated (smash d1)
        move.l  d0,d1
fdtg_next
        addq.l  #3,a2                    ; next sector
        cmp.l   d3,a2                    ; d3.l top of map
          blt.s fdtg_loop

        moveq   #0,d0
        movem.l (sp)+,fdtg.reg
        rts
    end
