; QL Floppy disk initialisation  V2.01    1990  Tony Tebby   QJUMP/Jo 15.12.91
;    Sandy / Herbert - Karte
;    mit mdv1_BOOT, mit Miracle Zusatzstecker fr 4 Laufwerke
;    mit iou_mkdr fr FLP/ATR - Version
;    fr DD / HD - Disketten
; !!!!!!!!! TESTversion mit absolut a2 = $C3FC0 !!!!!!!!!!!!

        section fq

        xdef    fq_init

        xref    base

;        xref    ut_procdef
;        xref    fq_proctab
        xref    iou_ddst
        xref    iou_ddlk
        xref    fq_slct

        xref    fq_xint
        xref    fq_poll
        xref    fq_flsha
        xref    fq_sss          ; select drive, seek, set sector (autoboot)

        xref    fq_chek         ; check all slave blocks read
        xref    fq_flsh         ; flush all buffers
        xref    fq_info         ; get occupancy information
        xref    fq_load         ; load
        xref    iou_save        ; save
        xref    fq_trnc         ; truncate
        xref    fq_lcbf         ; locate buffer
        xref    fq_albf         ; locate / allocate buffer
        xref    fq_upbf         ; mark buffer updated
        xref    fq_alfs         ; allocate first sector
        xref    fq_ckop         ; check medium for open operation
        xref    fq_fdrv         ; format drive
        xref    fq_rsecp        ; read sector (physical)
        xref    fq_wsecp        ; write sector (physical)
        xref    fq_wsecl        ; write sector (logical)
        xref    iou_mkdr        ; make directrory (QL5A-version)

        include 'flp1_keys_iod'
        include 'flp1_keys_karte'       ; aktuelle Karten-Version: 'keys_sandy'
        include 'flp1_dd_fq_ddlk'       ; QL Floppy linkage block

;+++
; Initialise DD linkage and get device going.
;
;       status return standard
;---
fq_init
;        lea     fq_proctab,a1            ; extra procedures
;        jsr     ut_procdef

        lea     fq_vect,a3               ; set up dd linkage
        jsr     iou_ddst(pc)

        st      fdd_schk(a3)             ; force check
        st      fdd_drvs(a3)             ; and already stopped
        move.b  #fdd.rnup,fdd_rnup(a3)   ; default runup

        tas     fdd_slvl(a3)             ; very high bottom of range
        move.w  #fdd.maxd,fdd_maxd(a3)   ; max drive = 2 .. 4
        move.w  #fdd.maxt,fdd_maxt(a3)   ; and track +1
        move.b  #%00000011,fdd_maxr(a3)  ; change mode win1_src_atr_, flp1_
        move.b  #$01,fdd_defd(a3)        ; default density HD
        jsr     iou_ddlk(pc)
; speziell fr Sandy/Herbert: Maus finden
;-        lea     base+fdc_adr(pc),a2     ;  $3FC0(pc),a2
        lea     $C3FC0,a2               ; !!!!!!! TEST !!!!!!!!
        move.l  a2,fdd_base(a3)         ;  Basisadresse WD1772 merken
        moveq   #$0E,d0                 ;+ bitmaske Maustasten
        move.b  #sqb.maus,d1            ;+ Mausbyte $80, bit 7 gesetzt
        tst.b   fdc_rst(a2)             ;+ $3FD0 lesen, $3FCC rcksetzen
        and.b   fdc_maus(a2),d0         ;+ Maustasten lesen
        cmpi.b  #$0E,d0                 ;+ keine Taste gedrckt
          beq.s fqi_mitm                ;+ ok, mit Maus
        moveq   #0,d1                   ;+ Mausbyte weg
fqi_mitm
        move.b  d1,fdd_cont(a3)         ;+ merken
        move.b  d1,fdc_cont(a2)         ;+ Maus einschalten oder nicht
; Miracle Zusatzstecker finden
        trap    #0                      ; alles in Supervisor
        ori.w   #$0700,SR               ; ..bitte nicht stren
        moveq   #0,d6                   ; msw: flp-nr 0
        bsr     fq_slct                 ; deselct
        move.b  #$58,fdc_cmd(a2)        ; step_in, no spinup, no verify, 6ms
        moveq   #-1,d0
trm_wtl dbf     d0,trm_wtl              ; warten
        btst    #2,fdc_stat(a2)         ; TR00 - bit gesetzt ?
          beq.s trm_nix                 ; ..nein
        move.b  #6,fdd_plug(a3)         ; mit Stecker
        move.w  #4,fdd_maxd(a3)         ; ..4 Laufwerke flp1_ ... flp4_
trm_nix
        move.b  #$D0,fdc_cmd(a2)        ; forced interrupt
; Autoboot MDV1_BOOT
        move.w  #$4,fdd_time(a3)        ;+ FLP_TIME = $40000, ca. 2.4 sec
        moveq   #0,d0                   ;+ no verify
        move.b  d0,fdd_trak(a3)         ;+ track 0, restore
        move.b  d0,fdd_side(a3)         ;+ side 0
        moveq   #1,d6
        move.b  d6,fdd_selc(a3)
        swap    d6                      ;+ msw: drive 1
;-        trap    #0                      ;+ supervisor now
        jsr     fq_sss(pc)              ;+ select, seek, set sector
          beq.s fqi_ok                  ;+ drive 1 not empty, MDV1_BOOT
        move.l  iod_dnam+2(a3),iod_dnus+2(a3) ;+ drive empty, forget about MDV0
        tas     fdd_nset(a3)            ;+ mark name set
fqi_ok
        move.w  #$2,fdd_time(a3)        ;+ FLP_TIME = $20000, ca. 1.2 sec normal
;        move.b  #fdd.actm,fdd_actm(a3)  ;+ ready to stop
        move.w  #fdd.actm,fdd_drvs(a3)  ;+ $0064
        andi.w  #$D8FF,sr               ;+ user mode
        moveq   #0,d0
        rts

fq_vect
        dc.l    fdd_end+fdd_pend ; length of linkage $300+$40 = $340 FLP0+PAR
        dc.l    fdd.hlen    ; length of physical definition DD/HD $C80
        dc.w    3,'MDV0'    ; device name (usage) fr auto-boot
        dc.w    3,'FLP0'    ; device name (real)

null    dc.w    fq_xint-*   ; external interrupt server     Maus-Dummy-Routine
        dc.w    fq_poll-*   ; polling server
        dc.w    0           ; scheduler server

        dc.w    0           ; io
        dc.w    0           ; open
        dc.w    0           ; close
        dc.w    fq_flsha-*  ; forced slaving
        dc.w    0           ; dummy
        dc.w    0           ; dummy
        dc.w    0           ; format

        dc.w    fq_chek-*   ; check all slave blocks read
        dc.w    fq_flsh-*   ; flush all buffers
        dc.w    fq_info-*   ; get occupancy information
        dc.w    fq_load-*   ; load
        dc.w    iou_save-*  ; save
        dc.w    fq_trnc-*   ; truncate
        dc.w    fq_lcbf-*   ; locate buffer
        dc.w    fq_albf-*   ; locate / allocate buffer
        dc.w    fq_upbf-*   ; mark buffer updated
        dc.w    fq_alfs-*   ; allocate first sector
        dc.w    fq_ckop-*   ; check medium for open operation
        dc.w    fq_fdrv-*   ; format drive
        dc.w    fq_rsecp-*  ; read sector
        dc.w    fq_wsecp-*  ; write sector
        dc.w    fq_wsecl-*  ; write sector (logical position)
        dc.w    iou_mkdr-*  ; make directory (QL5A-version) (new)
        dc.w    -1
    end
