; Floppy Disk Locate Buffer    V2.00    1988   Tony Tebby QJUMP   Jo

        section fq

        xdef    fq_lcbf
        xdef    fq_lcbf1

        xref    fq_figrp
        xref    fq_rsecl

        xref    iou_fisl
        xref    iou_frsl

        include 'flp1_keys_err'
        include 'flp1_keys_sys'
        include 'flp1_keys_hdr'
        include 'flp1_keys_sbt'
        include 'flp1_keys_chn'
        include 'flp1_dd_fq_QL5A'
        include 'flp1_mac_assert'
;+++
; Floppy Disk. Locates a slave block for read or write operations.
; If necessary, it reads the appropriate sector from the disk.
;
;       d3  r   (word) bytes left in buffer
;       d4  r   block/byte
;       d5 c  p file position
;       d6 c  p drive / file number
;       a0 c  p channel block
;       a2  r   pointer to buffer
;       a3 c  p pointer to linkage block
;       a4 c  p pointer to physical definition block
;       a5 c  p pointer to map
;
;       status return standard
;---
fq_lcbf
        move.l  d5,d4                    ; make block / byte form
        asl.l   #7,d4
        lsr.w   #7,d4

fq_lcbf1
fdl.reg reg     a1
;***        movem.l fdl.reg,-(sp)
        move.l  a1,-(sp)
        jsr     iou_fisl(pc)             ; find slave block
          beq.s fdl_done

        jsr     iou_frsl(pc)             ; find a free slave block

;          lea       $bfc80,a1 ;pointer to dummy sb-table
;          lea       $bfd00,a2 ;pointer to dummy slave block

        move.l  d4,d0
        clr.w   d0                       ; sector number
        swap    d0
        divu    flp_allc(a5),d0          ; sector / group form
        jsr     fq_figrp(pc)             ; find group
          blt.s fdl_bad

        assert  0,sbt_phys-1,sbt_phyg-2
        or.l    d0,(a1)+                 ; set physical sector / group
        assert  0,sbt_file-4,sbt_blok-6
        move.w  d6,(a1)+                 ; set file
        swap    d4
        move.w  d4,(a1)+                 ; and block
        swap    d4

        swap    d0
        pea     -8(a1)                   ; backspace a1 and keep it
        move.l  a2,a1
        jsr     fq_rsecl(pc)             ; read sector
        move.l  (sp)+,a1
          bne.s fdl_bad
fdl_done
        move.l  #512,d3                  ; bytes left in buffer
        sub.w   d4,d3
        add.w   d4,a2                    ; pointer position
        bra.s   fdl_exit

fdl_bad
        move.b  #sbt.mpty,sbt_stat(a1)   ; say empty

fdl_exit
;***        movem.l (sp)+,fdl.reg
        move.l  (sp)+,a1
        tst.l   d0
        rts
        end
