; FLP / ATR Floppy Disk Load File   V2.00 1990  Tony Tebby  QJUMP / 23.11.91 Jo
; FLP / ATR compatible iod_hdrl(a4) -> d5.l = $40 / $00
; ATR_CONV 1 or 2 implemented   06.01.92
; DD / HD version               18.03.92

        section fq

        xdef    fq_load

        xref    fq_flsha
        xref    fq_rsecl

        xref    iou_table

        include 'flp1_keys_chn'
;-        include 'flp1_keys_hdr'
        include 'flp1_keys_iod'         ;+
        include 'flp1_dd_fq_ddlk'
        include 'flp1_dd_fq_ql5a'

;+++
; Scatter Load floppy disk file
;
;       d1 cr   input/output byte count
;       d2 c    number of bytes to transfer
;       d6 c  p drive number / file number
;       a0 c  p pointer to channel definition
;       a1 cr   pointer to read/write buffer
;       a3 c  p pointer to linkage block
;       a4    p pointer to physical definition
;       a5    p pointer to map
;
;       status return standard
;---
fq_load
;-fdl.reg reg     d3/d4/d6/d7/a0/a2
fdl.reg reg     d3-d7/a0/a2             ;+
        movem.l fdl.reg,-(sp)

        tst.b   fdd_mup0(a4)     ;V10 our medium up to date ?
          beq.s fdl_do           ; ... yes

        jsr     fq_flsha(pc)     ; ensure medium is up to date (no write ops)
          bne.l fdl_exit
fdl_do
        subq.w  #1,d6            ; file ID is one different in map
        move.l  chn_feof(a0),d7  ; get length
        move.l  iod_hdrl(a4),d5  ;+ inbuilt header length QL5A = $40, ATRdev = 0
        sub.l   d5,d7            ; real length!!
          beq.l fdl_ok           ; =0, fertig
        add.l   a1,d7            ; end address of load
        move.l  a1,a2            ; start address of load

        move    sr,-(sp)        ;+++
        ori.w   #$0700,sr       ;+++

        moveq   #0,d3            ; start looking at track 0
fdl_tr_loop
        moveq   #0,d4            ; start at physical sector 0 (offset), side 0
fdl_se1_loop
        clr.w   d4               ; physical sector 0, side 1
fdl_se0_loop
;-+        move.l  d4,d1            ; used for ATRdev only
        move.l  d4,d0            ; $00,$01,$02,...
          bpl.s fdl_side
        tas     d0               ; $80,$81,$82,...
fdl_side
;-+        tst.w   d5                      ;+ ATRdev ?
;-+          beq.s fdl_notr                ;+ ..yes, no translate
        moveq   #0,d1
        move.w  flp_scyl(a5),d1
        subq.w  #1,d1
fdl_sloop
        cmp.b   flp_lgph(a5,d1.w),d0    ; translate lgph -> phlg
        dbeq    d1,fdl_sloop
fdl_notr
        move.w  d3,d0            ; track
        mulu    flp_scyl(a5),d0  ; * nr of sectors        (upper end d0=0)
        add.w   d1,d0            ; logical sector on drive

        move.l  d0,d2
        divu    flp_allc(a5),d2  ; position in map (upper end is posn in group)
        move.w  d2,d1
        add.w   d2,d2
        add.w   d1,d2            ; address in map

        lea     flp_gmap(a5,d2.w),a1
        move.b  (a1)+,d1         ; get 12 bits of map
        lsl.w   #8,d1
        move.b  (a1)+,d1
        ror.l   #4,d1
        cmp.w   d6,d1            ; is the file the same?
          bne.s fdl_se_next      ; ... no
        swap    d1               ; ... yes
        lsr.w   #4,d1
        move.b  (a1)+,d1         ; get group number
        mulu    flp_allc(a5),d1  ; as sector number
        swap    d2
        add.w   d2,d1                   ;+ sector within group

        lsl.l   #8,d1
        add.l   d1,d1            ; gives address from base of load
          bne.s fdl_sa1          ; not the first sector

        lea     (a2),a1          ; load into start
        move.l  d5,d1                   ;+ offset of start in sector
        bra.s   fdl_ckend

fdl_sa1
        sub.l   d5,d1                   ;+    0 or $40
        lea     0(a2,d1.l),a1    ; set start address (less header)
        moveq   #0,d1            ; and no offset
fdl_ckend
        cmp.l   d7,a1            ; is start of sector off end of file?
          bge.s fdl_se_next      ; ... yes
        move.l  d7,d2            ; end of file
        sub.l   a1,d2            ; amount to read
        add.l   d1,d2            ; corrected
        sub.l   #$200,d2         ; at least a sector?
          blt.s fdl_buff         ; ... no, buffer it

        moveq   #0,d2

        tst.b   fdd_cvsw(a3)            ;+ convert switch
          bne.s fdl_buff                ;+ ..on, convert and use buffer

        tst.w   d1               ; part sector?
          beq.s fdl_rdo          ; ... no

fdl_buff
        move.l  a1,a0
        lea     fdd_buff(a3),a1  ; ... yes, use buffer
        jsr     fq_rsecl(pc)     ; read sector
          bne.s fdl_exit         ; ... oops

        tst.b   fdd_cvsw(a3)            ;+ convert switch
          bne.s fdl_conv                ;+ ..on, convert and use buffer
fdl_nocv                                ;+ ..cv_table not found
        adda.w  d1,a1            ; start copying from here
        add.w   #$200,d2
        sub.w   d1,d2
        bra.s   fdl_plend
fdl_ploop
        move.b  (a1)+,(a0)+
fdl_plend
        dbra    d2,fdl_ploop
        bra.s   fdl_se_next

fdl_rdo
        jsr     fq_rsecl(pc)     ; read sector
          bne.s fdl_exit         ; ... oops

fdl_se_next
        addq.w  #1,d4            ; next physical sector
        cmp.w   flp_strk(a5),d4  ; off end?
          blt   fdl_se0_loop     ; ... no, side0-loop

        bset    #$1F,d4          ; flag side 1
          bne.s fdl_ntrk         ; ..it is

        cmp.w   flp_scyl(a5),d4  ; off end ?
          bne   fdl_se1_loop     ; ...no, side1-loop
fdl_ntrk
        addq.l  #1,d3            ; next track (cylinder)
        cmp.w   flp_trak(a5),d3  ; off end?
          blt.l fdl_tr_loop      ; ... no

        move    (sp)+,sr        ;+++

        move.l  d7,a1            ; end pointer
        move.l  d7,d1
        sub.l   a2,d1            ; amount transferred
fdl_ok
        moveq   #0,d0
fdl_exit
        movem.l (sp)+,fdl.reg
        rts

; ATR_CONV 1 or 2:
fdl_conv
        move.l  a5,-(sp)
        jsr     iou_table(pc)   ; cv_table -> a5
          beq.s fdl_nc          ; ..not there
        adda.w  #$100,a5        ; IBM/Atari -> QL
        adda.w  d1,a1           ; start copying from here
        add.w   #$200,d2
        sub.w   d1,d2
        bra.s   fdl_clend
fdl_cloop
        move.b  (a1)+,d0
        move.b  0(a5,d0.w),(a0)+
fdl_clend
        dbf     d2,fdl_cloop
        moveq   #1,d0           ; cond.code NZ
fdl_nc
        movea.l (sp)+,a5
          bne.s fdl_se_next
        bra.s   fdl_nocv        ; cv_table not found...

    end
