; QL Floppy Polling Routine   V2.00    1990   Tony Tebby QJUMP / Jo 01.12.92

        section fq

        xdef    fq_poll

        xref    fq_flsha
        xref    fq_slct
        xref    fq_fint

        include 'flp1_keys_karte'
        include 'flp1_dd_fq_ddlk'
        include 'flp1_mac_assert'
;+++
; Floppy Polling Interrupt Routine - QL
;---
fq_poll
        tst.b   fdd_drvs(a3)             ; stopped?
          bge.s fdp_rnup                 ; ... no
        tst.b   fdd_freq(a3)             ; flush required?
          beq.s fdp_rts                  ; ... no
        tst.b   fdd_actm(a3)             ; suppressed?
          bge.s fdp_start                ; ... no, startup
fdp_rts
        rts

fdp_rnup
        movea.l fdd_base(a3),a2          ; WD1772
          beq.s fdp_actn                 ; run-up
        subq.b  #1,fdd_drvs(a3)          ; running up timer fdd.rnup -> 0

        tst.b   fdd_actm(a3)             ; suppressed?
          blt.s fdp_rts                  ; ... yes

        assert  fds..mo,7
        move.b  (a2),d0                  ; drive still running?
          bpl.s fdp_rstrt                ; ... no

        move.b  fdd_actm(a3),d0          ; action counter to be decremented?
          ble.s fdp_rts                  ; ... no
        subq.b  #fdd.acts,d0             ; decrement before stop = 1
        tst.b   fdd_freq(a3)             ; flush required?
          beq.s fdp_acts                 ; ..no
        subq.b  #fdd.af17-fdd.acts,d0    ; ..yes, decrement a bit quicker 4-1
          bge.s fdp_acts                 ; fdd.at17 -> 0
        moveq   #0,d0                    ; no count now = 0
fdp_acts
        move.b  d0,fdd_actm(a3)          ; decremented timer
;-        bra.s   fdp_run                  ; keep it running
        rts

fdp_rstrt
        tst.b   fdd_freq(a3)             ; do we need it running?
          beq.s fdp_desl                 ; ... no


fdp_start
        st      fdd_schk(a3)              ; ensure that we check drive again
        move.b  fdd_rnup(a3),fdd_drvs(a3) ; and wait a bit

fdp_run
        movea.l fdd_base(a3),a2           ; WD1772
;-        move.b  $D0,fdc_cmd(a2)           ; force interrupt
;-        rts
        jmp     fq_fint(pc)               ; keep motor running
;-        bra.s   fdp_sel


fdp_actn
        tst.b   fdd_actm(a3)             ; suppressed?
          blt.s fdp_rts                  ; ... yes

        tst.b   fdd_freq(a3)             ; flush required?
          beq.s fdp_stop                 ; ... no

        assert  fds..mo,7
        move.b  (a2),d0                  ; check drive running
          bpl.s fdp_start                ; ... no, start it

        subq.b  #fdd.actf,fdd_actm(a3)   ; countdown to flush  3 wait...
;-          bgt.s fdp_run                  ; keep it running
          bgt.s fdp_rts1

        clr.b   fdd_actm(a3)             ; no count now

        jsr     fq_flsha(pc)            ; -> FLUSH routine

        clr.b   fdd_freq(a3)             ; get ready to stop
        move.b  #fdd.at17,fdd_actm(a3)   ; (1772 motor control timing)
fdp_rts1
        rts

fdp_stop
        assert  fds..mo,7
        move.b  (a2),d0                  ; check drive motor still running
          bpl.s fdp_desl                 ; ... no, stop now

        subq.b  #fdd.acts,fdd_actm(a3)   ; ... countdown to stop  1
          bgt.s fdp_rts1

;        move.b  #fdd.at17,fdd_actm(a3)   ; timed out, get ready to stop again
;        subq.b  #1,fdd_selc(a3)          ; try other drive
;        bgt.s   fdp_sel                  ; OK try 1
;        move.b  #2,fdd_selc(a3)          ; ... or 2
;        bra.s   fdp_sel

fdp_desl
        clr.b   fdd_actm(a3)             ; stopped now
        st      fdd_drvs(a3)             ; yes, really
        sf      fdd_selc(a3)             ; no drive
;-fdp_sel
;-        move.b  fdd_selc(a3),d6          ; select this
        clr.b   d6
        swap    d6
        st      fdd_ctrk(a3)             ; track unknown
        st      fdd_schk(a3)             ; force check
        jmp     fq_slct(pc)              ; -> SELECT drive

    end
