; QL Read track address     1990       Tony Tebby  QJUMP   Jo

        section fq

        xdef    fq_raddr

        xref    fq_restv
        xref    fq_cmd
        xref    fq_stat
        xref    fq_read1s               ;+
;-        xref    ad_setrf
;-        xref    ad_seta

        include 'flp1_keys_karte'       ;+
        include 'flp1_dd_fq_ddlk'

;+++ 
; Read track address. Sets FDD_CTRK. If it fails, it tries to restore.
;
;       d0  r   0 OK, -ve not complete, + error bits set
;       a2 c  p WD1772                  ;+
;
;       status return 0 ok, -ve timed out, +ve error 
;---
fq_raddr
fdra.reg reg    d1/d2/a1
        movem.l fdra.reg,-(sp)
        lea     fdd_rawk(a3),a1          ; use read address work area
        moveq   #10,d1                   ; 10 x versuchen
fdra_loop
        subq.w  #1,d1
          ble.s fdra_exit
        moveq   #fdc.radd,d0             ; read address
        jsr     fq_cmd(pc)
        moveq   #6,d2                   ;+ 6 bytes..
        jsr     fq_read1s(pc)           ;+ ..lesen
          bne.s fdra_loop               ;+ war nix, nochmal
        jsr     fq_stat(pc)
          blt.s fdra_exit               ; timed out
          bne.s fdra_loop               ; nochmal, falls kein timeout

        move.b  fdc_sec(a2),d1          ;+ track steht jetzt in sector-register
        move.b  d1,(a1)                 ;+ ..in fdd_rawk(a3) schreiben
        move.b  d1,fdc_trak(a2)         ;+ ..in fdc_trak(a2) schreiben

fdra_exit
        movem.l (sp)+,fdra.reg
        tst.l   d0
          bne.s fq_restv                 ; restore with verify
        rts

        end
