; QL Floppy Disk Read / Write 1 Sector                   1991/92 Jo
; mit fdd_time(a3)            12.12.91
; fr DD / HD Disketten       28.02.92
; Schleife gendert           30.10.94

          section   fq

          xdef      fq_writ1s
          xdef      fq_read1s

          include   'dd_fq_ddlk'
          include   'keys_karte'

;+++
; Write Sector DD/HD (a1) -> WD1772
;
;         d2.w c    Anzahl bytes schreiben
;         a1   c  p Zeiger auf Puffer
;         a2   c    WD1772
;
;         status return ERR_FE oder ERR_ok
;---
fq_writ1s
wrt_reg   reg       d1/d3/d5/a1/a5
          movem.l   wrt_reg,-(a7)
          move      SR,-(a7)
          ori.w     #$0700,SR
          lea       fdc_data(a2),a5
          moveq     #0,d3               ; bit #0, BUSY
          moveq     #1,d1               ; bit #1, DRQ
          move.l    fdd_time(a3),d0     ; timeout $20000 ca. 1.2 sec
          bra.s     wrtdbf
wrtloop
          btst      d3,(a2)             ; BUSY gesetzt ?    8+4=1.6us
            beq.s   werror              ; ..nein, ERR_FE    12 =1.6us  ->18

          btst      d1,(a2)             ; DRQ gesetzt ?     8+4
            bne.s   wsec                ; ..ja, schreiben   12        ->18
          btst      d1,(a2)             ; DRQ gesetzt ?
            bne.s   wsec                ; ..ja, schreiben
          btst      d1,(a2)             ; DRQ gesetzt ?
            bne.s   wsec                ; ..ja, schreiben

          subq.l    #1,d0               ; Zhler            12
            blt.s   werror              ; ..timeout         12        ->18

          btst      d1,(a2)             ; DRQ gesetzt ?
            bne.s   wsec                ; ..ja, schreiben
          btst      d1,(a2)             ; DRQ gesetzt ?
            bne.s   wsec                ; ..ja, schreiben
wrtlp1
          btst      d1,(a2)             ; DRQ gesetzt ?
            beq.s   wrtloop             ; ..nein, warten
wsec
          move.b    d5,(a5)             ; byte -> fdc_data
wrtdbf
          move.b    (a1)+,d5            ; nchstes byte in d5 puffern
          dbf       d2,wrtlp1           ; 20=2.7us  ->18=2.4us

          moveq     #0,d0               ; ERR_ok
wexit     move      (a7)+,SR
          movem.l   (a7)+,wrt_reg
          tst.l     d0
          rts
werror    moveq     #-$10,d0            ; ERR_FE
          bra.s     wexit

;+++
; Read Sector DD/HD  WD1772 -> (a1)
;
;         d2.w c    Anzahl bytes lesen
;         a1   c  p Zeiger auf Puffer
;         a2   c    WD1772
;
;         status return ERR_FE, ERR_NF oder ERR_ok
;---
fq_read1s
read_reg  reg       d1/d3/a1/a5
          movem.l   read_reg,-(a7)
          move      SR,-(a7)
          ori.w     #$0700,SR
          lea       fdc_data(a2),a5
          moveq     #0,d3               ; bit #0, BUSY
          moveq     #1,d1               ; bit #1, DRQ
          move.l    fdd_time(a3),d0     ; timeout $20000 ca. 1.2 sec
;- 18.03.92         cmpi.w    #6,d2               ; readadr ? 6 bytes
;-                    bne.s   readbf
;-                  lsr.l     #4,d0               ; / 16 = $2000 bei readadr
          bra.s     readbf
readl
          btst      d3,(a2)             ; BUSY gesetzt ?    8+4=1.6us
            beq.s   rerror              ; ..nein, ERR_FE    12 =1.6us  ->18

          btst      d1,(a2)             ; DRQ gesetzt ?     8+4
            bne.s   rsec                ; ..ja, lesen       12        ->18
          btst      d1,(a2)             ; DRQ gesetzt ?
            bne.s   rsec                ; ..ja, lesen
          btst      d1,(a2)             ; DRQ gesetzt ?
            bne.s   rsec                ; ..ja, lesen

          subq.l    #1,d0               ; Zhler            12
            blt.s   rtout               ; ..timeout         12        ->18

          btst      d1,(a2)             ; DRQ gesetzt ?
            bne.s   rsec                ; ..ja, lesen
          btst      d1,(a2)             ; DRQ gesetzt ?
            bne.s   rsec                ; ..ja, lesen
redl1
          btst      d1,(a2)             ; DRQ gesetzt ?
            beq.s   readl               ; ..nein, warten
rsec
          move.b    (a5),(a1)+          ; byte fdc_data -> speicher
readbf
          dbf       d2,redl1            ; 20=2.7us  ->18=2.4us

          moveq     #0,d0               ; ERR_ok
rexit     move      (a7)+,SR
          movem.l   (a7)+,read_reg
          tst.l     d0
          rts
rtout     moveq     #-7,d0              ; ERR_NF timeout
          bra.s     rexit
rerror    moveq     #-$10,d0            ; ERR_FE Lesefehler
          bra.s     rexit

          end
