; QL seek to track      1990       Tony Tebby  QJUMP /  Jo 13.04.91
; step rate DD/HD corrected         17.03.92

        section fq

        xdef    fq_seek
        xdef    fq_rest
        xdef    fq_restv

        xref    fq_cmd
        xref    fq_stat
        xref    fq_busy         ;+
        xref    fq_ckrdy        ;+
        xref    wait80us

        include 'flp1_keys_karte'       ;+
        include 'flp1_dd_fq_ddlk'

;+++
; Seek to track - step rate variable (with or without verification or settle)
; Sets FDD_CTRK.  ( + atomic)
;
;       d0 cr   -1, 0 or fdc.veri / 0 OK, -ve not complete, + error bits set
;       d3 c  p track number
;       d6 c  p msw drive number 1..4
;       a2 c  p WD1772
;       a3 c  p linkage block
;
;       status return zero OK, -ve timed out, + odd error!!
;---
fq_seek
        move.w  d0,-(sp)
        move.b  fdd_trak(a3),d0          ; track required
          beq.s fq_rests                 ; ... 0, restore
        cmp.b   fdd_ctrk(a3),d0          ; there already?
          beq.s fds_ok2                  ; ... yes
fds_dsee
        move.b  d0,fdd_ctrk(a3)
        move.b  d0,fdc_data(a2)          ;+ track -> data-reg
        moveq   #fdc.seek,d0             ; seek
        bra.s   fds_do

;+++
; Restore to track 0 - step rate variable (with verification).
; Sets FDD_CTRK.   ( + atomic )
;
;       d0  r   0 OK, -ve not complete, + error bits set
;       d6 c  p msw drive number 1..4
;       a2 c  p WD1772
;       a3 c  p linkage block
;
;       status return zero OK, -ve timed out, + odd error!!
;---
fq_restv
        moveq   #fdc.veri,d0

;+++
; Restore to track 0 - step variable (with or without verification or settle).
; Sets FDD_CTRK.   ( + atomic )
;
;       d0 cr   -1, 0 or fdc.veri / 0 OK, -ve not complete, + error bits set
;       d6 c  p msw drive number 1..4
;       a2 c  p WD1772
;       a3 c  p linkage block
;
;       status return zero OK, -ve timed out, + odd error!!
;---
fq_rest
        move.w  d0,-(sp)
fq_rests
        clr.b   fdd_ctrk(a3)             ; track zero now
        moveq   #fdc.rest,d0             ; restore
fds_do
        tst.w   (sp)                     ; verify?
          ble.s fds_cmd                  ; ... no
        or.w    (sp),d0                  ; ... yes
fds_cmd
        swap    d6                      ; d6.msw drive number 1..4
        adda.w  d6,a3
        or.b    fdd_stpa-1(a3),d0       ; step rate per drive (DD/HD corrected)
        suba.w  d6,a3
        swap    d6
        move    sr,-(sp)                ;+
        ori.w   #$0700,sr               ;+ atomic
        jsr     fq_cmd(pc)
        jsr     fq_ckrdy(pc)  ;+ NEW !!!
          bne.s fds_cker      ;+ d0.l ok or ERR_FE drive empty (no indexpulses)
        sf      fdd_mpty(a3)  ;+ flag drive not empty
        jsr     fq_busy(pc)
        jsr     fq_stat(pc)
        andi.w  #fds.skok,d0             ; seek errors only
          beq.s fds_done
        bra.s   fds_serr
fds_cker
        st      fdd_mpty(a3)  ;+ flag drive empty
fds_serr
        st      fdd_ctrk(a3)
        move    (sp)+,sr                ;+
        bra.s   fds_ex2
fds_done
        move    (sp)+,sr                ;+

        tst.w   (sp)                    ; settle?
          blt.s fds_ok2                 ; ... no
        move.w  #$00F0,d0               ; wait 240 * 80 us = 19.2 ms
        jsr     wait80us
fds_ok2
        moveq   #0,d0
fds_ex2
        addq.l  #2,sp
        tst.l   d0
        rts
   end
