; QL Floppy select drive/side    --- Sandy ---          02.11.94 Jo
; mit fdd_plug Miracle Zusatzstecker flp1_ ... flp4_
; ATR compatible
; DD / HD version

        section fq

        xdef    fq_slct

        include 'keys_iod'
        include 'keys_karte'
        include 'dd_fq_ddlk'
        include 'mac_assert'
*+++
; Select disk drive and side. Sets FDD_SLCT, Blats FDD_CTRK if new drive.
; Wait for spinup if MO not set. Use fdd_mode(a4) ( S=-1, D=0, H=1 )
;
;       d0   s  scratch
;       d6 c  p msw drive number (1...)
;       a1  u p always FLP0 linkage block
;       a3 c  p FLP0 or ATR0 linkange block
;       a4 c  p phys.def block ( not used if drive number =0 )
;
;       status return NZ if new drive
*---
fq_slct
slct.reg  reg       d1/a1/a2
          movem.l   slct.reg,-(sp)
          movea.l   fdd_base(a3),a2    ; WD1772
          movea.l   a3,a1              ; FLP0 or ATR0 linkage block
          cmpi.l    #'ATR0',iod_dnam+2(a3)
            bne.s   is_flp
          movea.l   fdd_flpl(a3),a1    ; FLP0 linkage block
is_flp    moveq     #$FFFFFFE0,d0      ; nur shugart-bits
          and.b     fdd_cont(a1),d0    ; alles aus
          swap      d6
          tst.b     d6                 ; 0 kein Laufwerk, 1 .. fdd.maxd
            beq.s   contrl
motein
          bset      #3,d0               ; Motor ein
; DD - HD umschalten
          moveq     #iod_iolk,d1        ; =$18
          add.l     a3,d1               ; $18(a3)
          cmp.l     iod_drlk(a4),d1     ; phys def block gesetzt?
            bne.s   fds_dens            ; ..nein, fdd_mode(a4) nicht benutzen
          moveq     #1,d1               ; d1.w = $0001, s.u.
          add.b     fdd_mode(a4),d1     ; -1, 0, 1 -> 0, 1, 2
          lsr.b     #1,d1               ;          -> 0, 0, 1
          move.b    d1,fdc_mode(a2)     ; DD=0 8MHz, HD=1 16MHz
; steprate anpassen
          adda.w    d6,a3
          move.b    fdd_step-1(a3),d1
          tst.b     fdd_mode(a4)
            ble.s   fds_isdd
          move.b    fds_stp(pc,d1.w),d1
fds_isdd
          move.b    d1,fdd_stpa-1(a3)
          suba.w    d6,a3
fds_dens
; doppelstecker setzen
          moveq     #0,d1
          move.b    d6,d1                   ; 1..4
          add.b     fdd_plug(a1),d1         ; +0 oder +6
          or.b      fds_list+1(pc,d1.w),d0  ; Laufwerk-bit(s) setzen
; seite setzen
          or.b      fdd_side(a3),d0     ; Seite 0/1
contrl
          move.b    d0,fdd_cont(a1)     ; aktuelle Einstellung fdc_controll
          move.b    d0,fdc_cont(a2)     ;+
          moveq     #-1,d0
          tst.b     d6
            beq.s   moton_ok            ; flp motor ausschalten
          moveq     #0,d0
          assert    fds..mo,7
          tst.b     fdc_stat(a2)
            bmi.s   moton_ok            ; motor on bit gesetzt, kein spinup
          move.b    fdd_rnup(a3),d0
moton_ok
          move.b    d0,fdd_drvs(a3)
          move.b    d6,d0
          swap      d6                  ; restore d6
          tst.b     d0                  ; any drive ?
            beq.s   fdsl_dsel           ; ..no, deselect
          cmp.b     fdd_ldrv(a1),d0     ; this drive currently selected?
            beq.s   fdsl_exit           ; ... yes
          move.b    d0,fdd_ldrv(a1)     ; immer in FLP0 ddd
fdsl_dsel
          move.b    d0,fdd_selc(a3)     ; ... it is now FLP0 oder ATR0
          st        fdd_ctrk(a1)        ; FLP0 track unknown
          st        fdd_ctrk(a3)        ; FLP0 or ATR0 track unknown
          moveq     #1,d0
fdsl_exit
          movem.l   (sp)+,slct.reg  ; ACHTUNG! condition codes nicht verndern
          rts
fds_list
; bit-nr                      1   2   4           ; flp1_ .. 3
          dc.b      $00,$00,$02,$04,$10,$00       ; fdd_plug = 0
; adresse %                  00  01  10  11       ; flp1_ .. 4
          dc.b      $00,$00,$00,$02,$04,$06       ; fdd_plug = 6
fds_stp
          dc.b      $01,$01,$03,$00     ; 6,12,2,3 -> 12,12,3,6 ms
          end
