; QL Floppy select, seek and set sector   1990  Tony Tebby  QJUMP / Jo

        section fq

        xdef    fq_sss

        xref    fq_slct
        xref    fq_seek
        xref    fq_raddr

        xref    fq_cmd
        xref    fq_stat

        include 'flp1_keys_karte'
        include 'flp1_dd_fq_ddlk'

;+++
; Select drive. If changed, read track address. Seek to track, set sector
; required. If d0 is -ve on entry, there will be a 20ms settle after seek,
; otherwise d0 should be fdc.veri (to verify after seek) or 0.
;
;       d0 cr   -1, 0 or fdc.veri / 0 OK, -ve NC, + error bits set
;       d6 c  p msw drive number
;       a2 c  p WD1772                  ;+
;
;       status return 0 ok, -ve timed out, +ve error 
;---
fq_sss
        move.w  d0,-(sp)                 ; verify flag
        jsr     fq_slct(pc)              ; select drive
        tst.b   fdd_ctrk(a3)             ; track defined?
          bge.s fds_seek
        tst.b   fdd_trak(a3)             ; track zero required?
          beq.s fds_seek                 ; ... yes, it will restore anyway
        jsr     fq_raddr(pc)             ; read track address
          bne.s fds_exit
fds_seek
        move.w  (sp),d0
        jsr     fq_seek(pc)              ; seek to track
          bne.s fds_exit
        move.b  fdd_sect(a3),fdc_sec(a2) ;+ set sector reg
        moveq   #0,d0
fds_exit
        addq.l  #2,sp                    ; remove verify key
        rts

        end
