; QL Floppy check status     1988  Tony Tebby  QJUMP   Jo

        section fq

        xdef    fq_stat                 ; check status of FDC
        xdef    fq_statw
        xdef    fq_fint                 ; force interrupt (status complete)

        xref    fq_cmd

        include 'flp1_keys_err'
        include 'flp1_keys_karte'
        include 'flp1_dd_fq_ddlk'

;+++
; This routine waits timeout $100 for completion and checks the status
; of the controller
;
;       status return 0, ERR.NC or error status bits
;
;---
fq_stat
        move.w  #$0100,d0                ; timeout $100

;+++
; This routine waits timeout d0.w for completion and checks the status
; of the controller
;
;       d0.w c   timeout
;
;       status return 0, ERR.NC or error status bits
;
;---
fq_statw
        btst    #fds..bsy,fdc_stat(a2)  ; still busy?
          beq.s fds_sttr                ; ..no
        subq.w  #1,d0
          bgt.s fq_statw
fds_sttr
        moveq   #fds.rwok,d0             ; read/write ok ?
        and.b   fdc_stat(a2),d0
          beq.s fds_exit                 ; ... yes
        btst    #fds..bsy,d0             ; still busy?
          bne.s fq_fint
fds_exit
        tst.l   d0
        rts

;+++
; Force Interrupt to complete command
;
;       d0  r   ERR.NC
;---
fq_fint
        moveq   #fdc.fint,d0
        bsr.s   fq_cmd(pc)
        moveq   #err.nc,d0
        rts

        end
