; Floppy Disk write sector      1990     Tony Tebby  QJUMP   Jo 26.10.94
; DD/HD
; extra settle HD

        section fq

        xdef    fq_wsecp                 ; write sector to Floppy disk
        xdef    fq_wsecl                 ; write sector to Floppy disk

        xref    fq_setp
        xref    fq_sss
        xref    fq_rest
        xref    fq_cmdwr
        xref    fq_stat
        xref    fq_ckrw
        xref    fq_slct
        xref    fq_writ1s               ;+
        xref    wait80us                ;+

        include 'keys_karte'       ;+
        include 'keys_iod'         ;+
;        include 'keys_sys'
        include 'keys_err'
        include 'dd_fq_ddlk'
        include 'mac_assert'

;+++
; This routine writes a sector to a Floppy disk
;
;       d0 cr   logical block (group/sector) / error code
;       d6 c  p msw drive number (1 to 8)
;       a1 c  p dma address
;       a2      WD1772                  ;+
;       a3 c  p floppy linkage block
;       a4 c  p phys def block
;       a5 c  p map
;
;       status return 0 or ERR.MCHK
;
;---
fq_wsecl
fdw.reg reg     d2/d4/a2                ;+
        movem.l fdw.reg,-(sp)
        jsr     fq_ckrw                  ; check read/write OK
          bne   fdw_exnc
        jsr     fq_setp                  ; set physical sector
        bra.s   fdw_do
;+++
; This routine writes a sector to a Floppy disk for direct sector IO
;
;       d0 cr   cylinder + side + sector / error code
;       d6 c  p msw drive number (1 to 8)
;       a1 c  u address to write from
;       a3 c  p floppy linkage block
;       a4 c  p phys def block
;
;       status return 0 or ERR.MCHK
;
;---
fq_wsecp
        assert  fdd.hold,-1             ;+
        st      fdd_actm(a3)            ;+ hold polling task (exept runup)
        move.l  d0,fdd_sadd(a3)         ;+ sector address
        jsr     fq_slct(pc)             ;+ select drive/side/motor on
fdwp_rnup
        tst.b   fdd_drvs(a3)            ;+
          bgt.s fdwp_rnup               ;+
        bsr.s   fdwp_wsec
          bne.s fdwp_err
        adda.w  iod_sctl(a4),a1
fdwp_err
        move.b  #fdd.at17,fdd_actm(a3)  ;+ ???
        rts
fdwp_wsec
        movem.l fdw.reg,-(sp)
        bra.s   fdw_dor

;+++
; This routine writes sectors to a Floppy disk
;
;       d0 cr   sector position track+side+sector / error code
;       d6 c  p msw drive number (1 to 8)
;       a1 c  p dma address
;       a2      WD1772                  ;+
;       a3 c  p floppy linkage block
;       a4 c  p phys def block
;
;       status return 0 or ERR.MCHK
;
;---
fq_wsec
        movem.l fdw.reg,-(sp)
fdw_do
        move.l  d0,fdd_sadd(a3)          ; sector address
fdw_dor
        movea.l fdd_base(a3),a2
        moveq   #3,d4                    ; retry counter
fdw_sss
        moveq   #fdc.veri,d0             ; verify on seek (extra settle)
        jsr     fq_sss(pc)               ; select and seek
          bne.s fdw_mchk
        moveq   #fdc.wsec,d0             ; write sector, no precomp $AA
        tst.b   fdd_mode(a4)            ;+ mode DD oder HD ?
          ble.s fdw_sd                  ;+ ..nur bei HD
        move.b  fdd_prec(a3),d2
        cmp.b   fdd_trak(a3),d2         ;+ kleiner Spur 40 ?
          bge.s fdw_set                 ;+ ..ja, no precomp
        moveq   #fdc.wsep,d0            ;+ write sector, precomp $A8
fdw_set
        ori.b   #fdc.veri,d0            ;+ settle 15/2 ms
fdw_sd                                  ;+
        jsr     fq_cmdwr(pc)
        move.w  iod_sctl(a4),d2         ;+ $200 bytes/sector normal
        jsr     fq_writ1s(pc)           ;+
          bne.s fdw_rtry                ;+
        jsr     fq_stat(pc)              ; wait for status at end of command
        move.l  d0,d2                   ; d0 retten
        moveq   #8,d0                   ; 8x80 us = 640 us
        jsr     wait80us(pc)            ; pause 600 us to remove tunnel erase
;                                         (was ist denn das ???)
        move.l  d2,d0
          beq.s fdw_exit
fdw_rtry
        subq.b  #1,d4                    ; retry counter
          ble.s fdw_mchk
        moveq   #0,d0
        jsr     fq_rest(pc)              ; restore
        bra.s   fdw_sss                  ; and re-seek

fdw_exit
fdw_exnc
        movem.l (sp)+,fdw.reg
        tst.l   d0
        rts

fdw_mchk
        moveq   #err.mchk,d0
        bra.s   fdw_exit

;fdw_nc
;        moveq   #err.nc,d0               ; wait for dma
;        bra.s   fdw_exnc

        end
