; QL Floppy Disk write track  V2.00    1990     Tony Tebby  QJUMP/Jo 26.10.94
; DD / HD

        section fq

        xdef    fq_wtrack                ; write track to Floppy disk

        xref    fq_sss

        include 'flp1_keys_karte'
        include 'flp1_keys_err'
        include 'flp1_keys_iod'         ;+
        include 'flp1_dd_fq_ddlk'

;+++
; This routine writes a track to a QL Floppy disk
;                             using the sector address in (a3)
; 1 Takt 7.5MHz = 133.333 ns
;
;       d2 c s  word number of bytes for 1 track  fdf.trkl
;       d6 c  p msw drive number (1 to 8)
;       a1 c  p address to write from
;       a2      WD1772                  ;+
;       a3 c  p floppy linkage block
;       a4 c  p dummy phys.def (FORMAT) ;+
;
;       status return 0 or ERR.MCHK
;
;---
fq_wtrack
fdwt.reg reg    d1-d5/a0-a2/a5
        movem.l fdwt.reg,-(sp)

        movea.l fdd_base(a3),a2
        moveq   #-1,d0                   ; settle after seek
        jsr     fq_sss(pc)               ; select and seek
          bne.s fdwt_mchk

        movea.l fdd_base(a3),a2
        lea     fdc_data(a2),a5
        subq.w  #2,d2               ; bytezhler -1

        move.b  (a1)+,d5            ; 1.byte holen
        move.l  fdd_time(a3),d0     ; timeout $20000
        lsl.l   #2,d0               ; $80000
        moveq   #fdc.wtrk,d4        ; write track, no precomp $FA
        tst.b   fdd_mode(a4)        ; 'S', 'D' immer ohne precomp
          ble.s fdwt_wtrk
        move.b  fdd_prec(a3),d1
        cmp.b   fdd_trak(a3),d1     ; ab Spur 40..
          bge.s fdwt_wtrk
        moveq   #fdc.wtrp,d4       ; write track, mit precomp $F8
fdwt_wtrk
        moveq   #0,d3               ; bit #0, BUSY
        moveq   #1,d1               ; bit #1, DRQ
        move.b  d4,(a2)             ; write track $FA oder $F8
waitl0
        moveq   #3,d4               ; DRQ, BUSY gesetzt ?
        and.b   (a2),d4
        cmpi.b  #3,d4
          beq.s fdwt_st             ; fdc.wtrk accepted, start
        subq.l  #1,d0
          bgt.s waitl0              ; ..warten
        bra.s   fdwt_mchk           ; timeout (?)
fdwt_st
        move.l  fdd_time(a3),d0
        bra.s   wsec
wrtloop
        btst    d3,(a2)             ; BUSY gesetzt ?    8+4=1.6us
          beq.s fdwt_done           ; ..nein, fertig    12 =1.6us  ->18

        btst    d1,(a2)             ; DRQ gesetzt ?
          bne.s wsec                ; ..ja, schreiben
        btst    d1,(a2)             ; DRQ gesetzt ?
          bne.s wsec                ; ..ja, schreiben
        btst    d1,(a2)             ; DRQ gesetzt ?
          bne.s wsec                ; ..ja, schreiben

        subq.l  #1,d0               ; Zhler            12
          blt.s fdwt_mchk           ; ..timeout         12        ->18

        btst    d1,(a2)             ; DRQ gesetzt ?
          bne.s wsec                ; ..ja, schreiben
        btst    d1,(a2)             ; DRQ gesetzt ?
          bne.s wsec                ; ..ja, schreiben
        btst    d1,(a2)             ; DRQ gesetzt ?
          beq.s wrtloop             ; ..nein, warten
wsec
        move.b  d5,(a5)             ; byte -> data reg FDC
        move.b  (a1)+,d5            ; nchstes byte in d5 puffern
        dbf     d2,wrtloop          ;                   20=2.7us  ->18=2.4us
fdwt_done
        moveq   #%00001111,d0       ; CRC, LOST DATA, DRQ, BUSY
        and.b   (a2),d0
          bne.s fdwt_mchk
fdwt_exit
        movem.l (sp)+,fdwt.reg
        rts

fdwt_mchk
        moveq   #err.mchk,d0
        bra.s   fdwt_exit

        end
