;  ram0 mit mdv0 formatieren                      1991 Jo

          section   rd

          xdef      rd_fmdv

          include   'flp1_dd_rd_ddlk'

;+++
; Routine fr 'FORMAT RAM0_MDV0'
;
;         d1.w c    mdv-nr
;         d2-d7     scratch
;         a0   c  p heap $20E10 Lnge
;         a1-a4     scratch
;         a5   c  p Zeiger auf Ramdisk $B0 + 4*d1.w(a3)
;         a6   c  p SV_BASE ( $28000 )
;
;         status return ERR_FF oder ERR_ok
;---
rd_fmdv
          lea       rdd_map(a0),a1      ; 8(a0) ab hier Ramdisk Sektor 0
          move.l    a1,(a5)             ; ..in $AC(a3) eintragen
          move.l    a1,d3
          st        rdl_form(a1)        ; $0B(a1) flag ramdisk formatiert
          move.w    #$00FE,d0           ; 255 x
L07A0     st        rdl_flnr+1(a1)      ; $0D Filenr $FF 'bad sector'
          adda.w    #$0210,a1
          dbf       d0,L07A0
          move.l    a1,d5               ; merken
          lea       -$0830(a1),a4       ; 4 Sektoren unterhalb Ende als 'map'
          move.l    d3,(a4)+            ; 'map' selbst in map
L07AE
          tst.b     $00EE(a6)           ; SV_MDRUN
            bne.s   L07AE               ; ..warten
          ori.w     #$0700,SR           ; Interrupts aus
L07B8     dbne      d0,L07B8            ; warten
          movea.l   #$00018020,a3      ; PC_MCTRL mdv control/status; IPC status
          moveq     #$FFFFFFE7,d0       ; % 1110 0111
          and.b     $00A0(a6),d0        ; SV_TMODE
          ori.b     #$10,d0
          move.b    d0,-$001E(a3)       ; = $18002 PC_TCTRL transmit control
          move.b    d0,$00A0(a6)
          moveq     #$02,d6             ; Anzahl Versuche = 3x
          bsr       mdv_ein             ; mdv d1.w motor on smash d0-d2
mdv_read
          movea.l   #$00018020,a3
          move.l    d5,-(sp)
          bsr       mdv_rall            ; ganzes Bndchen lesen
          move.l    (sp)+,d5
          moveq     #$00,d4             ; Zhler Blcke gelesen
          moveq     #$00,d7             ; Zhler Blcke mit Fehler
          movea.l   d5,a4
          suba.w    #$0830-4,a4         ; Puffer fr temp-map
          cmpi.b    #$FF,rdd_map+rdl_flnr+1(a0) ; $08+$0C+1=$15, Sektor 0 ok ?
            beq.s   mdv_erff                    ; ..Sektor 0 Fehler -> ERR_FF
          moveq     #-$01,d1
file_loop
          addq.w    #$01,d1             ; File-Nr gesucht
          cmpi.b    #$F8,d1             ; hchste File-Nr mdv-map Sektor 0
            beq.s   mdv_file
          moveq     #-$01,d2
block_loop
          addq.w    #$01,d2             ; Block-Nr gesucht
          lea       rdd_map(a0),a1          ; $0008(a0)
          lea       rdd_map+rdl.end(a0),a2  ; $0018(a0)
          move.w    #$00FE,d3
          moveq     #$00,d0
map_loop
          move.b    (a2)+,d0            ; File-Nr aus map
          cmp.b     (a2)+,d2            ; Block-Nr aus map richtig ?
            bne.s   L0818               ; ..nein
          cmp.b     d0,d1               ; richtige File-Nr ?
            beq.s   L0822               ; ..ja
L0818     adda.w    #rdl.nxts,a1        ; nchster Sektor +$0210
          dbf       d3,map_loop         ; weitersuchen
          bra.s     file_loop
L0822
          cmp.b     rdl_flnr+1(a1),d1   ; File-Nr
            bne.s   L082E               ; ..falsch
          cmp.b     rdl_blnr+1(a1),d2   ; Block-Nr
            beq.s   L0846               ; ..richtig
L082E     addq.w    #$01,d7             ; Anzahl fehlerhafte Sektoren
          st        rdl_flnr+1(a1)      ; ..als fehlerhaft $FF kennzeichnen
          tst.w     d6                  ; noch Versuche frei ?
            bgt.s   L0846               ; ..ja
          move.b    d1,rdl_flnr+1(a1)   ; ..nein, aufgeben
          move.b    d2,rdl_blnr+1(a1)
          st        rdl_err(a1)         ; ..und kennzeichnen $0A(a1)
L0846
          addq.w    #$01,d4             ; Anzahl Sektoren
          tst.b     d2                  ; 1. Block des Files ?
            bne.s   L0856               ; ..nein
          cmp.l     d5,a4               ; a4 zu gro ?
            bge.s   mdv_erff            ; ..Katastrophe
          move.l    a1,(a4)+            ; 1. Block in map eintragen
          movea.l   a1,a3               ; merken fr 2... Block
          bra.s     block_loop
L0856
          move.l    a1,(a3)             ; Link 2... Block
          movea.l   a1,a3               ; Link nchster Block
          bra.s     block_loop
mdv_erff
          subq.w    #$01,d6
            bge     mdv_read            ; nochmal versuchen..
          moveq     #-$0E,d0            ; ERR_FF
          bra       mdv_done
mdv_file
          tst.w     d7                  ; Anzahl fehlerhafte Sektoren
            beq.s   L0874               ; ..keine, ok
          subq.w    #$01,d6             ; nochmal versuchen ?
            bge     mdv_read            ; ..ja
L0874
          movea.l   a0,a4                    ; 0(a0) Zeiger auf freien Block
          lea       rdd_map+rdl.nxts(a0),a1  ; $0218(a0) Sektor 1 link
          lea       rdd_map+rdl.end+2(a0),a2 ; $001A(a0) Sektor 1 map
          moveq     #1,d0               ; Sektor 0 mitzhlen
          move.w    #$00FE,d3
L0884     cmpi.b    #$F8,(a2)           ; Block frei oder "defekt" ?
            bcs.s   L0890               ; ..nein
          addq.w    #$01,d0             ; ..ja, zhlen
          move.l    a1,(a4)             ; link in (a4)
          movea.l   a1,a4               ; nchster Block
L0890     adda.w    #rdl.nxts,a1        ; + $210
          addq.l    #2,a2
          dbf       d3,L0884

          add.w     d0,d4               ; freie + "defekte" + belegte Blcke
          move.w    d0,rdd_free(a0)
          move.w    d4,rdd_totl(a0)
          move.w    d4,d1
          sub.w     d7,d1               ; Anzahl gut formatiert
          move.w    d4,d2               ; Anzahl alle formatiert ( 255 )

          movea.l   d5,a2
          suba.w    #$0830,a2              ; hier steht temp-ram-map
          lea       rdd_map+rdl.end(a0),a1 ; hier hin kopieren
          movea.l   a1,a4                  ; ram-map wird gleich gebraucht
          moveq     #$7E,d3                ; ($7E+1) * 4 = $1FC
mdv_cp0   move.l    (a2)+,(a1)+            ; ram-map nach unten kopieren
          dbf       d3,mdv_cp0
          clr.l     (a1)                   ; letztes Langwort = 0 !

; Fehlerhafte Files mit '*' markieren
          tst.w     d7                  ; Fehlerhafte Blcke ?
            beq.s   mdv_anok            ; ..nein, gleich Dir kopieren
          addq.l    #8,a4               ; Zeiger auf 1.File
mdv_anys
          move.l    (a4)+,d3            ; d3.l zeigt auf 1.Block des Files
            beq.s   mdv_anok
          movea.l   d3,a1               ; a1 zeigt auf File-Nr n+1 - Link
mdv_flo
          tst.b     rdl_err(a1)         ; Flag Fehler von mdv-map Analyse
            bne.s   mdv_rerr
mdv_fcon
          move.l    (a1),d0             ; letzter Block des Files ?
            beq.s   mdv_anys            ; ..ja, nchster File
          movea.l   d0,a1
          bra.s     mdv_flo
mdv_rerr
          movea.l   d3,a2
          adda.w    #$001E,a2           ; zeigt auf string Filename
          move.w    (a2),d0             ; Lnge Filename
          addq.w    #1,d0
          cmpi.w    #$24,d0             ; Filename wird zu lang..
            bge.s   mdv_fcon
          move.w    d0,(a2)+
          move.b    #'*',-1(a2,d0.w)    ; Fehlerflag '*' eintragen
          bra.s     mdv_fcon
; Root-Dir aus Fileheadern zusammensuchen
mdv_anok
          lea       rdd_map+rdl.end+4(a0),a4      ; root-Dir in map
          movea.l   (a4),a3             ; a3 zeigt auf root-Dir, a4 auf 0. File
          move.l    rdl.end(a3),d6      ; Lnge Root-Dir in bytes
hdr_bloo
          lea       rdl.end(a3),a2
          moveq     #7,d3               ; max 8 Dir-Eintrge pro Block
hdr_loop
          move.l    (a4)+,d0            ; 1..n File 1.Block
            beq.s   mdv_cldr            ; ram-map leer, Rest lschen
          movea.l   d0,a1
          adda.w    #rdl.end,a1         ; Fileheader
          moveq     #$0F,d0             ; $10 * 4 = $40
mdv_head  move.l    (a1)+,(a2)+         ; Header in Dir kopieren
          dbf       d0,mdv_head
          dbf       d3,hdr_loop         ; max 8 Header pro Dir-Block
          move.l    (a3),d0             ; nchster Dir-Block
            beq.s   mdv_done            ; nanu ?
          movea.l   d0,a3
          bra.s     hdr_bloo
; Rest Root-Dir lschen
mdv_cldr
          moveq     #0,d5
hdr_clo2
          moveq     #$0F,d0
hdr_clo1  move.l    d5,(a2)+            ; 1 Dir-Eintrag $40 bytes lschen
          dbf       d0,hdr_clo1
          dbf       d3,hdr_clo2         ; max 8 Eintrge pro Block
          move.l    (a3),d0             ; letzter Block des mdv-Dir ?
            beq.s   mdv_done            ; ..ja
          movea.l   d0,a3               ; ..nein, weiter lschen
          lea       rdl.end(a3),a2
          moveq     #7,d3
          bra.s     hdr_clo2
mdv_done
          movem.l   d0-d2,-(a7)
          movea.l   #$00018020,a3
          bsr       mdv_aus
          moveq     #$FFFFFFE7,d0
          and.b     $00A0(a6),d0
          move.b    d0,-$001E(a3)
          move.b    d0,$00A0(a6)
          andi.w    #$F8FF,SR
          movem.l   (a7)+,d0-d2
          move.l    d0,d4
            beq.s   L097E
          clr.l     (a5)                ; $AC+4*ramnr(a3) abmelden
          moveq     #$19,d0             ; MT_RECHP
          trap      #$01                ; Ramdisk entfernen
          move.l    d4,d0
L097E     rts

; ganzes Bndchen lesen
mdv_rall
rall_reg  reg       d6/a0/a5
          movem.l   rall_reg,-(sp)
          moveq     #-$01,d6
L0986     dbf       d6,L0986
          move.w    d6,(sp)
          suba.w    #$0010,sp
L0990     move.w    #$0120,$000E(sp)
L0996     subi.w    #$0020,$000E(sp)
L099C     subq.w    #$01,$000E(sp)
            blt.s   L09EA
          movea.w   $0000012A,a2        ; MD_SECTR
          movea.l   sp,a1
          jsr       $4000(a2)
          bra.s     L0996               ; bad medium
          bra.s     L099C               ; bad sector header
          andi.w    #$00FF,d7           ; d7.w Sektor-Nr
          move.w    $0010(sp),d6
            bpl.s   L09BE
          move.w    d7,$0010(sp)
L09BE     cmp.w     d7,d6
            beq.s   L09EA
          mulu      #rdl.slen+rdl.end,d7          ; #$0210
          movea.l   $0014(sp),a0                  ; rdd_heap
          lea       rdd_map+rdl.end(a0,d7.l),a1   ; $08+$10 = $18
          cmpi.b    #$FF,rdl_flnr+1-rdl.end(a1)   ; $0C+1-$10 = -$03(a1)
            bne.s   L0990                         ; schon gelesen, weiter
          movea.w   $00000124,a2        ; MD_READ
          jsr       $4000(a2)
          bra.s     L0990               ; failed
          move.b    d1,rdl_flnr+1-rdl.nxts(a1)    ; -$0203(a1)
          move.b    d2,rdl_blnr+1-rdl.nxts(a1)    ; -$0201(a1)
          bra.s     L0990
L09EA     adda.w    #$0010,sp
          movem.l   (sp)+,rall_reg
          rts
; mdv ein / aus
mdv_ein
          moveq     #$03,d2   ; d1.w mdv-nr
          subq.w    #$01,d1
          bra.s     L09FE
mdv_aus
          moveq     #$02,d2
          moveq     #$07,d1
L09FE
          move.b    d2,(a3)
          moveq     #$3C,d0
          ror.l     d0,d0
          andi.b    #$01,d2
          move.b    d2,(a3)
          moveq     #$3C,d0
          ror.l     d0,d0
          moveq     #$02,d2
          dbf       d1,L09FE
          rts
    end
