; QL ram disk initialisation  V2.01    1990  Tony Tebby   QJUMP/Jo 09.12.91

        section rd

        xdef    rd_init

        xref    iou_ddst
        xref    iou_ddlk

;        xref    rd_chek         ; check all slave blocks read
;        xref    rd_flsh         ; flush all buffers
        xref    rd_info         ; get occupancy information
        xref    iou_load        ; load
        xref    iou_save        ; save
        xref    rd_trnc         ; truncate
        xref    rd_lcbf         ; locate buffer
        xref    rd_albf         ; locate / allocate buffer
;        xref    rd_upbf         ; mark buffer updated
        xref    rd_alfs         ; allocate first sector
        xref    rd_ckop         ; check medium for open operation
        xref    rd_fdrv         ; format drive
;        xref    rd_rsecp        ; read sector (physical)
;        xref    rd_wsecp        ; write sector (physical)
;        xref    rd_wsecl        ; write sector (logical)
        xref    iou_mkdr        ; make directory

        include 'flp1_keys_iod'
        include 'flp1_keys_karte'       ; aktuelle Karten-Version: 'keys_sandy'
        include 'flp1_dd_rd_ddlk'       ; QL Ram linkage block

;+++
; Initialise DD linkage and get device going.
;
;       status return standard
;---
rd_init
        lea     rd_vect(pc),a3            ; set up dd linkage
        jsr     iou_ddst(pc)
        jmp     iou_ddlk(pc)

rd_vect
        dc.l    rdd_end     ; length of linkage             $00F0
        dc.l    rdd.plen    ; length of physical definition $0050
        dc.w    3,'RAM0'    ; device name (usage)
        dc.w    3,'RAM0'    ; device name (real)

null    dc.w    0           ; external interrupt server
        dc.w    0           ; polling server
        dc.w    0           ; scheduler server

        dc.w    0           ; io
        dc.w    0           ; open
        dc.w    0           ; close
        dc.w    0           ; forced slaving
        dc.w    0           ; dummy
        dc.w    0           ; dummy
        dc.w    0           ; format

        dc.w    0           ; $50 check all slave blocks read
        dc.w    0           ; $56 flush all buffers
        dc.w    rd_info-*   ; $5C get occupancy information
        dc.w    iou_load-*  ; $62 load
        dc.w    iou_save-*  ; $68 save
        dc.w    rd_trnc-*   ; $6E truncate
        dc.w    rd_lcbf-*   ; $74 locate buffer
        dc.w    rd_albf-*   ; $7A locate / allocate buffer
        dc.w    0           ; $80 mark buffer updated
        dc.w    rd_alfs-*   ; $86 allocate first sector
        dc.w    rd_ckop-*   ; $8C check medium for open operation
        dc.w    rd_fdrv-*   ; $92 format drive
        dc.w    0           ; $98 read sector
        dc.w    0           ; $9E write sector
        dc.w    0           ; $A4 write sector (logical position)
        dc.w    iou_mkdr-*  ; $AA make directory (QL5A - Version)
; never forget...
        dc.w    -1          ; endflag
        end





