; IO buffering   V2.02     1987  Tony Tebby   QJUMP  / Jo 28.11.91
; FLP und ATR compatibel

        section iou

        xdef    iou_fmul
        xdef    iou_fmlw
        xdef    iou_flin
        xdef    iou_smul
        xdef    iou_smlw

        xdef    iou_fden
        xdef    iou_fde0
        xdef    iou_sden
        xdef    iou_sde0

        xdef    iou_tabl     ; get absolute address of cv_table -> a5

        include 'keys_err'
;-        include 'keys_k'
        include 'keys_iod'
;-        include 'keys_hdr'
        include 'keys_chn'
        include 'keys_qdos_ioa'
        include 'dd_fq_ddlk'       ;+
        include 'keys_cv'

;+++
; Fetch directory entry (atomic) d7 bytes starting at beginning of entry.
; CHN_SDPS and CHN_SDID must be valid.
;
;       d1  u   byte count
;       d6 c  p drive number / (file id)
;       d7 cr   amount to buffer / unbuffer
;       a0 c  p pointer to channel block
;       a1 cr   buffer address
;       a2   s  internal buffer address
;       a3 c  p linkage block address
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       status return standard
;---
iou_fde0
        movem.l d5/d6,-(sp)
        move.l  chn_sdps(a0),d5          ; start
        bra.s   ifdw_do

;+++
; Fetch directory entry (atomic) d7 bytes starting at byte d4 of entry.
; CHN_SDPS and CHN_SDID must be valid.
;
;       d1  u   byte count
;       d4 c  p byte position (long)
;       d6 c  p drive number / (file id)
;       d7 cr   amount to buffer / unbuffer
;       a0 c  p pointer to channel block
;       a1 cr   buffer address
;       a2   s  internal buffer address
;       a3 c  p linkage block address
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       status return standard
;---
iou_fden
        movem.l d5/d6,-(sp)
        move.l  chn_sdps(a0),d5          ; start
        add.l   d4,d5
ifdw_do
        move.w  chn_sdid(a0),d6          ; sub-directory
        bsr.s   ifw_do
        movem.l (sp)+,d5/d6
        rts

;+++
; Fetch multiple bytes and wait, d7 bytes starting at byte d5
; ( used only for directory fetch bytes )
;       d1  u   byte count
;       d4    p block / byte buffer position
;       d5 cr   file position
;       d6 c  p drive number / sub-directory or file id
;       d7 cr   amount to buffer / unbuffer
;       a0 c  p pointer to channel block
;       a1 cr   buffer address
;       a2   s  internal buffer address
;       a3 c  p linkage block address
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       status return standard
;---
iou_fmlw
ifw_do
        movem.l d3/d4,-(sp)

        move.b  chn_accs(a0),chn_accd(a0)         ;+ save access key
        move.b  #ioa.kdir,chn_accs(a0)            ;+ ..flag directory
ifw_retry
        sf      fdd_cvsw(a3)            ;+ directory: convert switch off !
        bsr.s   iou_fmul                 ; fetch multiple bytes
        cmp.w   #err.nc,d0               ; is it not complete?
          beq.s ifw_retry                ; ... yes (or no??)

        move.b  chn_accd(a0),chn_accs(a0)         ;+ restore access key
        movem.l (sp)+,d3/d4
        tst.l   d0
        rts
;+++
; Fetch d7 bytes from file d6 starting at byte d5
;
;       d1  u   byte count
;       d3   s  amount to be read
;       d4   s  block / byte buffer position
;       d5 cr   file position
;       d6 c  p drive number / file id
;       d7 cr   amount to buffer / unbuffer
;       a1 cr   buffer address
;       a2   s  internal buffer address
;       a3 c  p linkage block address
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       status return standard
;---
iou_fmul

        move    sr,-(sp)                ;+++
        ori.w   #$0700,sr               ;+++

        cmpi.b  #ioa.kdir,chn_accs(a0)  ;+ directory io ?
          bne.s iofm_next               ;+
        sf      fdd_cvsw(a3)            ;+ ..yes, convert switch off

; loop unbuffering blocks

iofm_next
        jsr     iod_lcbf(a3)             ; locate buffer
          bne.s iofm_rts                 ; ... oops

        cmp.l   d3,d7                    ; all to be read?
          bhs.s iofm_unbf                ; ... yes
        move.l  d7,d3

; unbuffer d3 bytes

iofm_unbf
        move.l  a1,d0                    ; destination address
        or.w    d5,d0                    ; or source address (ish)

        add.l   d3,d1                    ; more read (or will be)
        add.l   d3,d5                    ; new buffer pointer
        sub.l   d3,d7                    ; amount left

        tst.b   fdd_cvsw(a3)            ;+ convert switch
          bne.s iofm_conv               ;+ ..on
iofm_ff
        lsr.w   #1,d0                    ; odd?
          bcs.s iofm_bend                ; ... yes, just copy bytes

        ror.l   #5,d3                    ; copy 8 long words at a time
        bra.s   iofm_lwend

iofm_lword
        move.l  (a2)+,(a1)+              ; copy long word
        move.l  (a2)+,(a1)+              ; copy long word
        move.l  (a2)+,(a1)+              ; copy long word
        move.l  (a2)+,(a1)+              ; copy long word
        move.l  (a2)+,(a1)+              ; copy long word
        move.l  (a2)+,(a1)+              ; copy long word
        move.l  (a2)+,(a1)+              ; copy long word
        move.l  (a2)+,(a1)+              ; copy long word
iofm_lwend
        dbra    d3,iofm_lword

        clr.w   d3
        rol.l   #5,d3                    ; amount remaining
        bra.s   iofm_bend

iofm_byte
        move.b  (a2)+,(a1)+              ; bytes at a time
iofm_bend
        dbra    d3,iofm_byte
iofm_d7d0
        move.l  d7,d0                    ; any more to go?
          bne.s iofm_next                ; ... yes
iofm_rts
        move.b  fdd_conv(a3),fdd_cvsw(a3) ;+ convert switch = value ATR_CONV

        move    (sp)+,sr                ;+++

        tst.l   d0                        ;+
        rts

;+ ATR_CONV fetch multible bytes active
iofm_conv
        move.l  a5,-(sp)                ; save d0/a5
        bsr.s   iosf_table              ; find cv_table
          beq.s iofm_nc                 ; ..not set
        adda.w  #$0100,a5               ; IBM/Atari -> QL
        moveq   #0,d0
        bra.s   iofm_cnd
iofm_cbt
        move.b  (a2)+,d0
        move.b  0(a5,d0.w),(a1)+        ; convert
iofm_cnd
        dbra    d3,iofm_cbt
        moveq   #1,d0                   ; cond. code NZ
iofm_nc
        movea.l (sp)+,a5
          beq.s iofm_ff                 ; cv_table not there !
        bra.s   iofm_d7d0
;+++
; subroutine to find absolut adress of cv_table
;---
iou_tabl
iosf_table
        move.l  d0,-(sp)
        movea.l fdd_cadr(a3),a5         ; convert table ID-flag
        moveq   #0,d0
        move.b  fdd_conv(a3),d0         ; ATR_CONV 1 or 2
        lsl.w   #2,d0                   ; *4 = 4 or 8
        add.w   fdd_iatp(a4),d0         ; + 0 IBM or +2 Atari
        move.w  0(a5,d0.w),d0           ; word offset pointer to cv_table
        adda.w  d0,a5                   ; absout adress cv_table
        movem.l (sp)+,d0
        rts                             ; cond code: Z not set, NZ set
;+++
; Unbuffer up to d7 bytes, stopping at <NL>, from file d6 position d5
;
;       d1  u   byte count
;       d3   s
;       d4   s  block / byte buffer position
;       d5 cr   file position
;       d6 c  p drive number / file id
;       d7 cr   amount to buffer / unbuffer
;       a1 cr   buffer address
;       a2   s  internal buffer address
;       a3 c  p linkage block address
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       status return standard
;---
iou_flin
;-       move     sr,-(sp)                ;+++
;-       ori.w    #$0700,sr               ;+++

        cmpi.b  #ioa.kdir,chn_accs(a0)  ;+ directory io ?
          bne.s iofl_next               ;+
        sf      fdd_cvsw(a3)            ;+ ..yes, convert switch off

; loop unbuffering but checking for 'enter'

iofl_next
        jsr     iod_lcbf(a3)             ; locate buffer
          bne.s iofl_rts                 ; ... oops

        cmp.l   d3,d7                    ; all to be read?
          bhs.s iofl_unbf                ; ... yes
        move.l  d7,d3

; unbuffer up to d3 bytes

iofl_unbf
        move.l  d3,d0                    ; max amount to copy
          beq.s iofl_teof                ; ... none, buffer full

        tst.b   fdd_cvsw(a3)            ;+ convert switch
          bne.s iofl_conv               ;+ ..on
iofl_ff
        tst.l   d0                      ;+ cond code NZ
        bra.s   iofl_bend

iofl_byte
        move.b  (a2)+,(a1)               ; copy byte
        cmp.b   #$0A,(a1)+               ; was it enter?
iofl_bend
          dbeq  d0,iofl_byte             ; next

iofl_cnt
          beq.s iofl_done                ; ... enter found

        add.l   d3,d1                    ; more read
        add.l   d3,d5                    ; update pointer
        sub.l   d3,d7                    ; any more?
          bne.s iofl_next                ; ... yes

iofl_teof
        moveq   #err.bffl,d0             ; buffer full
        cmp.l   d1,d2                    ; all read?
          beq.s iofl_rts
        moveq   #err.eof,d0              ; ... no, must have been end of file
        bra.s   iofl_rts

iofl_done
        sub.w   d0,d3                    ; amount actually read
        add.l   d3,d1
        add.l   d3,d5                    ; update pointer
        moveq   #0,d0                    ; done
iofl_rts
        move.b  fdd_conv(a3),fdd_cvsw(a3) ;+ convert switch = value ATR_CONV
;-        move    (sp)+,sr                ;+++
        tst.l   d0                        ;+
        rts

;+ ATR_CONV fetch multible bytes NL active
iofl_conv
        movem.l d1/a5,-(sp)
        moveq   #0,d1
        bsr     iosf_table              ; find cv_table
          beq.s iofl_nc                 ; ..not set
        adda.w  #$0100,a5               ; IBM -> QL
;-        tst.l   d0                      ; d0 kann nicht = 0 sein !
        bra.s   iofl_cnd
iofl_cbt
        move.b  (a2)+,d1
        move.b  0(a5,d1.w),(a1)+        ; copy byte
        cmpi.b  #$0A,d1                  ; was it enter?
iofl_cnd
          dbeq  d0,iofl_cbt             ; next

        movem.l (sp)+,d1/a5
        bra.s   iofl_cnt
iofl_nc
        movem.l (sp)+,d1/a5
        bra.s   iofl_ff

;+++
; Set directory entry (atomic) d7 bytes starting from the start
; of this file's entry. This entry avoids checking the end of file and
; always locates rather than allocates the appropriate sector. CHN_SDPS and
; CHN_SDID must be valid.
;
;       d1  u   byte count
;       d5    p file position
;       d6 c  p drive number / (file id)
;       d7 cr   amount to buffer / unbuffer
;       a0 c  p pointer to channel block
;       a1 cr   buffer address
;       a2   s  internal buffer address
;       a3 c  p linkage block address
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       status return standard
;---
iou_sde0
        movem.l d3/d4,-(sp)              ; save d3/d4
        moveq   #0,d4
        bsr.s   iou_sden
        movem.l (sp)+,d3/d4
        rts
;+++
; Set directory entry (atomic) d7 bytes starting d4 bytes on from the start
; of this file's entry. This entry avoids checking the end of file and
; always locates rather than allocates the appropriate sector. CHN_SDPS and
; CHN_SDID must be valid.
;
;       d1  u   byte count
;       d3   s
;       d4 c s  byte position (long)
;       d5    p file position
;       d6 c  p drive number / (file id)
;       d7 cr   amount to buffer / unbuffer
;       a0 c  p pointer to channel block
;       a1 cr   buffer address
;       a2   s  internal buffer address
;       a3 c  p linkage block address
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       status return standard
;---
iou_sden
        tst.b   iod_wprt(a4)             ; read only?
          bne.s ibf_rdon                 ; ... yes

        movem.l d5/d6,-(sp)
        move.l  chn_sdps(a0),d5          ; start
        add.l   d4,d5
        move.w  chn_sdid(a0),d6          ; sub-directory

        move.b  chn_accs(a0),chn_accd(a0)         ;+ save access key
        move.b  #ioa.kdir,chn_accs(a0)            ;+ ..flag directory
isd_retry
        sf      fdd_cvsw(a3)            ;+ directory: convert switch off !
        jsr     iod_lcbf(a3)             ; locate buffer
          bne.s isd_check
        move.l  d7,d3
        bsr.s   iosm_unbf                ; send multiple bytes
isd_check
        cmp.w   #err.nc,d0               ; is it not complete?
          beq.s isd_retry                ; ... yes (or no??)

        move.b  chn_accd(a0),chn_accs(a0)         ;+ restore access key
        tst.l   d0
        movem.l (sp)+,d5/d6
        rts

;+++
; Set multiple bytes and wait, d7 bytes to directory starting at byte d5.
; Assumes that directory entries cannot span sector boundries. CHN_FEOF
; must be valid.
;
;       d1  u   byte count
;       d4    p block / byte buffer position
;       d5 cr   file position
;       d6 c  p drive number / directory file ID
;       d7 cr   amount to buffer / unbuffer
;       a0 c  p pointer to channel block
;       a1 cr   buffer address
;       a2   s  internal buffer address
;       a3 c  p linkage block address
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       status return standard
;---
iou_smlw
        movem.l d3/d4,-(sp)

        move.b  chn_accs(a0),chn_accd(a0)         ;+ save access key
        move.b  #ioa.kdir,chn_accs(a0)            ;+ ..flag directory
isw_retry
        sf      fdd_cvsw(a3)            ;+ directory: convert switch off !
        bsr.s   iou_smul                 ; send multiple bytes
        cmp.w   #err.nc,d0               ; is it not complete?
          beq.s isw_retry                ; ... yes (or no??)

        move.b  chn_accd(a0),chn_accs(a0)         ;+ restore access key
        movem.l (sp)+,d3/d4
        tst.l   d0
        rts

ibf_rdon
        moveq   #err.rdo,d0
        rts

;+++
; Send d7 bytes to file d6 starting at byte d5. CHN_FEOF must be valid.
;            
;       d1  u   byte count
;       d3   s
;       d4   s  block / byte buffer position
;       d5 cr   file position
;       d6 c  p drive number / file id
;       d7 cr   amount to buffer / unbuffer
;       a1 cr   buffer address
;       a2   s  internal buffer address
;       a3 c  p linkage block address
;       a4 c  p pointer to physical definition
;       a5 c  p pointer to map
;
;       status return standard
;---
iou_smul
        tst.b   iod_wprt(a4)             ; read only?
          bne.s ibf_rdon

        cmpi.b  #ioa.kdir,chn_accs(a0)  ;+ directory io ?
          bne.s iosm_next               ;+
        sf      fdd_cvsw(a3)            ;+ ..yes, convert switch off

; loop buffering blocks

iosm_next
        jsr     iod_albf(a3)             ; locate / allocate buffer
          bne.s iosm_rts                 ; ... oops

        cmp.l   d3,d7                    ; all to be sent?
          bhs.s iosm_unbf                ; ... yes
        move.l  d7,d3

; buffer d3 bytes

iosm_unbf
        move.l  a1,d0                    ; source
        or.w    d5,d0                    ; or destination

        add.l   d3,d1                    ; more sent (or will be)
        add.w   d3,d4                    ; new buffer pointer
        add.l   d3,d5                    ; new file pointer
        sub.l   d3,d7                    ; amount left

        tst.b   fdd_cvsw(a3)            ;+ convert switch
          bne.s iosm_conv               ;+
iosm_ff
        lsr.w   #1,d0                    ; source or destination odd?
          bcs.s iosm_bend                ; ... yes, just copy bytes

        ror.l   #5,d3                    ; copy 8 long words at a time
        bra.s   iosm_lwend

iosm_lword
        move.l  (a1)+,(a2)+              ; copy long word
        move.l  (a1)+,(a2)+              ; copy long word
        move.l  (a1)+,(a2)+              ; copy long word
        move.l  (a1)+,(a2)+              ; copy long word
        move.l  (a1)+,(a2)+              ; copy long word
        move.l  (a1)+,(a2)+              ; copy long word
        move.l  (a1)+,(a2)+              ; copy long word
        move.l  (a1)+,(a2)+              ; copy long word
iosm_lwend
        dbra    d3,iosm_lword

        clr.w   d3
        rol.l   #5,d3                    ; amount remaining
        bra.s   iosm_bend

iosm_byte
        move.b  (a1)+,(a2)+              ; copy byte
iosm_bend
        dbra    d3,iosm_byte
iosm_d7d0
        jsr     iod_upbf(a3)             ; mark updated buffer
        move.l  d7,d0                    ; any more to go?
          bne.s iosm_next                ; ... yes
iosm_rts
        move.b  fdd_conv(a3),fdd_cvsw(a3) ;+ convert switch = value ATR_CONV
        tst.l   d0                        ;+
        rts

;+ ATR_CONV send multible bytes active
iosm_conv
        move.l  a5,-(sp)
        bsr     iosf_table              ; find cv_table
          beq.s iosm_nc                 ; ..not set
        moveq   #0,d0
        bra.s   iosm_cnd
iosm_cbt
        move.b  (a1)+,d0
        cmpi.b  #$0A,d0                 ; LF ?
          bne.s iosm_rcl                ; ..nein, merken und bersetzen
        cmpi.b  #$0D,fdd_byte(a3)       ; voriges byte ein CR ?
          beq.s iosm_rcl                ; ..ja, einfgen unntig, aber merken
        cmpi.b  #' ',fdd_byte(a3)       ; ' ' noch da ?
          bne.s iosm_ins                ; ..nein, leider nicht, CR einfgen
        move.b  #$0D,-1(a2)             ; ..ja, ' ' vor LF in CR umwandeln
        bra.s   iosm_rcl                ; ..und LF merken
iosm_ins
        subq.l  #1,a1                   ; Lesezeiger zurckstellen auf LF
        addq.l  #1,d7                   ; File ein byte lnger (!)
        move.b  #$0D,d0                 ; ..und erst CR schicken
iosm_rcl
        move.b  d0,fdd_byte(a3)         ; byte merken
        move.b  0(a5,d0.w),(a2)+
iosm_cnd
        dbra     d3,iosm_cbt
        moveq   #1,d0                   ; cond code NZ
iosm_nc
        movea.l (sp)+,a5
          beq.s iosm_ff
        bra.s   iosm_d7d0

        end
