; FLP/ATR Find name in directory   V2.03  1987  Tony Tebby  QJUMP / 30.12.91 Jo
; FLP/ATR compatible
; IBM . or .. -file -> err.fdiu, IBM . or ..-subdir -> flag #30,d4.l
; setzt IBM Pfadlnge fdd_path(a4)

        section iou

        xdef    iou_fnam

        xref    iou_fmlw
        xref    iou_cknm
        xref    iou_ckdn

        include 'keys_iod'
        include 'keys_err'
        include 'keys_chn'
        include 'keys_hdr'
        include 'keys_qdos_ioa'
        include 'dd_fq_ddlk'
;+++
; ATR Find name in directory.
;
;       d1   s
;       d2   s
;       d3 cr   zero or directory pointer for sub-directory
;       d4 cr   zero or directory ID for sub-directory (msb set if genuine dir)
;       d5  r   directory pointer for name or empty entry
;       d6 cr   drive / sub-directory file ID
;       d7   s  byte count
;       a0 c  p base of channel block  
;       a1   s  pointer to name
;       a2   s  buffer pointer
;       a3 c  p linkage block pointer
;       a4 c  p physical definition pointer
;
;       status return standard
;---
iou_fnam
reglist  reg     d3/d4/d5/a0/a4
regchan  reg     a0/a4
stk_dpt  equ     $00    ; d3
stk_did  equ     $04    ; d4
stk_sdpt equ     $08    ; d5
stk_chan equ     $0c    ; a0
stk_pdef equ     $10    ; a4

        moveq   #0,d5                    ; preset zero pointer (will become neg)
        movem.l reglist,-(sp)            ; save regs
        move.l  iod_hdrl(a4),d5          ; start from here!
        move.l  iod_rdfs(a4),chn_csb(a0) ; set first guess at slave block  
        jsr     iod_lcbf(a3)             ; locate first one
        move.l  chn_csb(a0),iod_rdfs(a4) ; and keep it

ifn_floop
        cmp.l   chn_feof(a0),d5          ; at end of file?
          bhs.l ifn_fdnf                 ; ... yes, not found

        lea     chn_opwk(a0),a1          ; spare space for directory entry
        moveq   #hdr.len,d7              ; length to read
        jsr     iou_fmlw(pc)             ; read directory entry
          bne.l ifn_exit                 ; ... not there

        tst.l   hdr_flen+chn_opwk(a0)           ;+ VOL-ID Kennung?
          bmi.s ifn_floop                       ;+ ..ja, fr QDOS tabu

        tst.w   hdr_name+chn_opwk(a0)    ; vacant?
          beq   ifn_empty                ; ... yes
        lea     hdr_name+chn_opwk(a0),a4 ; point to name
        move.b  hdr_type+chn_opwk(a0),d0 ; directory type?
        addq.b  #1,d0
          bne.s ifn_cknm                 ; ... no
; rootdir or subdir
        jsr     iou_ckdn                 ; check directory name
        movem.l stk_chan(sp),regchan     ; restore a0/a4
          bne.s ifn_floop                ; ... no
        moveq   #-hdr.len,d3
        add.l   d5,d3                    ; sub-directory dir position
        move.l  d3,stk_dpt(sp)
        move.l  d6,stk_did(sp)
        move.w  hdr_flid+chn_opwk(a0),d6 ; sub-directory file ID
        move.w  d6,chn_flid(a0)          ; new file ID 
        clr.l   stk_sdpt(sp)             ; no empty entry yet
        moveq   #-hdr.len,d0
        add.l   hdr_flen+chn_opwk(a0),d0
        move.l  iod_hdrl(a4),d5
        add.l   d5,d0
        move.l  d0,chn_feof(a0)          ; new EOF
        move.w  chn_name(a0),d0
        cmp.w   hdr_name+chn_opwk(a0),d0 ; was it actually directory?
          beq.s ifn_sdir                 ; ... yes
        subq.w  #1,d0                    ; could it have a trailing underscore?
        cmp.w   hdr_name+chn_opwk(a0),d0
          bne   ifn_floop                ; ... no
        cmp.b   #'_',chn_name+2(a0,d0.w)
          bne   ifn_floop                ; ... no
        move.w  d0,chn_name(a0)          ; ... yes, reset length
ifn_sdir
        tas     stk_did(sp)              ; directory, flag it

        tst.l   iod_hdrl(a4)                      ;+ ATRdev only !
          bne.s ifn_found                         ;+ ..not ATRdev
        cmpi.b  #'.',hdr_name+1+chn_opwk(a0,d0.w) ;+ IBM . or ..-file ?
          bne.s ifn_sfound                        ;+ ..no
        bset    #6,stk_did(sp)                    ;+ ..yes, flag it
        bra.s   ifn_found                         ;+
ifn_sfound                                        ;+
        cmpi.w  #1,d6                             ;+ root dir ?
          bne.s ifn_sset                          ;+ ..no
        moveq   #0,d0                             ;+ pathlength = 0
ifn_sset                                          ;+
        move.w  d0,fdd_path(a4)                   ;+ pathlength subdir
        bra.s   ifn_found                         ;+

; normal file
ifn_cknm
        jsr     iou_cknm                 ; characters match?
        movem.l stk_chan(sp),regchan     ; restore a0/a4
          bne.l ifn_floop                ; ... no, it is not the same
ifn_found
        moveq   #0,d0                    ; ... yes, ok
        move.l  d5,stk_sdpt(sp)          ; set d5 pointer return
        bra.s   ifn_exit

ifn_empty
        tst.l   stk_sdpt(sp)             ; have we already found an empty entry?
          bne.l ifn_floop                ; ... yes
        move.l  d5,stk_sdpt(sp)          ; ... no, save the pointer to this one
        bra.l   ifn_floop

; name not found
ifn_fdnf
        tst.l   iod_hdrl(a4)                    ;+ ATRdev only
          bne.s ifn_notf                        ;+

        lea     chn_name(a0),a1                 ;+
        move.w  (a1)+,d0                        ;+
        bra.s   ifn_2loop                       ;+
ifn_1loop                                       ;+
        cmpi.b  #'_',(a1)+                      ;+
          bne.s ifn_2loop                       ;+
        cmpi.b  #'.',(a1)                       ;+
          bne.s ifn_2loop                       ;+
        moveq   #err.fdiu,d0                    ;+
        bra.s   ifn_exit                        ;+
ifn_2loop                                       ;+
        dbf     d0,ifn_1loop                    ;+

        cmpi.w  #1,d6                           ;+ rootdir ?
          bgt.s ifn_notf                        ;+ ..no
        clr.w   fdd_path(a4)                    ;+ ..yes, pathlength 0

ifn_notf
        move.l  #err.fdnf,d0             ; d0.l > 0 !!!
ifn_exit
        movem.l (sp)+,reglist            ; restore regs
        moveq   #hdr.len,d1
        sub.l   d1,d5                    ; backspace pointer to start of entry
        tst.l   d0                       ; set error
        rts

    end
